! ************************************************************* 
!
!   This is a software package CIAO
!
!     developed as a part of the national project "Research and 
!     Development of Innovative Simulation software",which is   
!     supported by the next-generation IT program of MEXT of Japan
!
!   latest version: 
!
!     4.0:  2013/01/17 
!           codes for spin-polarized pseudopotential generation are added
!
! ************************************************************* 
!
!  Software name : CIAO (Code for Investigating Atomic Orbitals)
!  Subroutine(s) : calc_rho_sol, calc_rho_ss, calc_drho_ddrho_core_sol
!                : calc_drho_ddrho_pcore_sol, calc_drho_ddrho_sol
!                : calc_drho_ddrho_ss, calc_drho_core_sol
!                : calc_drho_pcore_sol, calc_drho_sol, calc_drho_ss
!  Author(s)     : Masakuni Okamoto (August 25, 2003)
!
!  The license of the code and contact address :
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)
!
!=====================================================================
   subroutine calc_rho_sol(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ir, ishell, ips, ll, nref, t1, t2, lt1, lt2, ltlt, icore
   real(8) :: sum, pi4
   ier = 0
   pi4 = 4.d0 * PI

! ====================================== modified by K. T. =============== 4.0
!   rho_sol(:) = 0.d0
   rho_sol(:,:) = 0.d0
! ========================================================================= 4.0

   do ips = 1,nps
      ishell = ishell_ps(ips,1)
      ll = l_qnum(ishell)
      nref = nref_us(ll)
      if (is_solve(ishell) == 0) then
         cycle
      end if
      do ir = 1,nmesh

! ========================================= modified by K. T. ============== 4.0
!         rho_sol(ir) = rho_sol(ir) &
!            + focc(ishell) * rphi_sol(ir,ips)**2
         rho_sol(ir,1) = rho_sol(ir,1) &
            + focc(ishell) * rphi_sol(ir,ips)**2
! ========================================================================== 4.0

         do t1 = 1,nref
         do t2 = 1,nref
            lt1 = lt_n_us(ll,t1)
            lt2 = lt_n_us(ll,t2)
            ltlt = ltlt_nm_us(ll,t1,ll,t2)
            if (ltlt /= 0) then
! ========================================= modified by K. T. =========== 4.0
!               rho_sol(ir) = rho_sol(ir) &
!                  + focc(ishell) &
!                     * qps_us(ir,ltlt,0) * rpos(ir)**2 &
!                     * beta_phi_sol(lt1,ips) &
!                     * beta_phi_sol(lt2,ips)
               rho_sol(ir,1) = rho_sol(ir,1) &
                  + focc(ishell) &
                     * qps_us(ir,ltlt,0) * rpos(ir)**2 &
                     * beta_phi_sol(lt1,ips) &
                     * beta_phi_sol(lt2,ips)
! ======================================================================= 4.0
            end if
         end do
         end do
      end do
   end do
   do ir = 1,nmesh
! ================================================ modified by K. T. ====== 4.0
!      rho_sol(ir) = rho_sol(ir) / (pi4*rpos(ir)**2)
      rho_sol(ir,1) = rho_sol(ir,1) / (pi4*rpos(ir)**2)
! ========================================================================= 4.0
   end do
   if (num_core_hole > 0) then
      felec_sol  = felec_sol  + ftot_core_hole
      felec_core = felec_core - ftot_core_hole
      felec_val  = felec_sol
      do icore = 1,num_core_hole
         ishell = ishell_core_hole(icore)
         do ir = 1,nmesh
! ================================================ modified by K. T. ========== 4.0
!            rho_sol(ir) = rho_sol(ir) &
!               + focc_core_hole(icore) &
!                  * (chi_g(ir,ishell)/rpos(ir))**2 / pi4
            rho_sol(ir,1) = rho_sol(ir,1) &
               + focc_core_hole(icore) &
                  * (chi_g(ir,ishell)/rpos(ir))**2 / pi4
! ============================================================================= 4.0
         end do
      end do
   end if
   sum = 0.d0
   do ir = 1,nmesh
! ============================================= modified by K. T. ============ 4.0
!      sum = sum + pi4*rpos(ir)**2*wr(ir) * rho_sol(ir)
      sum = sum + pi4*rpos(ir)**2*wr(ir) * rho_sol(ir,1)
! ============================================================================= 4.0
   end do
   if (abs(sum-felec_sol) > 1.d-5) then
      write(IFLOG,*) '### ERROR ### sum of rho_sol != felec_sol'
      write(IFLOG,*) '   sum of rho_sol ...', sum
      write(IFLOG,*) '   felec_sol      ...', felec_sol
      ier = 1 ; go to 99
   end if

! ===================================== modified by K. T. ============== 4.0
!   rho_sol(:) = rho_sol(:) * felec_sol/sum
!   do ir = 1,nmesh
!      if (abs(rho_sol(ir)) < 1.d-99) then
!         rho_sol(ir) = 0.d0
!      end if
!   end do

   rho_sol(:,1) = rho_sol(:,1) * felec_sol/sum
   do ir = 1,nmesh
      if (abs(rho_sol(ir,1)) < 1.d-99) then
         rho_sol(ir,1) = 0.d0
      end if
   end do
! ==================================================================== 4.0

99 continue
   end subroutine calc_rho_sol

! ===================================== added by K. T. ================= 4.0
subroutine calc_rho_sol_kt(ier)
  use parameters
  implicit none

  integer,intent(out) :: ier
  integer :: ir, ishell, ips, ll, nref, t1, t2, lt1, lt2, ltlt, icore
  real(8) :: sum, pi4

  integer :: ispin, itmp1, itmp2

  ier = 0
  pi4 = 4.d0 * PI

  rho_sol(:,:) = 0.d0

  do ips = 1,nps
     ishell = ishell_ps(ips,1)
     ll = l_qnum(ishell)

     nref = nref_us(ll)

     ispin = ( 1-spin(ishell) ) /2 +1

     if (is_solve(ishell) == 0) then
        cycle
     end if
     
     do ir = 1,nmesh
        
        rho_sol(ir,ispin) = rho_sol(ir,ispin) &
             + focc(ishell) * rphi_sol(ir,ips)**2
        
        do t1 = 1,nref
           do t2 = 1,nref
              itmp1 = t1 + nref_max_us *(ispin -1)
              itmp2 = t2 + nref_max_us *(ispin -1)
              
              lt1 = lt_n_us(ll,itmp1)
              lt2 = lt_n_us(ll,itmp2)
              
              ltlt = ltlt_nm_us(ll,itmp1,ll,itmp2)
              
              if (ltlt /= 0) then
                 rho_sol(ir,ispin) = rho_sol(ir,ispin) &
                      + focc(ishell) &
                      * qps_us(ir,ltlt,0) * rpos(ir)**2 &
                      * beta_phi_sol(lt1,ips) &
                      * beta_phi_sol(lt2,ips)
              end if
           end do
        end do
     end do
  end do

  do ir = 1,nmesh
     rho_sol(ir,:) = rho_sol(ir,:) / (pi4*rpos(ir)**2)
  end do

  if (num_core_hole > 0) then          

     stop "Not supported"

     felec_sol  = felec_sol  + ftot_core_hole
     felec_core = felec_core - ftot_core_hole
     felec_val  = felec_sol

     do icore = 1,num_core_hole
        ishell = ishell_core_hole(icore)
        do ir = 1,nmesh
           rho_sol(ir,:) = rho_sol(ir,:) &
                + focc_core_hole(icore) &
                * (chi_g(ir,ishell)/rpos(ir))**2 / pi4
        end do
     end do
  end if

  sum = 0.d0
  Do ispin=1, nspin
     do ir = 1,nmesh
        sum = sum + pi4*rpos(ir)**2*wr(ir) * rho_sol(ir,ispin)
     end do
  End do

  if (abs(sum-felec_sol) > 1.d-5) then
     write(IFLOG,*) '### ERROR ### sum of rho_sol != felec_sol'
     write(IFLOG,*) '   sum of rho_sol ...', sum
     write(IFLOG,*) '   felec_sol      ...', felec_sol
     ier = 1 ; go to 99
  end if

  rho_sol(:,:) = rho_sol(:,:) * felec_sol/sum

  Do ispin=1, nspin
     do ir = 1,nmesh
        if (abs(rho_sol(ir,ispin)) < 1.d-99) then
           rho_sol(ir,ispin) = 0.d0
        end if
     end do
  end do

99 continue

end subroutine calc_rho_sol_kt
! ======================================================================= 4.0

!=====================================================================
   subroutine check_negative_rho_sol(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ir, is_negative
   real(8) :: rho_tmp, sum, pi4
   ier = 0
   pi4 = 4.d0 * PI
   is_negative = 0
   do ir = 1,nmesh
      select case (is_pcc)
! =========================================== modified by K. T. ============== 4.0
!      case (NONE)
!         rho_tmp = rho_sol(ir)
!      case (PCC)
!         rho_tmp = rho_sol(ir) + rho_pcore(ir)
!      case (FCC)
!         rho_tmp = rho_sol(ir) + rho_core(ir)
!      end select
!
      case (NONE)
         rho_tmp = rho_sol(ir,1)
      case (PCC)
         rho_tmp = rho_sol(ir,1) + rho_pcore(ir)
      case (FCC)
         rho_tmp = rho_sol(ir,1) + rho_core(ir)
      end select
! ============================================================================ 4.0

      if (rho_tmp < 0.d0) then
         is_negative = 1

! ========================================= modified by K. T. ============= 4.0
!         write(IFLOG,'(i10,3(1pd20.10))') ir,rpos(ir),rho_sol(ir),rho_tmp
!         rho_sol(ir) = 1.d-20
         write(IFLOG,'(i10,3(1pd20.10))') ir,rpos(ir),rho_sol(ir,1),rho_tmp
         rho_sol(ir,1) = 1.d-20
! =========================================================================== 4.0
      end if

   end do
   sum = 0.d0
   do ir = 1,nmesh
! ============================================== modified by K. T. ========== 4.0
!      sum = sum + pi4*rpos(ir)**2*wr(ir) * rho_sol(ir)
      sum = sum + pi4*rpos(ir)**2*wr(ir) * rho_sol(ir,1)
! ============================================================================= 4.0
   end do
   if (is_negative /= 0) then
      write(IFLOG,*) '### CAUTION ### rho_sol < 0 for some ir.'
      write(IFLOG,*) 'ir, rpos, rho_sol'
      do ir = 1,nmesh,10
! ================================================ modified by K. T. ========== 4.0
!         write(IFLOG,'(i10,2(1pd20.10))') ir,rpos(ir),rho_sol(ir)
         write(IFLOG,'(i10,2(1pd20.10))') ir,rpos(ir),rho_sol(ir,1)
!============================================================================== 4.0
      end do
      write(IFLOG,*) 'sum of rho_sol ...',sum
      write(IFLOG,*) 'felec_sol      ...',felec_sol

! ================================================ modified by K. T. ============ 4.0
!      rho_sol(:) = rho_sol(:) * felec_sol/sum
      rho_sol(:,1) = rho_sol(:,1) * felec_sol/sum
! =============================================================================== 4.0

      write(IFSUM,*)
      write(IFSUM,*) '##########################################'
      write(IFSUM,*) '##  [SOL] Negative charge was detected  ##'
      write(IFSUM,*) '##########################################'
      ier = 0 ; go to 99
   end if

   if (abs(sum-felec_sol) > 1.d-5) then
      write(IFLOG,*) '### ERROR ### sum of rho_sol != felec_sol'
      write(IFLOG,*) '   sum of rho_sol ...', sum
      write(IFLOG,*) '   felec_sol      ...', felec_sol
      ier = 1 ; go to 99
   end if

! ===================================== modified by K. T. ============ 4.0
!   rho_sol(:) = rho_sol(:) * felec_sol/sum
!   do ir = 1,nmesh
!      if (abs(rho_sol(ir)) < 1.d-99) then
!         rho_sol(ir) = 0.d0
!      end if
!   end do
!
   rho_sol(:,1) = rho_sol(:,1) * felec_sol/sum
   do ir = 1,nmesh
      if (abs(rho_sol(ir,1)) < 1.d-99) then
         rho_sol(ir,1) = 0.d0
      end if
   end do
! ========================================================================= 4.0

99 continue
   end subroutine check_negative_rho_sol

!====================== added by K. T. ========================= 4.0
subroutine check_negative_rho_sol_kt(ier)
  use parameters
  implicit none

  integer,intent(out) :: ier
  integer :: ir, is_negative
  real(8) :: rho_tmp, sum, pi4

  integer :: ispin

  ier = 0
  pi4 = 4.d0 * PI
  is_negative = 0

  Do ispin=1, nspin

     do ir = 1,nmesh
        select case (is_pcc)
        case (NONE)
           rho_tmp = rho_sol(ir,ispin)
        case (PCC)
           rho_tmp = rho_sol(ir,ispin) + rho_pcore(ir)
        case (FCC)
           rho_tmp = rho_sol(ir,ispin) + rho_core(ir)
        end select

        if (rho_tmp < 0.d0) then
           is_negative = 1
           write(IFLOG,'(i10,i3,3(1pd20.10))') ir, ispin, rpos(ir), &
                &                              rho_sol(ir,ispin), rho_tmp
           rho_sol(ir,ispin) = 1.d-20
        end if

     end do
     
  End do

  sum = 0.d0

  Do ispin=1, nspin
     do ir = 1,nmesh
        sum = sum + pi4*rpos(ir)**2*wr(ir) * rho_sol(ir,ispin)
     end do
  End do

  if (is_negative /= 0) then
     write(IFLOG,*) '### CAUTION ### rho_sol < 0 for some ir.'
     write(IFLOG,*) 'ir, rpos, rho_sol'

     Do ispin=1, nspin
        write(IFLOG,*) 'ispin = ', ispin
        do ir = 1,nmesh,10
           write(IFLOG,'(i10,2(1pd20.10))') ir,rpos(ir),rho_sol(ir,ispin)
        end do
     End do

     write(IFLOG,*) 'sum of rho_sol ...',sum
     write(IFLOG,*) 'felec_sol      ...',felec_sol


     rho_sol(:,:) = rho_sol(:,:) * felec_sol/sum

     write(IFSUM,*)
     write(IFSUM,*) '##########################################'
     write(IFSUM,*) '##  [SOL] Negative charge was detected  ##'
     write(IFSUM,*) '##########################################'
     ier = 0 ; go to 99
  end if

  if (abs(sum-felec_sol) > 1.d-5) then
     write(IFLOG,*) '### ERROR ### sum of rho_sol != felec_sol'
     write(IFLOG,*) '   sum of rho_sol ...', sum
     write(IFLOG,*) '   felec_sol      ...', felec_sol
     ier = 1 ; go to 99
  end if

  rho_sol(:,:) = rho_sol(:,:) * felec_sol/sum

  Do ispin=1, nspin
     do ir = 1,nmesh
        if (abs(rho_sol(ir,ispin)) < 1.d-99) then
           rho_sol(ir,ispin) = 0.d0
        end if
     end do
  End do
! ========================================================================= 4.0

99 continue

end subroutine check_negative_rho_sol_kt
! ============================================================================= 4.0   

!=====================================================================
   subroutine calc_rho_ss(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ir, ishell, ll, nref, t1, t2, lt1, lt2, ltlt, iss, &
              ispin, is_negative
   real(8) :: sum, sum1, sum2, pi4, rho_tmp
   ier = 0
   is_negative = 0
   pi4 = 4.d0 * PI
   rho_ss(:,:) = 0.d0
   do iss = 1,nss
      ispin = 2-(spin_ss(iss)+1)/2
      ishell = ishell_ss(iss)
      ll = l_qnum(ishell)
      nref = nref_us(ll)
      if (is_solve_ss(iss) == 0) then
         cycle
      end if
      do ir = 1,nmesh
         rho_ss(ir,ispin) = rho_ss(ir,ispin) &
            + focc_ss(iss) * rphi_ss(ir,iss)**2
         do t1 = 1,nref
         do t2 = 1,nref
            lt1 = lt_n_us(ll,t1)
            lt2 = lt_n_us(ll,t2)
            ltlt = ltlt_nm_us(ll,t1,ll,t2)
            if (ltlt /= 0) then
               rho_ss(ir,ispin) = rho_ss(ir,ispin) &
                  + focc_ss(iss) &
                     * qps_us(ir,ltlt,0) * rpos(ir)**2 &
                     * beta_phi_ss(lt1,iss) &
                     * beta_phi_ss(lt2,iss)
            end if
         end do
         end do
         select case (is_spin_ss)
         case (RESTRICTED)
            select case (is_pcc)
            case (NONE)
               rho_tmp = rho_ss(ir,ispin)
            case (PCC)
               rho_tmp = rho_ss(ir,ispin) + rho_pcore(ir)
            case (FCC)
               rho_tmp = rho_ss(ir,ispin) + rho_core(ir)
            end select
         case (POLARIZED)
            select case (is_pcc)
            case (NONE)
               rho_tmp = rho_ss(ir,ispin)
            case (PCC)
               rho_tmp = rho_ss(ir,ispin) + rho_pcore(ir)*0.5d0
            case (FCC)
               rho_tmp = rho_ss(ir,ispin) + rho_core(ir)*0.5d0
            end select
         end select
         if (rho_tmp < 0.d0) then
            is_negative = 1
            write(IFLOG,'(2i10,3(1pd20.10))') ir,ispin,rpos(ir),rho_ss(ir,ispin),rho_tmp
         end if
      end do
   end do
   do ispin = 1,nspin_ss
   do ir = 1,nmesh
      rho_ss(ir,ispin) = rho_ss(ir,ispin) / (pi4*rpos(ir)**2)
      if (abs(rho_ss(ir,ispin)) < 1.d-99) then
         rho_ss(ir,ispin) = 0.d0
      end if
   end do
   end do
   select case (is_spin_ss)
   case (RESTRICTED)
      sum1 = 0.d0
      do ir = 1,nmesh
         sum1 = sum1 + pi4*rpos(ir)**2*wr(ir) * rho_ss(ir,1)
      end do
      sum2 = 0.d0
      if (is_negative /= 0) then
         write(IFLOG,*) '### ERROR ### rho_ss < 0 for some ir.'
         write(IFLOG,*) 'ir, rpos, rho_ss'
         do ir = 1,nmesh,10
            write(IFLOG,'(i10,2(1pd20.10))') ir,rpos(ir),rho_ss(ir,1)
         end do
         write(IFLOG,*) 'sum of rho_ss ...',sum1
         write(IFLOG,*) 'felec_ss      ...',felec_ss
         rho_ss(:,1) = rho_ss(:,1) * felec_ss/sum1
         write(IFSUM,*)
         write(IFSUM,*) '#########################################'
         write(IFSUM,*) '##  [SS] Negative charge was detected  ##'
         write(IFSUM,*) '#########################################'
         ier = 0 ; go to 99
      end if
      if (abs(sum1-felec_ss) > 1.d-5) then
         write(IFLOG,*) '### ERROR ### sum of rho_ss != felec_ss'
         write(IFLOG,*) '   sum of rho_ss ...', sum1
         write(IFLOG,*) '   felec_ss      ...', felec_ss
         ier = 1 ; go to 99
      end if
   case (POLARIZED)
      sum1 = 0.d0
      do ir = 1,nmesh
         sum1 = sum1 + pi4*rpos(ir)**2*wr(ir) * rho_ss(ir,1)
      end do
      sum2 = 0.d0
      do ir = 1,nmesh
         sum2 = sum2 + pi4*rpos(ir)**2*wr(ir) * rho_ss(ir,2)
      end do
      if (is_negative /= 0) then
         write(IFLOG,*) '### ERROR ### rho_ss < 0 for some ir.'
         write(IFLOG,*) 'ir, rpos, rho_ss(1), rho_ss(2)'
         do ir = 1,nmesh,10
            write(IFLOG,'(i10,3(1pd20.10))') ir,rpos(ir), &
                                   rho_ss(ir,1),rho_ss(ir,1)
         end do
         write(IFLOG,*) 'sum of rho_ss(1) ...',sum1
         write(IFLOG,*) 'felec1_ss        ...',felec1_ss
         write(IFLOG,*) 'sum of rho_ss(2) ...',sum2
         write(IFLOG,*) 'felec2_ss        ...',felec2_ss
         rho_ss(:,1) = rho_ss(:,1) * felec1_ss/sum1
         rho_ss(:,2) = rho_ss(:,2) * felec2_ss/sum2
         write(IFSUM,*)
         write(IFSUM,*) '#########################################'
         write(IFSUM,*) '##  [SS] Negative charge was detected  ##'
         write(IFSUM,*) '#########################################'
         ier = 0 ; go to 99
      end if
      if (abs(sum1-felec1_ss) > 1.d-5) then
         write(IFLOG,*) '### ERROR ### sum of rho_ss(1) != felec1_ss'
         write(IFLOG,*) '   sum of rho_ss(1) ...', sum1
         write(IFLOG,*) '   felec1_ss        ...', felec1_ss
         ier = 1 ; go to 99
      end if
      if (abs(sum2-felec2_ss) > 1.d-5) then
         write(IFLOG,*) '### ERROR ### sum of rho_ss(2) != felec2_ss'
         write(IFLOG,*) '   sum of rho_ss(2) ...', sum2
         write(IFLOG,*) '   felec2_ss        ...', felec2_ss
         ier = 2 ; go to 99
      end if
   end select
   sum = sum1 + sum2
   write(IFLOG,'(1x,a25,3f15.10)') &
        '??? charge (f1,f2,rho)...',sum1,sum2,sum
   select case (is_spin_ss)
   case (RESTRICTED)
      rho_ss(:,1) = rho_ss(:,1) * felec_ss/sum1
   case (POLARIZED)
      if (sum1 == 0.d0) then
         rho_ss(:,1) = 0.d0
      else
         rho_ss(:,1) = rho_ss(:,1) * felec1_ss/sum1
      end if
      if (sum2 == 0.d0) then
         rho_ss(:,2) = 0.d0
      else
         rho_ss(:,2) = rho_ss(:,2) * felec2_ss/sum2
      end if
   end select
99 continue
   end subroutine calc_rho_ss

!============================================== added by K. T. =========== 4.0
subroutine calc_rho_ss_kt(ier)
  use parameters
  implicit none

  integer,intent(out) :: ier
  integer :: ir, ishell, ll, nref, t1, t2, lt1, lt2, ltlt, iss, &
              ispin, is_negative
  real(8) :: sum, sum1, sum2, pi4, rho_tmp

  integer :: itmp1, itmp2

  ier = 0
  is_negative = 0

  pi4 = 4.d0 * PI
  rho_ss(:,:) = 0.d0

  do iss = 1,nss

     ispin = 2-(spin_ss(iss)+1)/2
     ishell = ishell_ss(iss)

     ll = l_qnum(ishell)
     nref = nref_us(ll)

     if (is_solve_ss(iss) == 0) then
        cycle
     end if

     do ir = 1,nmesh
        rho_ss(ir,ispin) = rho_ss(ir,ispin) &
             + focc_ss(iss) * rphi_ss(ir,iss)**2

        do t1 = 1,nref
           do t2 = 1,nref

              itmp1 = t1 + nref_max_us * (ispin -1)
              itmp2 = t2 + nref_max_us * (ispin -1)

              if ( nspin == 1 ) then
                 itmp1 = t1;  itmp2 = t2
              endif

              lt1 = lt_n_us(ll,itmp1)
              lt2 = lt_n_us(ll,itmp2)

              ltlt = ltlt_nm_us(ll,itmp1,ll,itmp2)

              if (ltlt /= 0) then
                 rho_ss(ir,ispin) = rho_ss(ir,ispin) &
                      + focc_ss(iss) &
                      * qps_us(ir,ltlt,0) * rpos(ir)**2 &
                      * beta_phi_ss(lt1,iss) &
                      * beta_phi_ss(lt2,iss)
              end if

           end do
        end do

        select case (is_spin_ss)
        case (RESTRICTED)
           select case (is_pcc)
           case (NONE)
              rho_tmp = rho_ss(ir,ispin)
           case (PCC)
              rho_tmp = rho_ss(ir,ispin) + rho_pcore(ir)
           case (FCC)
              rho_tmp = rho_ss(ir,ispin) + rho_core(ir)
           end select
        case (POLARIZED)
           select case (is_pcc)
           case (NONE)
              rho_tmp = rho_ss(ir,ispin)
           case (PCC)
              rho_tmp = rho_ss(ir,ispin) + rho_pcore(ir)*0.5d0
           case (FCC)
              rho_tmp = rho_ss(ir,ispin) + rho_core(ir)*0.5d0
           end select
        end select

        if (rho_tmp < 0.d0) then
           is_negative = 1
           write(IFLOG,'(2i10,3(1pd20.10))') ir,ispin,rpos(ir),rho_ss(ir,ispin),rho_tmp
        end if
     end do

  end do

  do ispin = 1,nspin_ss
     do ir = 1,nmesh
        rho_ss(ir,ispin) = rho_ss(ir,ispin) / (pi4*rpos(ir)**2)
        if (abs(rho_ss(ir,ispin)) < 1.d-99) then
           rho_ss(ir,ispin) = 0.d0
        end if
     end do
  end do

  select case (is_spin_ss)

  case (RESTRICTED)
     sum1 = 0.d0
     do ir = 1,nmesh
        sum1 = sum1 + pi4*rpos(ir)**2*wr(ir) * rho_ss(ir,1)
     end do

     sum2 = 0.d0

     if (is_negative /= 0) then
        write(IFLOG,*) '### ERROR ### rho_ss < 0 for some ir.'
        write(IFLOG,*) 'ir, rpos, rho_ss'
        do ir = 1,nmesh,10
           write(IFLOG,'(i10,2(1pd20.10))') ir,rpos(ir),rho_ss(ir,1)
        end do
        write(IFLOG,*) 'sum of rho_ss ...',sum1
        write(IFLOG,*) 'felec_ss      ...',felec_ss

        rho_ss(:,1) = rho_ss(:,1) * felec_ss/sum1

        write(IFSUM,*)
        write(IFSUM,*) '#########################################'
        write(IFSUM,*) '##  [SS] Negative charge was detected  ##'
        write(IFSUM,*) '#########################################'
        ier = 0 ; go to 99
     end if

     if (abs(sum1-felec_ss) > 1.d-5) then
        write(IFLOG,*) '### ERROR ### sum of rho_ss != felec_ss'
        write(IFLOG,*) '   sum of rho_ss ...', sum1
        write(IFLOG,*) '   felec_ss      ...', felec_ss
        ier = 1 ; go to 99
     end if

  case (POLARIZED)
     sum1 = 0.d0
     do ir = 1,nmesh
        sum1 = sum1 + pi4*rpos(ir)**2*wr(ir) * rho_ss(ir,1)
     end do

     sum2 = 0.d0
     do ir = 1,nmesh
        sum2 = sum2 + pi4*rpos(ir)**2*wr(ir) * rho_ss(ir,2)
     end do

     if (is_negative /= 0) then
        write(IFLOG,*) '### ERROR ### rho_ss < 0 for some ir.'
        write(IFLOG,*) 'ir, rpos, rho_ss(1), rho_ss(2)'
        do ir = 1,nmesh,10
           write(IFLOG,'(i10,3(1pd20.10))') ir,rpos(ir), &
                rho_ss(ir,1),rho_ss(ir,1)
        end do
        write(IFLOG,*) 'sum of rho_ss(1) ...',sum1
        write(IFLOG,*) 'felec1_ss        ...',felec1_ss
        write(IFLOG,*) 'sum of rho_ss(2) ...',sum2
        write(IFLOG,*) 'felec2_ss        ...',felec2_ss

        rho_ss(:,1) = rho_ss(:,1) * felec1_ss/sum1
        rho_ss(:,2) = rho_ss(:,2) * felec2_ss/sum2

        write(IFSUM,*)
        write(IFSUM,*) '#########################################'
        write(IFSUM,*) '##  [SS] Negative charge was detected  ##'
        write(IFSUM,*) '#########################################'
        ier = 0 ; go to 99

     end if

     if (abs(sum1-felec1_ss) > 1.d-5) then
        write(IFLOG,*) '### ERROR ### sum of rho_ss(1) != felec1_ss'
        write(IFLOG,*) '   sum of rho_ss(1) ...', sum1
        write(IFLOG,*) '   felec1_ss        ...', felec1_ss
        ier = 1 ; go to 99
     end if

     if (abs(sum2-felec2_ss) > 1.d-5) then
        write(IFLOG,*) '### ERROR ### sum of rho_ss(2) != felec2_ss'
        write(IFLOG,*) '   sum of rho_ss(2) ...', sum2
        write(IFLOG,*) '   felec2_ss        ...', felec2_ss
        ier = 2 ; go to 99
     end if

  end select

  sum = sum1 + sum2
  write(IFLOG,'(1x,a25,3f15.10)') &
       '??? charge (f1,f2,rho)...',sum1,sum2,sum


  select case (is_spin_ss)

  case (RESTRICTED)
     rho_ss(:,1) = rho_ss(:,1) * felec_ss/sum1

  case (POLARIZED)
     if (sum1 == 0.d0) then
        rho_ss(:,1) = 0.d0
     else
        rho_ss(:,1) = rho_ss(:,1) * felec1_ss/sum1
     end if
     if (sum2 == 0.d0) then
        rho_ss(:,2) = 0.d0
     else
        rho_ss(:,2) = rho_ss(:,2) * felec2_ss/sum2
     end if
  end select

99 continue

end subroutine calc_rho_ss_kt
! ========================================================================== 4.0

!=====================================================================
   subroutine calc_drho_ddrho_core_sol(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ir
   ier = 0
   call calc_ddiff_exp(ier,iord_diff,nmesh,rpos, &
                       rho_core,drho_core,ddrho_core)
   call calc_ddiff_rho_origin(ier,iord_diff,nmesh, &
                              rpos,rho_core,drho_core,ddrho_core)
   do ir = nmesh-iord_diff*2-1,nmesh
        rho_core(ir) =   rho_core(nmesh-iord_diff*2-2)
       drho_core(ir) =  drho_core(nmesh-iord_diff*2-2)
      ddrho_core(ir) = ddrho_core(nmesh-iord_diff*2-2)
   end do
99 continue
   end subroutine calc_drho_ddrho_core_sol

!=====================================================================
   subroutine calc_drho_ddrho_pcore_sol(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ir
   ier = 0
   call calc_ddiff_exp(ier,iord_diff,nmesh,rpos, &
                       rho_pcore,drho_pcore,ddrho_pcore)
   call calc_ddiff_rho_origin(ier,iord_diff,nmesh, &
                              rpos,rho_pcore,drho_pcore,ddrho_pcore)
   do ir = nmesh-iord_diff*2-1,nmesh
        rho_pcore(ir) =   rho_pcore(nmesh-iord_diff*2-2)
       drho_pcore(ir) =  drho_pcore(nmesh-iord_diff*2-2)
      ddrho_pcore(ir) = ddrho_pcore(nmesh-iord_diff*2-2)
   end do
99 continue
   end subroutine calc_drho_ddrho_pcore_sol

!=====================================================================

   subroutine calc_drho_ddrho_sol(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ir
   ier = 0
   call calc_ddiff_exp(ier,iord_diff,nmesh,rpos, &
           rho_sol,drho_sol,ddrho_sol)
   call calc_ddiff_rho_origin(ier,iord_diff,nmesh, &
           rpos,rho_sol,drho_sol,ddrho_sol)

! ======================================= modified by K. T. ============== 4.0
!   do ir = nmesh-iord_diff*2-1,nmesh
!        rho_sol(ir) =   rho_sol(nmesh-iord_diff*2-2)
!       drho_sol(ir) =  drho_sol(nmesh-iord_diff*2-2)
!      ddrho_sol(ir) = ddrho_sol(nmesh-iord_diff*2-2)
!   end do
!
   do ir = nmesh-iord_diff*2-1,nmesh
        rho_sol(ir,1) =   rho_sol(nmesh-iord_diff*2-2,1)
       drho_sol(ir,1) =  drho_sol(nmesh-iord_diff*2-2,1)
      ddrho_sol(ir,1) = ddrho_sol(nmesh-iord_diff*2-2,1)
   end do
! ========================================================================= 4.0

99 continue
   end subroutine calc_drho_ddrho_sol

! ========================================= added by K. T. =========== 4.0
subroutine calc_drho_ddrho_sol_kt(ier)
  use parameters
  implicit none

  integer,intent(out) :: ier
  integer :: ir, ispin

  ier = 0

  Do ispin=1, nspin
     call calc_ddiff_exp( ier, iord_diff, nmesh, rpos, &
          &               rho_sol(:,ispin), drho_sol(:,ispin),ddrho_sol(:,ispin) )
     call calc_ddiff_rho_origin(ier, iord_diff, nmesh, rpos,  &
          &               rho_sol(:,ispin), drho_sol(:,ispin),ddrho_sol(:,ispin) )
  End do

  do ir = nmesh-iord_diff*2-1,nmesh
     rho_sol(ir,:) =   rho_sol(nmesh-iord_diff*2-2,:)
     drho_sol(ir,:) =  drho_sol(nmesh-iord_diff*2-2,:)
     ddrho_sol(ir,:) = ddrho_sol(nmesh-iord_diff*2-2,:)
  end do

99 continue

end subroutine calc_drho_ddrho_sol_kt
! ================================================================== 4.0

!=====================================================================
   subroutine calc_drho_ddrho_ss(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ir, ispin
   ier = 0
   do ispin = 1,nspin_ss
      call calc_ddiff_exp(ier,iord_diff,nmesh,rpos(1), &
         rho_ss(1,ispin),drho_ss(1,ispin),ddrho_ss(1,ispin))
      call calc_ddiff_rho_origin(ier,iord_diff,nmesh,rpos(1), &
         rho_ss(1,ispin),drho_ss(1,ispin),ddrho_ss(1,ispin))
      do ir = nmesh-iord_diff*2-1,nmesh
           rho_ss(ir,ispin) =   rho_ss(nmesh-iord_diff*2-2,ispin)
          drho_ss(ir,ispin) =  drho_ss(nmesh-iord_diff*2-2,ispin)
         ddrho_ss(ir,ispin) = ddrho_ss(nmesh-iord_diff*2-2,ispin)
      end do
   end do
99 continue
   end subroutine calc_drho_ddrho_ss
   
!=====================================================================
   subroutine calc_drho_core_sol(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ir
   ier = 0
   call calc_diff_exp(ier,iord_diff,nmesh,rpos, &
                       rho_core,drho_core)
   call calc_diff_rho_origin(ier,iord_diff,nmesh, &
                              rpos,rho_core,drho_core)
   do ir = nmesh-iord_diff*2-1,nmesh
        rho_core(ir) =   rho_core(nmesh-iord_diff*2-2)
       drho_core(ir) =  drho_core(nmesh-iord_diff*2-2)
   end do
99 continue
   end subroutine calc_drho_core_sol

!=====================================================================
   subroutine calc_drho_pcore_sol(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ir
   ier = 0
   call calc_diff_exp(ier,iord_diff,nmesh,rpos, &
                       rho_pcore,drho_pcore)
   call calc_diff_rho_origin(ier,iord_diff,nmesh, &
                              rpos,rho_pcore,drho_pcore)
   do ir = nmesh-iord_diff*2-1,nmesh
        rho_pcore(ir) =   rho_pcore(nmesh-iord_diff*2-2)
       drho_pcore(ir) =  drho_pcore(nmesh-iord_diff*2-2)
   end do
99 continue
   end subroutine calc_drho_pcore_sol

!=====================================================================
   subroutine calc_drho_sol(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ir
   ier = 0
   call calc_diff_exp(ier,iord_diff,nmesh,rpos, &
           rho_sol,drho_sol)
   call calc_diff_rho_origin(ier,iord_diff,nmesh, &
           rpos,rho_sol,drho_sol)

! ====================================== modified by K. T. ============= 4.0
!   do ir = nmesh-iord_diff*2-1,nmesh
!        rho_sol(ir) =   rho_sol(nmesh-iord_diff*2-2)
!       drho_sol(ir) =  drho_sol(nmesh-iord_diff*2-2)
!   end do
   do ir = nmesh-iord_diff*2-1,nmesh
        rho_sol(ir,1) =   rho_sol(nmesh-iord_diff*2-2,1)
       drho_sol(ir,1) =  drho_sol(nmesh-iord_diff*2-2,1)
   end do
! ======================================================================== 4.0

99 continue
   end subroutine calc_drho_sol

!=====================================================================
   subroutine calc_drho_ss(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ir, ispin
   ier = 0
   do ispin = 1,nspin_ss
      call calc_diff_exp(ier,iord_diff,nmesh,rpos(1), &
         rho_ss(1,ispin),drho_ss(1,ispin))
      call calc_diff_rho_origin(ier,iord_diff,nmesh,rpos(1), &
         rho_ss(1,ispin),drho_ss(1,ispin))
      do ir = nmesh-iord_diff*2-1,nmesh
           rho_ss(ir,ispin) =   rho_ss(nmesh-iord_diff*2-2,ispin)
          drho_ss(ir,ispin) =  drho_ss(nmesh-iord_diff*2-2,ispin)
      end do
   end do
99 continue
   end subroutine calc_drho_ss

! ************************************************************* 
!
!   This is a software package CIAO
!
!     developed as a part of the national project "Research and 
!     Development of Innovative Simulation software",which is   
!     supported by the next-generation IT program of MEXT of Japan
!
!   latest version: 
!
!     4.0:  2013/01/17 
!           codes for spin-polarized pseudopotential generation are added
!
! ************************************************************* 
!
!  Software name : CIAO (Code for Investigating Atomic Orbitals)
!  Subroutine(s) : set_default_param, adjust_param
!  Author(s)     : Masakuni Okamoto (August 25, 2003)
!
!  The license of the code and contact address :
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)
!
!=====================================================================
   subroutine set_default_param
!=====================================================================
!
!  Sets default parameters
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
!--- is_spin
   nspin = 1
!--- core_potential
   core_type_explained = '-Z/r'
   is_core = NORMAL
   h_ok = 1.0d2
   drcl_ok = 0.2d0
   rcut_ok = 0.0d0
!--- xc_potential
   xc_type_explained = 'LDA (PW92-MOMO)'
   is_xc = LDAPW92_MOMO
   is_xc_class = LDA
!--- pseudo_potential
   pp_type_explained = 'No calculation'
   is_pp = NONE
   lmax = 2
   lloc = lmax
!--- core_correction
   pcc_type_explained = 'No core correction'
   is_pcc = NONE
   pcc_method_explained = 'None'
   is_pcc_method = NONE
   r0_pcc = 2.d0
   ng_pcc = 400
   gmin_pcc = 10.d0
   gmax_pcc = 40.d0
!--- core_hole_unscreened
   is_core_hole_unscreened = NO
!--- projector
   is_projector_type = NONE
!--- deficit_charge
   is_deficit_type = POLYNOMIAL
!--- solve_pp_spin
   solve_pp_spin_type_explained = 'No calculation'
   is_solve_pp_spin = NO
!--- logderi
   logderi_type_explained = 'Manual range'
   is_logderi = MANUAL
   ne_logderi = 4001
   emin_logderi  = -15.d0
   emax_logderi  =  +5.d0
   rcut_logderi  =   0.d0
   nrcut_logderi = 0
   is_logderi_method = FREDHOLM
   logderi_method_explained = 'Fredholm method'
   is_logderi_nonlocal = SEPARABLE
   logderi_nonlocal_explained = 'Separable'
!--- fourier
   fourier_type_explained = 'Manual range'
   is_fourier = MANUAL
   ng_fourier = 300
   gmin_fourier = 0.05d0
   gmax_fourier = 15.d0
!--- rmesh
   mesh_type_explained   = 'Logarithmic (Standard)'
   weight_type_explained = 'Extended rule'
   is_mesh   = JRCAT
   is_weight = EXTENDED
   nmesh = 1501  ;  xh = 96.d0  ;  rmax = 60.d0
   rmin = rmax * exp(dble(1-nmesh)/xh)
   dx   = 1.d0/xh
!--- gmesh
   gmin =  0.d0
   gmax = 30.d0
   ng_mesh = 601
!--- mixing
   mix1 = 0.30d0 ; mix2 = 0.30d0
!--- anderson
   n_anderson = 0
!--- conv
   nsave_dee = 5
   loop_conv = 150
   dee_conv  = 1.d-08
!--- order of calculation
   iord_pc    = 5
   iord_diff  = 4
   iord_nec   = 2
   iord_coeff = 5
!--- switches
   is_write_rm        = 1
   is_calc_hubbard    = 0
   is_calc_pao        = 0
   is_write_orbital   = 1
   is_write_rho       = 1
   is_write_us        = 1
   is_write_qps       = 1
   is_write_pcc       = 1
   is_write_pp        = 1
   is_write_ciaopp    = 1
   is_write_gncpp     = 0
   is_write_gncpp2    = 1
   is_write_psvpp     = 0
   is_write_logderi   = 1
   is_write_sol       = 1
   is_write_fourier   = 1
   is_with_dipole     = 1
   is_with_core       = 1
   is_with_ae         = 1
   is_with_so         = 0
   is_paw             = 0
   is_debug           = 0
!--- epsilon
   eps_check = 1.d-10
   eps_de    = 1.d-10
   end subroutine set_default_param

!=====================================================================
   subroutine adjust_param
!=====================================================================
!
!  Sets default parameters
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
!--- is_paw
   if ((is_with_ae /= 0).and.(is_with_core /= 0)) then
      is_paw = 1
   end if
   if (is_paw /= 0) then
      is_with_ae   = 1
      is_with_core = 1
   end if
   end subroutine adjust_param

! ************************************************************* 
!
!   This is a software package CIAO
!
!     developed as a part of the national project "Research and 
!     Development of Innovative Simulation software",which is   
!     supported by the next-generation IT program of MEXT of Japan
!
!   latest version: 
!
!     4.0:  2013/01/17 
!           codes for spin-polarized pseudopotential generation are added
!
! ************************************************************* 
!
!  Software name : CIAO (Code for Investigating Atomic Orbitals)
!  Subroutine(s) : write_pcc
!  Author(s)     : Masakuni Okamoto (August 25, 2003)
!
!  The license of the code and contact address :
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)
!
!=====================================================================
   subroutine write_pcc(ier)
!=====================================================================
!
!  M. Okamoto
!     
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ir, ig
   ier = 0
   open(IFPCC,file=trim(pccfile),status='unknown')
   write(IFPCC,*) 'PCC electron density and its fourier transform'
   call write_file_header(IFPCC)
   write(IFPCC,*)
   write(IFPCC,31) rpos(nr0_pcc), 'rcut  '
   write(IFPCC,31) gmin_pcc,      'gcut  '
   write(IFPCC,*)
   write(IFPCC,*) 'rpos, rho_core, rho_pcc, rho_val'
   do ir = 1,nmesh
! ============================================= modified by K. T. ========== 4.0
!      write(IFPCC,10) rpos(ir),rho_core(ir),rho_pcore(ir),rho_ps(ir)
      write(IFPCC,10) rpos(ir),rho_core(ir),rho_pcore(ir),rho_ps(ir,1)
! ========================================================================== 4.0
   end do
   write(IFPCC,*)
   write(IFPCC,*) 'gpos, gg_rho_core, gg_rho_pcc, gg_rho_val'
   do ig = 1,ng_mesh
      write(IFPCC,10) gpos(ig),gg_rho_core(ig),gg_rho_pcore(ig), &
                      gg_rho_val(ig)
   end do
10 format(10(1pe20.10))
31 format(1x,f20.10, 5x,':',1x,a6)
   close(IFPCC)
   end subroutine write_pcc

! ************************************************************* 
!
!   This is a software package CIAO
!
!     developed as a part of the national project "Research and 
!     Development of Innovative Simulation software",which is   
!     supported by the next-generation IT program of MEXT of Japan
!
!   latest version: 
!
!     4.0:  2013/01/17 
!           codes for spin-polarized pseudopotential generation are added
!
! ************************************************************* 
!
!  Software name : CIAO (Code for Investigating Atomic Orbitals)
!  Subroutine(s) : swap
!  Author(s)     : Masakuni Okamoto (August 25, 2003)
!
!  The license of the code and contact address :
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)
!
!=====================================================================
   subroutine swap(a,b)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   implicit none
   real(8),intent(inout) :: a, b
   real(8) :: tmp
   tmp = a ; a = b ; b = tmp
   end subroutine swap

!=====================================================================
   subroutine sort_simple(n,val,idx)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   implicit none
   integer,intent(in)  :: n
   real(8),intent(in)  :: val(1:n)
   integer,intent(out) :: idx(1:n)
   integer :: i, j, ipos, jpos
   real(8) :: vi, vj
   do i = 1,n
      idx(i) = i
   end do
   do i = 1,n-1
      ipos = idx(i)
      vi   = val(ipos)
      do j = i+1,n
         jpos = idx(j)
         vj   = val(jpos)
         if (vi > vj) then
            idx(i) = jpos
            idx(j) = ipos
            ipos = jpos
            vi   = vj
         end if
      end do
   end do
   end subroutine sort_simple

! ************************************************************* 
!
!   This is a software package CIAO
!
!     developed as a part of the national project "Research and 
!     Development of Innovative Simulation software",which is   
!     supported by the next-generation IT program of MEXT of Japan
!
!   latest version: 
!
!     4.0:  2013/01/17 
!           codes for spin-polarized pseudopotential generation are added
!
! ************************************************************* 
!
!  Software name : CIAO (Code for Investigating Atomic Orbitals)
!  Subroutine(s) : find_ishell_ss, set_init_state_ss
!  Author(s)     : Masakuni Okamoto (August 25, 2003)
!
!  The license of the code and contact address :
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)
!
!=====================================================================
   subroutine find_ishell_ss(nshell,n_qnum,l_qnum,nn,ll, &
                             ishell_found)
!=====================================================================
!
!  Finds ishell
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   implicit none
   integer,intent(in)  :: nshell, n_qnum(nshell), l_qnum(nshell), &
                          nn, ll
   integer,intent(out) :: ishell_found
   integer :: ishell, n, l
   do ishell = 1,nshell
      n = n_qnum(ishell)
      l = l_qnum(ishell)
      if ((nn == n).and.(ll == l)) then
         ishell_found = ishell
         exit
      end if
      if (ishell == nshell) then
         ishell_found = 0
         exit
      end if
   end do
   end subroutine find_ishell_ss

!============================================= added by K. T. ============= 4.0
subroutine find_ishell_ss_kt( nshell, n_qnum, l_qnum, nn, ll, &
     &                        myspin, spin_qnum, ishell_found )
  implicit none

  integer,intent(in)  :: nshell, n_qnum(nshell), l_qnum(nshell), &
       &                 nn, ll, myspin, spin_qnum(nshell)
  integer,intent(out) :: ishell_found

  integer :: ishell, n, l, ispin

  do ishell = 1,nshell
     n = n_qnum(ishell)
     l = l_qnum(ishell)

     ispin = spin_qnum(ishell)

     if ((nn == n).and.(ll == l).and.(ispin==myspin)) then
        ishell_found = ishell
        exit
     end if
     if (ishell == nshell) then
        ishell_found = 0
        exit
     end if
  end do

end subroutine find_ishell_ss_kt
! =========================================================================== 4.0
!=====================================================================
   subroutine set_init_state_ss(ier)
!=====================================================================
!
!  Sets initial states
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ishell, ir, iss, n1, l1, n2, l2, ips, ispin, lss, lshell
   real(8) :: r, sum1, sum2

! ================================ added by K. T. ====================== 4.0
   integer :: ispin_ps
! ====================================================================== 4.0   

   ier = 0
   if (is_core_hole_unscreened /= NO) then
      call reset_felec_ss(ier)
      if (ier /= 0) then
         write(IFLOG,*) '### ERROR ### in reset_felec_ss'
         go to 99
      end if
   end if
   do iss = 1,nss
      n1 = n_val_label_ss(iss)
      l1 = l_val_label_ss(iss)
      if (focc_ss(iss) < 0.d0) then
         write(IFLOG,*) '### ERROR ### focc_ss < 0'
         write(IFLOG,*) '   focc_ss ...',focc_ss(iss)
         write(IFLOG,*) '   (n,l,s) ...',n1,l1,spin_ss(iss)
         ier = 1 ; go to 99
      end if
   end do
   do iss = 1,nss
      n1 = n_val_label_ss(iss)
      l1 = l_val_label_ss(iss)
      do ips = 1,nps
         n2 = n_val_label_ps(ips)
         l2 = l_val_label_ps(ips)
         if ((n1 == n2).and.(l1 == l2)) then
            exit
         end if
         if (ips == nps) then
            write(IFLOG,*) '### ERROR ###'
            write(IFLOG,*) 'The valence states specified for solve_pp is'
            write(IFLOG,*) 'inequivalent to those for the pseudopotential.'
            write(IFLOG,*) '   (n,l) ...',n1,l1
            ier = 1 ; go to 99
         end if
      end do
   end do

   dee_save(:) = 0.d0
   do iss = 1,nss
      ishell = ishell_ss(iss)
      engy_ss(iss) = engy(ishell)
   end do

   sum1 = 0.d0
   do ir = 1,nmesh
      r = rpos(ir)

! =========================================== modiifed by K. T. ============ 4.0
!      rho_ss(ir,1) = rho_sol(ir)
!
      if ( nspin == 1 ) then
         rho_ss(ir,1) = rho_sol(ir,1)
      else if ( nspin == 2 ) then
         rho_ss(ir,1) = ( rho_sol(ir,1) +rho_sol(ir,2) ) /2.0
      endif
! ========================================================================== 4.0

      sum1 = sum1 + rho_ss(ir,1) * r*r*wr(ir)
   end do

   sum1 = sum1 * 4.d0*PI
   sum2 = 0.d0

   do ir = 1,nmesh
      r = rpos(ir)
      rho_ss(ir,1) = rho_ss(ir,1) * felec_ss/sum1
      if (is_spin_ss == POLARIZED) then
         rho_ss(ir,2) = (felec2_ss/felec_ss) * rho_ss(ir,1)
         rho_ss(ir,1) = rho_ss(ir,1) - rho_ss(ir,2)
         sum2 = sum2 + (rho_ss(ir,1)+rho_ss(ir,2)) * r*r*wr(ir)
      else
         sum2 = sum2 + rho_ss(ir,1) * r*r*wr(ir)
      end if
   end do

   sum2 = sum2 * 4.d0*PI

   write(IFLOG,10) '??? check: initial felec1_ss,felec2_ss ...', &
                                       felec1_ss,felec2_ss

10 format(1x,a42,2f15.10)

   if (abs(sum2-felec_ss) > 1.d-6) then
      write(IFLOG,*) '### ERROR ### sum of rho_ss != felec_ss'
      write(IFLOG,*) '   sum of rho_ss ...',sum2
      write(IFLOG,*) '   felec_ss      ...',felec_ss
      ier = 1 ; go to 99
   end if

! ========================================= modified by K. T. ============== 4.0
!   do ispin = 1,nspin_ss
!      vloc_scr_ss(:,ispin) = vloc_scr_sol(:)
!   end do
!
   if ( nspin == 1 ) then
      do ispin = 1,nspin_ss
         vloc_scr_ss(:,ispin) = vloc_scr_sol(:,1)
      end do

   else if ( nspin == 2 ) then

      if ( nspin_ss == 1 ) then
         vloc_scr_ss(:,ispin) = ( vloc_scr_sol(:,1) + vloc_scr_sol(:,2) )/2.0

      else if ( nspin_ss == 2 ) then

         Do ispin=1, nspin_ss
            ispin_ps = ispin                      ! uncertain

            vloc_scr_ss(:,ispin) = vloc_scr_sol(:,ispin_ps)
            vloc_scr_ss(:,ispin) = vloc_scr_sol(:,ispin_ps)
         End Do
      endif

   endif
! ========================================================================== 4.0

   do ispin = 1,nspin_ss
      dmat_ss(:,ispin) = dmat_us(:)
      vlocqps_ss(:,ispin) = vlocqps_us(:)
   end do
   is_solve_ss(:) = 1
   do iss = 1,nss
      ishell = ishell_ss(iss)
      if ((abs(felec2_ss) < 1.d-6).and.(spin_ss(iss) == -1)) then
         is_solve_ss(iss) = 0
      end if
      if (is_solve(ishell) == 0) then
         is_solve_ss(iss) = 0
      end if
   end do
   etot_ss = -1.d0
   do iss = 1,nss
      ishell = ishell_ss(iss)
      nrm_pos_ss(iss) = nrm_pos(ishell)
      select case (spin_ss(iss))
      case (+1)
         spin_label_ss(iss) = '+'
      case (-1)
         spin_label_ss(iss) = '-'
      end select
   end do
   call sort_engy_ss(ier)
   if (ier /= 0) then
      write(IFLOG,*) '### ERROR ### in sort_engy_ss' ; go to 99
   end if
   call set_focc_ss(ier)
   if (ier /= 0) then
      write(IFLOG,*) '### ERROR ### in set_focc_ss' ; go to 99
   end if
   do iss = 1,nss
      lss = list_ss(iss)
      lshell = ishell_ss(lss)
      write(IFLOG,*) '(n,l,s),focc,nocc,is_solve ...', &
         n_qnum(lshell),l_qnum(lshell),spin_ss(lss), &
         focc_ss(lss),nocc_ss(lss),is_solve_ss(lss)
   end do
99 continue
   end subroutine set_init_state_ss

! ************************************************************* 
!
!   This is a software package CIAO
!
!     developed as a part of the national project "Research and 
!     Development of Innovative Simulation software",which is   
!     supported by the next-generation IT program of MEXT of Japan
!
!   latest version: 
!
!     4.0:  2013/01/17 
!           codes for spin-polarized pseudopotential generation are added
!
! ************************************************************* 
!
!  Software name : CIAO (Code for Investigating Atomic Orbitals)
!  Subroutine(s) : get_args
!  Author(s)     : Masakuni Okamoto (August 25, 2003)
!
!  The license of the code and contact address :
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)
!
!=====================================================================
   subroutine get_args
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer :: iargc
   integer :: iarg, sw_show_help
   sw_show_help = 0
   have_infile = 0
   narg = iargc()
   if (narg == 0) then
      have_args = 0
      sw_show_help = 1
   else
      have_args = 1
      do iarg = 1,narg
         call getarg(iarg,argv(iarg))
         select case (argv(iarg)(1:1))
         case ('-')
            select case (argv(iarg))
            case ('--help', '-h', &
                  '--version', '-v')
               sw_show_help = 1
            case default
               write(*,*) '### ERROR ### flags are not correct.'
               sw_show_help = 1
            end select
         case default
            have_infile = 1
            infile = argv(iarg)
         end select
      end do
   end if
   if (have_infile == 0) then
      sw_show_help = 1
   end if
   if (sw_show_help == 1) then
      call write_version(6)
      write(*,*) '+------------------------------------------------+'
      write(*,*) '|  Usage: ciao input_file [flags ... ]           |'
      write(*,*) '|                                                |'
      write(*,*) '|     input_file ... input-file name             |'
      write(*,*) '|      -help     ... show help message           |'
      write(*,*) '+------------------------------------------------+'
      stop
   end if
99 continue
   end subroutine get_args

! ************************************************************* 
!
!   This is a software package CIAO
!
!     developed as a part of the national project "Research and 
!     Development of Innovative Simulation software",which is   
!     supported by the next-generation IT program of MEXT of Japan
!
!   latest version: 
!
!     4.0:  2013/01/17 
!           codes for spin-polarized pseudopotential generation are added
!
! ************************************************************* 
!
!  Software name : CIAO (Code for Investigating Atomic Orbitals)
!  Subroutine(s) : calc_xc_lda_pz81, calc_xc_lda_pz81_ps
!                : calc_xc_lda_pw92, calc_xc_lda_pw92_ps
!                : calc_xc_gga_pbe96, calc_xc_gga_pbe96_ps
!                : calc_xc_gga_pw91, calc_xc_gga_pw91_ps
!                : calc_x_lda, calc_x_lda_ps, calc_x_gga
!                : calc_x_gga_ps, calc_xc_none, calc_xc_none_ps
!  Author(s)     : Masakuni Okamoto (August 25, 2003)
!
!  The license of the code and contact address :
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)
!
!=====================================================================
   subroutine calc_xc_lda_pz81(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ir, ispin
   real(8) :: rho1, rho2, vxs(2), vcs(2), &
              rhomin = 1.d-35
   ier = 0
   do ir = 1,nmesh
      if (is_spin == POLARIZED) then
         rho1 = rho(ir,1) ; rho2 = rho(ir,2)
      else
         rho1 = rho(ir,1)*0.5d0 ; rho2 = rho1
      end if
      call lda_pz81(rho1,rho2,ex(ir),ec(ir),vxs,vcs)
      do ispin = 1,nspin
         vx(ir,ispin) = vxs(ispin)
         vc(ir,ispin) = vcs(ispin)
      end do
   end do
   end subroutine calc_xc_lda_pz81

!=====================================================================
   subroutine calc_xc_lda_pz81_ps(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ir
   real(8) :: rho1, rho2, rho1_tmp, &
              ex_tmp, ec_tmp, vx_tmp(2), vc_tmp(2), &
              rhomin = 1.d-35
   ier = 0
   do ir = 1,nmesh
      select case (is_pcc)
! ================================= modified by K. T. ================ 4.0
!      case (NONE)
!         rho1_tmp = rho_ps(ir)
!         rho1_tmp = rho_ps(ir)
!      case (PCC)
!         rho1_tmp = rho_ps(ir) + rho_pcore(ir)
!      case (FCC)
!         rho1_tmp = rho_ps(ir) + rho_core(ir)
!      end select
!
      case (NONE)
         rho1_tmp = rho_ps(ir,1)
      case (PCC)
         rho1_tmp = rho_ps(ir,1) + rho_pcore(ir)
      case (FCC)
         rho1_tmp = rho_ps(ir,1) + rho_core(ir)
      end select
! ================================================================== 4.0

      rho1 = rho1_tmp*0.5d0 ; rho2 = rho1
      call lda_pz81(rho1,rho2,ex_tmp,ec_tmp,vx_tmp,vc_tmp)

      ex_ps(ir) = ex_tmp
      ec_ps(ir) = ec_tmp

! ======================================= modiifed by K. T. ===========4.0
!      vx_ps(ir) = vx_tmp(1)
!      vc_ps(ir) = vc_tmp(1)
!
      vx_ps(ir,1) = vx_tmp(1)
      vc_ps(ir,1) = vc_tmp(1)
! ==================================================================== 4.0
   end do

   do ir = 1,nmesh
      select case (is_pcc)
      case (NONE)
         rho1_tmp = 0.d0
      case (PCC)
         rho1_tmp = rho_pcore(ir)
      case (FCC)
         rho1_tmp = rho_core(ir)
      end select
      rho1 = rho1_tmp*0.5d0 ; rho2 = rho1
      select case (is_pcc)

      case (PCC,FCC)
         call lda_pz81(rho1,rho2,ex_tmp,ec_tmp,vx_tmp,vc_tmp)
      case (NONE)
         ex_tmp    = 0.d0
         ec_tmp    = 0.d0
         vx_tmp(1) = 0.d0
         vc_tmp(1) = 0.d0
      end select
      expc_ps(ir) = ex_tmp
      ecpc_ps(ir) = ec_tmp
      vxpc_ps(ir) = vx_tmp(1)
      vcpc_ps(ir) = vc_tmp(1)
   end do

   end subroutine calc_xc_lda_pz81_ps

!=====================================================================
   subroutine calc_xc_lda_pw92(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ir, ispin
   real(8) :: rho1, rho2, vxs(2), vcs(2), &
              decdrs, decdzeta, &
              rhomin = 1.d-35
   ier = 0
   do ir = 1,nmesh
      if (is_spin == POLARIZED) then
         rho1 = rho(ir,1) ; rho2 = rho(ir,2)
      else
         rho1 = rho(ir,1)*0.5d0 ; rho2 = rho1
      end if
      call lda_pw92(rho1,rho2,ex(ir),ec(ir),vxs,vcs, &
                    decdrs,decdzeta)
      do ispin = 1,nspin
         vx(ir,ispin) = vxs(ispin)
         vc(ir,ispin) = vcs(ispin)
      end do
   end do
   end subroutine calc_xc_lda_pw92

!=====================================================================
   subroutine calc_xc_lda_pw92_ps(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ir
   real(8) :: rho1, rho2, rho1_tmp, &
              ex_tmp, ec_tmp, vx_tmp(2), vc_tmp(2), &
              decdrs, decdzeta, &
              rhomin = 1.d-35
   ier = 0
   do ir = 1,nmesh
      select case (is_pcc)

! =============================================== modified by K. T. ============ 4.0
!      case (NONE)
!         rho1_tmp = rho_ps(ir)
!      case (PCC)
!         rho1_tmp = rho_ps(ir) + rho_pcore(ir)
!      case (FCC)
!         rho1_tmp = rho_ps(ir) + rho_core(ir)
!      end select
!
      case (NONE)
         rho1_tmp = rho_ps(ir,1)
      case (PCC)
         rho1_tmp = rho_ps(ir,1) + rho_pcore(ir)
      case (FCC)
         rho1_tmp = rho_ps(ir,1) + rho_core(ir)
      end select
! ========================================================================== 4.0

      rho1 = rho1_tmp*0.5d0 ; rho2 = rho1

      call lda_pw92(rho1,rho2,ex_tmp,ec_tmp,vx_tmp,vc_tmp, &
                    decdrs,decdzeta)

      ex_ps(ir) = ex_tmp
      ec_ps(ir) = ec_tmp

! ========================================= modified by K. T. ============== 4.0
!      vx_ps(ir) = vx_tmp(1)
!      vc_ps(ir) = vc_tmp(1)
!
      vx_ps(ir,1) = vx_tmp(1)
      vc_ps(ir,1) = vc_tmp(1)
! ========================================================================= 4.0
   end do

   do ir = 1,nmesh
      select case (is_pcc)
      case (NONE)
         rho1_tmp = 0.d0
      case (PCC)
         rho1_tmp = rho_pcore(ir)
      case (FCC)
         rho1_tmp = rho_core(ir)
      end select
      rho1 = rho1_tmp*0.5d0 ; rho2 = rho1
      select case (is_pcc)
      case (PCC,FCC)
         call lda_pw92(rho1,rho2,ex_tmp,ec_tmp,vx_tmp,vc_tmp, &
                       decdrs,decdzeta)
      case (NONE)
         ex_tmp    = 0.d0
         ec_tmp    = 0.d0
         vx_tmp(1) = 0.d0
         vc_tmp(1) = 0.d0
      end select
      expc_ps(ir) = ex_tmp
      ecpc_ps(ir) = ec_tmp
      vxpc_ps(ir) = vx_tmp(1)
      vcpc_ps(ir) = vc_tmp(1)
   end do
   end subroutine calc_xc_lda_pw92_ps

!=====================================================================
   subroutine calc_xc_gga_pbe96(ier,imode)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(in)  :: imode
   integer,intent(out) :: ier
   integer :: ir, ispin
   real(8) :: r,rho1, rho2, ex_tmp, ec_tmp, vx_tmp(2), vc_tmp(2), &
              drho1, drho2, ddrho1, ddrho2, &
              eps_chg = 1.d-25
   ier = 0
   do ir = 1,nmesh
      if (is_spin == POLARIZED) then
            rho1 =    rho(ir,1) ;    rho2 =    rho(ir,2)
           drho1 =   drho(ir,1) ;   drho2 =   drho(ir,2)
          ddrho1 =  ddrho(ir,1) ;  ddrho2 =  ddrho(ir,2)
      else
            rho1 =    rho(ir,1)*0.5d0 ;    rho2 =    rho1
           drho1 =   drho(ir,1)*0.5d0 ;   drho2 =   drho1
          ddrho1 =  ddrho(ir,1)*0.5d0 ;  ddrho2 =  ddrho1
      end if
      r = rpos(ir)
      call gga_pbe96_spherical(imode, &
                 r,rho1,rho2,drho1,drho2,ddrho1,ddrho2, &
                 ex_tmp,ec_tmp,vx_tmp,vc_tmp)
      ex(ir) = ex_tmp
      ec(ir) = ec_tmp
      if (max(rho1,rho2) < eps_chg) then
         ec(ir) = 0.d0
      end if
      do ispin = 1,nspin
         vx(ir,ispin) = vx_tmp(ispin)
         vc(ir,ispin) = vc_tmp(ispin)
      end do
      if (rho1 < eps_chg) then
         vc(ir,1) = 0.d0
      end if
      if (nspin == 2) then
         if (rho2 < eps_chg) then
            vc(ir,2) = 0.d0
         end if
      end if
   end do
   end subroutine calc_xc_gga_pbe96

!=====================================================================
   subroutine calc_xc_gga_pbe96_ps(ier,imode)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(in)  :: imode
   integer,intent(out) :: ier
   integer :: ir
   real(8) :: r, rho1, rho2, drho1, drho2, ddrho1, ddrho2, &
              rho1_tmp, drho1_tmp, ddrho1_tmp, &
              ex_tmp, ec_tmp, vx_tmp(2), vc_tmp(2), &
              rhomin = 1.d-35, eps_chg = 1.d-25
   ier = 0
   do ir = 1,nmesh
      select case (is_pcc)

! ========================================= modified by K. T. =========== 4.0
!      case (NONE)
!           rho1_tmp =   rho_ps(ir)
!          drho1_tmp =  drho_ps(ir)
!         ddrho1_tmp = ddrho_ps(ir)
!      case (PCC)
!           rho1_tmp =   rho_ps(ir) +   rho_pcore(ir)
!          drho1_tmp =  drho_ps(ir) +  drho_pcore(ir)
!         ddrho1_tmp = ddrho_ps(ir) + ddrho_pcore(ir)
!      case (FCC)
!           rho1_tmp =   rho_ps(ir) +   rho_core(ir)
!          drho1_tmp =  drho_ps(ir) +  drho_core(ir)
!         ddrho1_tmp = ddrho_ps(ir) + ddrho_core(ir)
!      end select

      case (NONE)
           rho1_tmp =   rho_ps(ir,1)
          drho1_tmp =  drho_ps(ir,1)
         ddrho1_tmp = ddrho_ps(ir,1)
      case (PCC)
           rho1_tmp =   rho_ps(ir,1) +   rho_pcore(ir)
          drho1_tmp =  drho_ps(ir,1) +  drho_pcore(ir)
         ddrho1_tmp = ddrho_ps(ir,1) + ddrho_pcore(ir)
      case (FCC)
           rho1_tmp =   rho_ps(ir,1) +   rho_core(ir)
          drho1_tmp =  drho_ps(ir,1) +  drho_core(ir)
         ddrho1_tmp = ddrho_ps(ir,1) + ddrho_core(ir)
      end select
! ================================================================= 4.0

        rho1 =    rho1_tmp*0.5d0 ;    rho2 =    rho1
       drho1 =   drho1_tmp*0.5d0 ;   drho2 =   drho1
      ddrho1 =  ddrho1_tmp*0.5d0 ;  ddrho2 =  ddrho1
      !### DEBUG ### [begin]
      if (rho1_tmp < rhomin) then
           rho1 = rhomin ;   rho2 = rho1
          drho1 =   0.d0 ;  drho2 = 0.d0
         ddrho1 =   0.d0 ; ddrho2 = 0.d0
      end if
      !### DEBUG ### [end]
      r = rpos(ir)
      call gga_pbe96_spherical(imode, &
                 r,rho1,rho2,drho1,drho2,ddrho1,ddrho2, &
                 ex_tmp,ec_tmp,vx_tmp,vc_tmp)

      ex_ps(ir) = ex_tmp
      ec_ps(ir) = ec_tmp
      if (max(rho1,rho2) < eps_chg) then
         ec_ps(ir) = 0.d0    
      end if

! ========================================== modified by K. T. ============ 4.0
!      vx_ps(ir) = vx_tmp(1)
!      vc_ps(ir) = vc_tmp(1)
!      if (max(rho1,rho2) < eps_chg) then
!         vc_ps(ir) = 0.d0
!      end if

      vx_ps(ir,1) = vx_tmp(1)
      vc_ps(ir,1) = vc_tmp(1)
      if (max(rho1,rho2) < eps_chg) then
         vc_ps(ir,1) = 0.d0
      end if
! ========================================================================= 4.0


   end do

   do ir = 1,nmesh
      select case (is_pcc)
      case (NONE)
           rho1_tmp = 0.d0
          drho1_tmp = 0.d0
         ddrho1_tmp = 0.d0
      case (PCC)
           rho1_tmp =   rho_pcore(ir)
          drho1_tmp =  drho_pcore(ir)
         ddrho1_tmp = ddrho_pcore(ir)
      case (FCC)
           rho1_tmp =   rho_core(ir)
          drho1_tmp =  drho_core(ir)
         ddrho1_tmp = ddrho_core(ir)
      end select
        rho1 =    rho1_tmp*0.5d0 ;    rho2 =    rho1
       drho1 =   drho1_tmp*0.5d0 ;   drho2 =   drho1
      ddrho1 =  ddrho1_tmp*0.5d0 ;  ddrho2 =  ddrho1
      !### DEBUG ### [begin]
      if (rho1_tmp < rhomin) then
           rho1 = rhomin ;   rho2 = rho1
          drho1 =   0.d0 ;  drho2 = 0.d0
         ddrho1 =   0.d0 ; ddrho2 = 0.d0
      end if
      !### DEBUG ### [end]
      r = rpos(ir)
      select case (is_pcc)
      case (PCC,FCC)
         call gga_pbe96_spherical(imode, &
                 r,rho1,rho2,drho1,drho2,ddrho1,ddrho2, &
                 ex_tmp,ec_tmp,vx_tmp,vc_tmp)
      case (NONE)
         ex_tmp = 0.d0
         ec_tmp = 0.d0
         vx_tmp(1) = 0.d0
         vc_tmp(1) = 0.d0
      end select
      expc_ps(ir) = ex_tmp
      ecpc_ps(ir) = ec_tmp
      if (max(rho1,rho2) < eps_chg) then
         ecpc_ps(ir) = 0.d0    
      end if
      vxpc_ps(ir) = vx_tmp(1)
      vcpc_ps(ir) = vc_tmp(1)
      if (max(rho1,rho2) < eps_chg) then
         vcpc_ps(ir) = 0.d0
      end if
   end do
   end subroutine calc_xc_gga_pbe96_ps

!=====================================================================
   subroutine calc_xc_gga_pbe96_rad(ier,imode)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(in)  :: imode
   integer,intent(out) :: ier
   ier = 0
   if (is_spin == POLARIZED) then
       rho1_rad(:) =  rho(:,1) ;  rho2_rad(:) =  rho(:,2)
      drho1_rad(:) = drho(:,1) ; drho2_rad(:) = drho(:,2)
   else
       rho1_rad(:) =  rho(:,1)*0.5d0 ;  rho2_rad(:) =  rho1_rad(:)
      drho1_rad(:) = drho(:,1)*0.5d0 ; drho2_rad(:) = drho1_rad(:)
   end if
   call gga_fxc_rmesh( &
      ier,IFLOG,imode+1,iord_diff,nmesh,nspin,            &
      rpos,wr,rho1_rad,rho2_rad,drho1_rad,drho2_rad,      &
      fx_rad,fc_rad,dfx_rad,dfc_rad,dfxda_rad,dfcda_rad, &
      vx,vc,ex,ec,ex_sum,ec_sum)
   if (ier /= 0) then
      write(IFLOG,*) '### ERROR ### in gga_fxc_rmesh' ; go to 99
   end if
99 continue
   end subroutine calc_xc_gga_pbe96_rad

!=====================================================================
   subroutine calc_xc_gga_pbe96_rad_ps(ier,imode)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(in)  :: imode
   integer,intent(out) :: ier
   real(8) :: ex_sum_tmp, ec_sum_tmp
   ier = 0
   select case (is_pcc)
! ======================================== modified by K. T. ================ 4.0
!   case (NONE)
!       rho1_rad(:) =  rho_ps(:) * 0.5d0
!      drho1_rad(:) = drho_ps(:) * 0.5d0
!   case (PCC)
!       rho1_rad(:) = ( rho_ps(:) +  rho_pcore(:)) * 0.5d0
!      drho1_rad(:) = (drho_ps(:) + drho_pcore(:)) * 0.5d0
!   case (FCC)
!       rho1_rad(:) = ( rho_ps(:) +  rho_core(:)) * 0.5d0
!      drho1_rad(:) = (drho_ps(:) + drho_core(:)) * 0.5d0
!   end select
!
   case (NONE)
       rho1_rad(:) =  rho_ps(:,1) * 0.5d0
      drho1_rad(:) = drho_ps(:,1) * 0.5d0
   case (PCC)
       rho1_rad(:) = ( rho_ps(:,1) +  rho_pcore(:)) * 0.5d0
      drho1_rad(:) = (drho_ps(:,1) + drho_pcore(:)) * 0.5d0
   case (FCC)
       rho1_rad(:) = ( rho_ps(:,1) +  rho_core(:)) * 0.5d0
      drho1_rad(:) = (drho_ps(:,1) + drho_core(:)) * 0.5d0
   end select
! ===================================================================== 4.0

    rho2_rad(:) =  rho1_rad(:)
   drho2_rad(:) = drho1_rad(:)
   call gga_fxc_rmesh( &
      ier,IFLOG,imode+1,iord_diff,nmesh,1,               &
      rpos,wr,rho1_rad,rho2_rad,drho1_rad,drho2_rad,     &
      fx_rad,fc_rad,dfx_rad,dfc_rad,dfxda_rad,dfcda_rad, &
      vx_ps,vc_ps,ex_ps,ec_ps,ex_sum_tmp,ec_sum_tmp)
   if (ier /= 0) then
      write(IFLOG,*) '### ERROR ### in gga_fxc_rmesh' ; go to 99
   end if
   select case (is_pcc)
   case (NONE)
       rho1_rad(:) = 0.d0
      drho1_rad(:) = 0.d0
   case (PCC)
       rho1_rad(:) =  rho_pcore(:) * 0.5d0
      drho1_rad(:) = drho_pcore(:) * 0.5d0
   case (FCC)
       rho1_rad(:) =  rho_core(:) * 0.5d0
      drho1_rad(:) = drho_core(:) * 0.5d0
   end select
    rho2_rad(:) =  rho1_rad(:)
   drho2_rad(:) = drho1_rad(:)
   if (is_pcc == NONE) then
      vxpc_ps(:) = 0.d0 ; vcpc_ps(:) = 0.d0
      expc_ps(:) = 0.d0 ; ecpc_ps(:) = 0.d0
      expc_sum   = 0.d0 ; ecpc_sum   = 0.d0
   else
      call gga_fxc_rmesh( &
         ier,IFLOG,imode+1,iord_diff,nmesh,1,               &
         rpos,wr,rho1_rad,rho2_rad,drho1_rad,drho2_rad,     &
         fx_rad,fc_rad,dfx_rad,dfc_rad,dfxda_rad,dfcda_rad, &
         vxpc_ps,vcpc_ps,expc_ps,ecpc_ps,expc_sum,ecpc_sum)
      if (ier /= 0) then
         write(IFLOG,*) '### ERROR ### in gga_fxc_rmesh' ; go to 99
      end if
   end if
99 continue
   end subroutine calc_xc_gga_pbe96_rad_ps

!=====================================================================
   subroutine calc_xc_gga_pw91_rad(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   ier = 0
   if (is_spin == POLARIZED) then
       rho1_rad(:) =  rho(:,1) ;  rho2_rad(:) =  rho(:,2)
      drho1_rad(:) = drho(:,1) ; drho2_rad(:) = drho(:,2)
   else
       rho1_rad(:) =  rho(:,1)*0.5d0 ;  rho2_rad(:) =  rho1_rad(:)
      drho1_rad(:) = drho(:,1)*0.5d0 ; drho2_rad(:) = drho1_rad(:)
   end if
   call gga_fxc_rmesh( &
      ier,IFLOG,3,iord_diff,nmesh,nspin,                 &
      rpos,wr,rho1_rad,rho2_rad,drho1_rad,drho2_rad,     &
      fx_rad,fc_rad,dfx_rad,dfc_rad,dfxda_rad,dfcda_rad, &
      vx,vc,ex,ec,ex_sum,ec_sum)
   if (ier /= 0) then
      write(IFLOG,*) '### ERROR ### in gga_fxc_rmesh' ; go to 99
   end if
99 continue
   end subroutine calc_xc_gga_pw91_rad

!=====================================================================
   subroutine calc_xc_gga_pw91_rad_ps(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   real(8) :: ex_sum_tmp, ec_sum_tmp
   ier = 0
   select case (is_pcc)

! ======================================= modiifed by K. T. ============== 4.0
!   case (NONE)
!       rho1_rad(:) =  rho_ps(:) * 0.5d0
!      drho1_rad(:) = drho_ps(:) * 0.5d0
!   case (PCC)
!       rho1_rad(:) = ( rho_ps(:) +  rho_pcore(:)) * 0.5d0
!      drho1_rad(:) = (drho_ps(:) + drho_pcore(:)) * 0.5d0
!   case (FCC)
!       rho1_rad(:) = ( rho_ps(:) +  rho_core(:)) * 0.5d0
!      drho1_rad(:) = (drho_ps(:) + drho_core(:)) * 0.5d0
!   end select
!
   case (NONE)
       rho1_rad(:) =  rho_ps(:,1) * 0.5d0
      drho1_rad(:) = drho_ps(:,1) * 0.5d0
   case (PCC)
       rho1_rad(:) = ( rho_ps(:,1) +  rho_pcore(:)) * 0.5d0
      drho1_rad(:) = (drho_ps(:,1) + drho_pcore(:)) * 0.5d0
   case (FCC)
       rho1_rad(:) = ( rho_ps(:,1) +  rho_core(:)) * 0.5d0
      drho1_rad(:) = (drho_ps(:,1) + drho_core(:)) * 0.5d0
   end select
! ============================================================================= 4.0

    rho2_rad(:) =  rho1_rad(:)
   drho2_rad(:) = drho1_rad(:)
   call gga_fxc_rmesh( &
      ier,IFLOG,3,iord_diff,nmesh,1,                     &
      rpos,wr,rho1_rad,rho2_rad,drho1_rad,drho2_rad,     &
      fx_rad,fc_rad,dfx_rad,dfc_rad,dfxda_rad,dfcda_rad, &
      vx_ps,vc_ps,ex_ps,ec_ps,ex_sum_tmp,ec_sum_tmp)
   if (ier /= 0) then
      write(IFLOG,*) '### ERROR ### in gga_fxc_rmesh' ; go to 99
   end if
   select case (is_pcc)
   case (NONE)
       rho1_rad(:) = 0.d0
      drho1_rad(:) = 0.d0
   case (PCC)
       rho1_rad(:) =  rho_pcore(:) * 0.5d0
      drho1_rad(:) = drho_pcore(:) * 0.5d0
   case (FCC)
       rho1_rad(:) =  rho_core(:) * 0.5d0
      drho1_rad(:) = drho_core(:) * 0.5d0
   end select
    rho2_rad(:) =  rho1_rad(:)
   drho2_rad(:) = drho1_rad(:)
   if (is_pcc == NONE) then
      vxpc_ps(:) = 0.d0 ; vcpc_ps(:) = 0.d0
      expc_ps(:) = 0.d0 ; ecpc_ps(:) = 0.d0
      expc_sum   = 0.d0 ; ecpc_sum   = 0.d0
   else
      call gga_fxc_rmesh( &
         ier,IFLOG,3,iord_diff,nmesh,1,                     &
         rpos,wr,rho1_rad,rho2_rad,drho1_rad,drho2_rad,     &
         fx_rad,fc_rad,dfx_rad,dfc_rad,dfxda_rad,dfcda_rad, &
         vxpc_ps,vcpc_ps,expc_ps,ecpc_ps,expc_sum,ecpc_sum)
      if (ier /= 0) then
         write(IFLOG,*) '### ERROR ### in gga_fxc_rmesh' ; go to 99
      end if
   end if
99 continue
   end subroutine calc_xc_gga_pw91_rad_ps

!=====================================================================
   subroutine calc_x_lda(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ir, ispin
   real(8) :: rho1, rho2, ex_tmp, ec_tmp, vx_tmp(2), vc_tmp(2)
   ier = 0
   do ir = 1,nmesh
      if (is_spin == POLARIZED) then
         rho1 = rho(ir,1) ; rho2 = rho(ir,2)
      else
         rho1 = rho(ir,1)*0.5d0 ; rho2 = rho1
      end if
      call lda_x(rho1,rho2,ex_tmp,ec_tmp,vx_tmp,vc_tmp)
      ex(ir) = ex_tmp
      ec(ir) = ec_tmp
      do ispin = 1,nspin
         vx(ir,ispin) = vx_tmp(ispin)
         vc(ir,ispin) = vc_tmp(ispin)
      end do
   end do
   end subroutine calc_x_lda

!=====================================================================
   subroutine calc_x_lda_ps(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ir
   real(8) :: rho1, rho2, rho1_tmp, &
              ex_tmp, ec_tmp, vx_tmp(2), vc_tmp(2)
   ier = 0
   do ir = 1,nmesh
      select case (is_pcc)
! ======================================== modified  by K. T. ============== 4.0
!      case (NONE)
!         rho1_tmp = rho_ps(ir)
!      case (PCC)
!         rho1_tmp = rho_ps(ir) + rho_pcore(ir)
!      case (FCC)
!         rho1_tmp = rho_ps(ir) + rho_core(ir)
!      end select
!
      case (NONE)
         rho1_tmp = rho_ps(ir,1)
      case (PCC)
         rho1_tmp = rho_ps(ir,1) + rho_pcore(ir)
      case (FCC)
         rho1_tmp = rho_ps(ir,1) + rho_core(ir)
      end select
! ========================================================================= 4.0

      rho1 = rho1_tmp*0.5d0 ; rho2 = rho1
      call lda_x(rho1,rho2,ex_tmp,ec_tmp,vx_tmp,vc_tmp)

      ex_ps(ir) = ex_tmp
      ec_ps(ir) = ec_tmp

! =============================== modiifed by K. T. ================= 4.0
!      vx_ps(ir) = vx_tmp(1)
!      vc_ps(ir) = vc_tmp(1)
      vx_ps(ir,1) = vx_tmp(1)
      vc_ps(ir,1) = vc_tmp(1)
! ======================================================================= 4.0

   end do
   end subroutine calc_x_lda_ps

!=====================================================================
   subroutine calc_x_gga(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ir, ispin
   real(8) :: r, rho1, rho2, ex_tmp, ec_tmp, vx_tmp(2), vc_tmp(2), &
              drho1, drho2, ddrho1, ddrho2
   ier = 0
   do ir = 1,nmesh
      if (is_spin == POLARIZED) then
            rho1 =    rho(ir,1) ;    rho2 =    rho(ir,2)
           drho1 =   drho(ir,1) ;   drho2 =   drho(ir,2)
          ddrho1 =  ddrho(ir,1) ;  ddrho2 =  ddrho(ir,2)
      else
            rho1 =    rho(ir,1)*0.5d0 ;    rho2 =    rho1
           drho1 =   drho(ir,1)*0.5d0 ;   drho2 =   drho1
          ddrho1 =  ddrho(ir,1)*0.5d0 ;  ddrho2 =  ddrho1
      end if
      r = rpos(ir)
      call gga_x(r,rho1,rho2,drho1,drho2,ddrho1,ddrho2, &
                 ex_tmp,ec_tmp,vx_tmp,vc_tmp)
      ex(ir) = ex_tmp
      ec(ir) = ec_tmp
      do ispin = 1,nspin
         vx(ir,ispin) = vx_tmp(ispin)
         vc(ir,ispin) = vc_tmp(ispin)
      end do
   end do
   end subroutine calc_x_gga

!=====================================================================
   subroutine calc_x_gga_ps(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ir
   real(8) :: r, rho1, rho2, &
              drho1, drho2, ddrho1, ddrho2, &
              rho1_tmp, &
              drho1_tmp, ddrho1_tmp, &
              ex_tmp, ec_tmp, vx_tmp(2), vc_tmp(2), &
              rhomin = 1.d-25
   ier = 0
   do ir = 1,nmesh
      select case (is_pcc)
! ======================================= modiified by K. T. ============= 4.0
!      case (NONE)
!           rho1_tmp =   rho_ps(ir)
!          drho1_tmp =  drho_ps(ir)
!         ddrho1_tmp = ddrho_ps(ir)
!      case (PCC)
!           rho1_tmp =   rho_ps(ir) +   rho_pcore(ir)
!          drho1_tmp =  drho_ps(ir) +  drho_pcore(ir)
!         ddrho1_tmp = ddrho_ps(ir) + ddrho_pcore(ir)
!      case (FCC)
!           rho1_tmp =   rho_ps(ir) +   rho_core(ir)
!          drho1_tmp =  drho_ps(ir) +  drho_core(ir)
!         ddrho1_tmp = ddrho_ps(ir) + ddrho_core(ir)
!      end select
!
      case (NONE)
           rho1_tmp =   rho_ps(ir,1)
          drho1_tmp =  drho_ps(ir,1)
         ddrho1_tmp = ddrho_ps(ir,1)
      case (PCC)
           rho1_tmp =   rho_ps(ir,1) +   rho_pcore(ir)
          drho1_tmp =  drho_ps(ir,1) +  drho_pcore(ir)
         ddrho1_tmp = ddrho_ps(ir,1) + ddrho_pcore(ir)
      case (FCC)
           rho1_tmp =   rho_ps(ir,1) +   rho_core(ir)
          drho1_tmp =  drho_ps(ir,1) +  drho_core(ir)
         ddrho1_tmp = ddrho_ps(ir,1) + ddrho_core(ir)
      end select
! ======================================================================== 4.0

        rho1 =    rho1_tmp*0.5d0 ;    rho2 =    rho1
       drho1 =   drho1_tmp*0.5d0 ;   drho2 =   drho1
      ddrho1 =  ddrho1_tmp*0.5d0 ;  ddrho2 =  ddrho1
      !### DEBUG ### [begin]
      if (rho1_tmp < rhomin) then
           rho1 = rhomin ;   rho2 = rho1
          drho1 =   0.d0 ;  drho2 = 0.d0
         ddrho1 =   0.d0 ; ddrho2 = 0.d0
      end if
      !### DEBUG ### [end]
      r = rpos(ir)
      call gga_x(r,rho1,rho2,drho1,drho2,ddrho1,ddrho2, &
                 ex_tmp,ec_tmp,vx_tmp,vc_tmp)
      ex_ps(ir) = ex_tmp
      ec_ps(ir) = ec_tmp

! ===================================== modified by K. T. =================== 4.0
!      vx_ps(ir) = vx_tmp(1)
!      vc_ps(ir) = vc_tmp(1)
      vx_ps(ir,1) = vx_tmp(1)
      vc_ps(ir,1) = vc_tmp(1)
! =========================================================================== 4.0
   end do
   end subroutine calc_x_gga_ps

!=====================================================================
   subroutine calc_xc_none(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ir, ispin
   ier = 0
   do ir = 1,nmesh
      ex(ir) = 0.d0
      ec(ir) = 0.d0
      do ispin = 1,nspin
         vx(ir,ispin) = 0.d0
         vc(ir,ispin) = 0.d0
      end do
   end do
   end subroutine calc_xc_none

!=====================================================================
   subroutine calc_xc_none_ps(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ir
   ier = 0
   do ir = 1,nmesh
      ex_ps(ir) = 0.d0
      ec_ps(ir) = 0.d0
! ===================================== modified by K. T. =========== 4.0
!      vx_ps(ir) = 0.d0
!      vc_ps(ir) = 0.d0
      vx_ps(ir,:) = 0.d0
      vc_ps(ir,:) = 0.d0
! =================================================================== 4.0
   end do
   end subroutine calc_xc_none_ps

! ************************************************************* 
!
!   This is a software package CIAO
!
!     developed as a part of the national project "Research and 
!     Development of Innovative Simulation software",which is   
!     supported by the next-generation IT program of MEXT of Japan
!
!   latest version: 
!
!     4.0:  2013/01/17 
!           codes for spin-polarized pseudopotential generation are added
!
! ************************************************************* 
!
!  Software name : CIAO (Code for Investigating Atomic Orbitals)
!  Subroutine(s) : sort_engy, set_focc, calc_efermi
!  Author(s)     : Masakuni Okamoto (August 25, 2003)
!
!  The license of the code and contact address :
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)
!
!=====================================================================
   subroutine sort_engy(ier)
!=====================================================================
!
!  Sorts energy levels
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ishell, jshell, imin
   ier = 0
   do ishell = 1,nshell
      list_shell(ishell) = ishell
   end do
   do ishell = 1,nshell-1
      imin = ishell
      do jshell = ishell+1,nshell
         if (engy(list_shell(jshell)) < engy(list_shell(imin))) then
            imin = jshell
         end if
      end do
      call iswap(list_shell(ishell),list_shell(imin))
   end do
99 continue
   end subroutine sort_engy

!=====================================================================
   subroutine set_focc(ier)
!=====================================================================
!
!  Sets focc
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ishell, lshell, nn, ll, ss, lspin
   real(8) :: ftot, sum
   ier = 0
   select case (is_spin_state)
   case (AUTOMATIC)
   foccnl_tmp(:,:,:) = foccnl(:,:,:)
   do ishell = 1,nshell
      lshell = list_shell(ishell)
      nn   = n_qnum(lshell)
      ll   = l_qnum(lshell)
      ftot = dble(nocc(lshell))
      if (ftot >= foccnl_tmp(nn,ll,1)) then
         focc(lshell) = foccnl_tmp(nn,ll,1)
         foccnl_tmp(nn,ll,1) = 0.d0
      else
         focc(lshell) = ftot
         foccnl_tmp(nn,ll,1) = foccnl_tmp(nn,ll,1) - ftot
      end if
   end do
   case (UD_SPECIFIED, SPIN_SPECIFIED)
   foccnls_tmp(:,:,:) = foccnls(:,:,:)
   do ishell = 1,nshell
      lshell = list_shell(ishell)
      nn   = n_qnum(lshell)
      ll   = l_qnum(lshell)
      ss   = spin  (lshell)
      lspin = 2 - (ss+1)/2
      ftot = dble(nocc(lshell))
      if (ftot >= foccnls_tmp(nn,ll,lspin)) then
         focc(lshell) = foccnls_tmp(nn,ll,lspin)
         foccnls_tmp(nn,ll,lspin) = 0.d0
      else
         focc(lshell) = ftot
         foccnls_tmp(nn,ll,lspin) = foccnls_tmp(nn,ll,lspin) - ftot
      end if
      write(IFLOG,*) 'ishell,lshell,focc ...',ishell,lshell,focc(lshell)
   end do
   end select
   do ishell = 1,nshell
      if ((focc(ishell) > 1.d-15).and.(is_solve(ishell) == 0)) then
         write(IFLOG,*) '### ERROR ### focc != 0 for is_solve = 0'
         write(IFLOG,*) '   ishell   ...', ishell
         write(IFLOG,*) '   label    ...', ' '//state(ishell)
         write(IFLOG,*) '   focc     ...', focc(ishell)
         write(IFLOG,*) '   is_solve ...', is_solve(ishell)
         ier =1 ; go to 99
      end if
   end do
   sum = 0.d0
   do ishell = 1,nshell
      if (is_solve(ishell) /= 0) then
         sum = sum + focc(ishell)
      end if
   end do
   if (abs(sum-felec) > eps_check) then
      write(IFLOG,*) '### ERROR ### sum of focc != felec'
      write(IFLOG,*) '   sum of focc ...',sum
      write(IFLOG,*) '   felec       ...',felec
      ier = 1 ; go to 99
   end if
99 continue
   end subroutine set_focc

!=====================================================================
   subroutine calc_efermi(ier)
!=====================================================================
!
!  Calculates Fermi level
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ishell, lshell
   ier = 0
   efermi = 0.d0
   do ishell = 1,nshell
      lshell = list_shell(ishell)
      if (abs(focc(lshell)) > 1.d-10) then
         efermi = engy(lshell)
      else
         exit
      end if
   end do
99 continue
   end subroutine calc_efermi

! ************************************************************* 
!
!   This is a software package CIAO
!
!     developed as a part of the national project "Research and 
!     Development of Innovative Simulation software",which is   
!     supported by the next-generation IT program of MEXT of Japan
!
!   latest version: 
!
!     4.0:  2013/01/17 
!           codes for spin-polarized pseudopotential generation are added
!
! ************************************************************* 
!
!  Software name : CIAO (Code for Investigating Atomic Orbitals)
!  Subroutine(s) : check_conv
!  Author(s)     : Masakuni Okamoto (August 25, 2003)
!
!  The license of the code and contact address :
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)
!
!=====================================================================
   subroutine check_conv(ier,is_conv,loop_scf)
!=====================================================================
!
!  Checks convergence of SCF calculation
!
!  M. Okamoto
!
!---------------------------------------------------------------------  
   use parameters   
   implicit none
   integer,intent(out)   :: ier
   integer,intent(inout) :: is_conv
   integer,intent(in)    :: loop_scf
   integer :: ishell, i
   real(8) :: dee_max, de, tmp
   ier = 0
   is_conv = NO
   do i = nsave_dee-1,1,-1
      dee_save(i+1) = dee_save(i)
   end do
   dee_save(1) = abs((etot_sum-etot_old)/etot_old)
   write(IFLOG,10) '### ETOT ### etot,dee ...', &
      loop_scf, etot_sum, dee_save(1)
   dee_max = dee_save(1)
   if ((loop_scf > nsave_dee).and.(nsave_dee >= 2)) then
      do i = 2,nsave_dee
         dee_max = max(dee_save(i),dee_max)
      end do
   end if
   de = abs(engy(1)-engy_old(1))
   do ishell = 1,nshell
      if (is_solve(ishell) /= 0) then
      tmp = abs(engy(ishell)-engy_old(ishell))
      de  = max(de,tmp)
      end if
   end do
   write(IFLOG,10) '#### DE #### de .........', &
      loop_scf, de
   if ((loop_scf > nsave_dee).and.(dee_max < dee_conv)) then
      is_conv = YES
      write(IFLOG,20) &
        'SCF calculation converged after',loop_scf,'iterations.'
      write(IFSUM,*)
      write(IFSUM,20) &
        'SCF calculation converged after',loop_scf,'iterations.'
   end if
   if (loop_scf > loop_conv) then
      write(IFLOG,30) &
       '### ERROR ### SCF loop count exceeded the limit',loop_conv,'.'
      write(IFSUM,*)
      write(IFSUM,30) &
       '### ERROR ### SCF loop count exceeded the limit',loop_conv,'.'
      ier = 1 ; go to 99
   end if
10 format(1x,a25,i7,2(1pe25.15))
20 format(1x,a31,(1x,i4,1x),a11)
30 format(1x,a47,(1x,i4),a1)
99 continue
   end subroutine check_conv

! ************************************************************* 
!
!   This is a software package CIAO
!
!     developed as a part of the national project "Research and 
!     Development of Innovative Simulation software",which is   
!     supported by the next-generation IT program of MEXT of Japan
!
!   latest version: 
!
!     4.0:  2013/01/17 
!           codes for spin-polarized pseudopotential generation are added
!
! ************************************************************* 
!
!  Software name : CIAO (Code for Investigating Atomic Orbitals)
!  Subroutine(s) : set_vion, calc_vh, calc_veff
!  Author(s)     : Masakuni Okamoto (August 25, 2003)
!
!  The license of the code and contact address :
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)
!
!=====================================================================
   subroutine set_vion(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ir, ll
   real(8) :: r, fn_patom_poly12, b_ok(0:3)
   ier = 0
   select case (is_core)
   case (NORMAL)
      vion(:,lmax_core) = - fatom / rpos(:)
   case (PATOM)
      do ll = 0,lmax_core
      do ir = 1,nmesh
         r = rpos(ir)
         if (r < rcut_core(ll)) then
            vion(ir,ll) = &
               fn_patom_poly12(r,fatom,rcut_core(ll),vcut_core(ll))
         else
            vion(ir,ll) = - fatom / r
         end if
      end do
      end do
   case (OZAKI_KINO)
      ll = lmax_core
      call calc_coeff_ok_poly3(fatom,rcut_ok,drcl_ok,h_ok,b_ok)
      do ir = 1,nmesh
         r = rpos(ir)
         if (r < rcut_ok - drcl_ok) then
            vion(ir,ll) = - fatom / r
         else if (r < rcut_ok) then
            vion(ir,ll) = &
               b_ok(0) + r*(b_ok(1) + r*(b_ok(2) + r*b_ok(3)))
         else
            vion(ir,ll) = h_ok
         end if
      end do
      do ir = nmesh,1,-1
         r = rpos(ir)
         if (r < rcut_ok) then
            nrcut_ok = ir+1 ; exit
         end if
      end do
   end select
99 continue
   end subroutine set_vion

!=====================================================================
   subroutine calc_vh(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ir, ii, i0, is, j, jr, ispin
   real(8) :: sum1, sum2
   ier = 0
   do ir = 1,nmesh
      sum1 = 0.d0
      sum2 = 0.d0
      if (ir == 1) then
         sum1 = 0.d0
      else if ((ir >= 2).and.(ir <= 5)) then
         do ii = 2,ir
            i0 = ii-1
            is = 1
            call set_open_weight_exp(ier,i0,is,rpos,wt)
            do ispin = 1,nspin
            do j = 1,4
               sum1 = sum1 &
                    + rpos(i0+j*is)**2*rho(i0+j*is,ispin)*wt(i0+j*is)
            end do
            end do
         end do
      else
         call set_weight_exp(ier,1,ir,rpos,wt)
         do ispin = 1,nspin
         do jr = 1,ir
            sum1 = sum1 + rpos(jr)**2*rho(jr,ispin)*wt(jr)
         end do
         end do
      end if
      sum1 = sum1*(4.d0*PI/rpos(ir))
      if (ir == nmesh) then
            sum2 = 0.d0
      else if ((ir <= nmesh-1).and.(ir >= nmesh-4)) then
         do ii = ir,nmesh-1
            i0 = ii+1
            is = -1
            call set_open_weight_exp(ier,i0,is,rpos,wt)
            do ispin = 1,nspin
            do j = 1,4
               sum2 = sum2 &
                    - rpos(i0+j*is)**2*rho(i0+j*is,ispin)*wt(i0+j*is)
            end do
            end do
         end do
      else
         call set_weight_exp(ier,ir,nmesh,rpos,wt)
         do ispin = 1,nspin
         do jr = ir,nmesh
            sum2 = sum2 + rpos(jr)*rho(jr,ispin)*wt(jr)
         end do
         end do
      end if
      sum2 = sum2*(4.d0*PI)
      vh(ir) = sum1 + sum2
   end do
99 continue
   end subroutine calc_vh

!=====================================================================
   subroutine calc_vxc(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: imode
   ier = 0
   select case (is_xc)
   case(LDAPZ81)
      call calc_xc_lda_pz81(ier)
      if (ier /= 0) then
         write(IFLOG,*) '### ERROR ### in calc_xc_lda_pz81'
         write(IFLOG,*) '   ier ...',ier ; go to 99
      end if
   case(LDAPW92_MOMO, LDAPW92_MOMO2)
      call calc_xc_lda_pw92(ier)
      if (ier /= 0) then
         write(IFLOG,*) '### ERROR ### in calc_xc_lda_pw92'
         write(IFLOG,*) '   ier ...',ier ; go to 99
      end if
   case(LDAPW92_GNCPP, GGAPBE96_GNCPP, GGAPBE96_KATO)
      ier = 1 ! call calc_xc_gga_gncpp(ier)
      if (ier /= 0) then
         write(IFLOG,*) '### ERROR ### in calc_xc_gga_gncpp'
         write(IFLOG,*) '   ier ...',ier ; go to 99
      end if
   case(GGAPW91_F90, GGAPW91_F77)
      ier = 1 ! call calc_xc_gga_gncpp(ier)
      if (ier /= 0) then
         write(IFLOG,*) '### ERROR ### in calc_xc_gga_gncpp(gga)'
         write(IFLOG,*) '   ier ...',ier ; go to 99
      end if
   case(GGAPBE96_MOMO)
      imode = 0
      call calc_xc_gga_pbe96(ier,imode)
      if (ier /= 0) then
         write(IFLOG,*) '### ERROR ### in calc_xc_gga_pbe96'
         write(IFLOG,*) '   ier   ...',ier
         write(IFLOG,*) '   imode ...',imode
         go to 99
      end if
   case(GGAPBE96_MOMO2)
      imode = 0
      call calc_xc_gga_pbe96_rad(ier,imode)
      if (ier /= 0) then
         write(IFLOG,*) '### ERROR ### in calc_xc_gga_pbe96_rad'
         write(IFLOG,*) '   ier   ...',ier
         write(IFLOG,*) '   imode ...',imode
         go to 99
      end if
   case(REVPBE)
      imode = 1
      call calc_xc_gga_pbe96(ier,imode)
      if (ier /= 0) then
         write(IFLOG,*) '### ERROR ### in calc_xc_gga_pbe96'
         write(IFLOG,*) '   ier   ...',ier
         write(IFLOG,*) '   imode ...',imode
         go to 99
      end if
   case(GGAPW91_MOMO, GGAPW91_MOMO2)
      call calc_xc_gga_pw91_rad(ier)
      if (ier /= 0) then
         write(IFLOG,*) '### ERROR ### in calc_xc_gga_pw91_rad'
         write(IFLOG,*) '   ier   ...',ier
         go to 99
      end if
   case(XLDA)
      call calc_x_lda(ier)
      if (ier /= 0) then
         write(IFLOG,*) '### ERROR ### in calc_x_lda'
         write(IFLOG,*) '   ier ...',ier ; go to 99
      end if
   case(XGGA)
      call calc_x_gga(ier)
      if (ier /= 0) then
         write(IFLOG,*) '### ERROR ### in calc_x_gga'
         write(IFLOG,*) '   ier ...',ier ; go to 99
      end if
   case(NONE)
      call calc_xc_none(ier)
      if (ier /= 0) then
         write(IFLOG,*) '### ERROR ### in calc_xc_none'
         write(IFLOG,*) '   ier ...',ier ; go to 99
      end if
   end select
99 continue
end subroutine calc_vxc

!=====================================================================
   subroutine calc_veff(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ispin, ll
   ier = 0
   call calc_vh(ier)
   if (ier /= 0) then
      write(IFLOG,*) '### ERROR ### in calc_vh'
      write(IFLOG,*) '   ier ...',ier ; go to 99
   end if
   call calc_vxc(ier)
   if (ier /= 0) then
      write(IFLOG,*) '### ERROR ### in calc_vxc'
      write(IFLOG,*) '   ier ...',ier ; go to 99
   end if
   do ll = 0,lmax_core
   do ispin = 1,nspin
      veff(:,ispin,ll) = vion(:,ll) + vh(:) &
                        + vx(:,ispin) + vc(:,ispin)
   end do
   end do
99 continue
   end subroutine calc_veff

! ************************************************************* 
!
!   This is a software package CIAO
!
!     developed as a part of the national project "Research and 
!     Development of Innovative Simulation software",which is   
!     supported by the next-generation IT program of MEXT of Japan
!
!   latest version: 
!
!     4.0:  2013/01/17 
!           codes for spin-polarized pseudopotential generation are added
!
! ************************************************************* 
!
!  Software name : CIAO (Code for Investigating Atomic Orbitals)
!  Subroutine(s) : calc_bound_state_loc, calc_bound_state_nonscf_sol
!                : calc_bound_state_ss, set_initpoints_right_sol
!                : int_from_right_sol, guess_de_sol, calc_beta_phi_sol
!                : calc_beta_phi_ss, set_initpoints_left_sol
!                : int_from_left_sol, pc_adams_5_sol
!                : write_energy_level_sol, write_energy_level_ss
!  Author(s)     : Masakuni Okamoto (August 25, 2003)
!
!  The license of the code and contact address :
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)
!
!=====================================================================
   subroutine calc_bound_state_loc(ier,IFLOG, &
                 iord_pc,iord_nec,iord_diff,dx,eps_de, &
                 nmesh,rpos,wr,vloc_scr,ll,node,ee_solved,is_solved)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   implicit none
   integer,intent(in)  :: IFLOG, iord_pc, iord_nec, iord_diff, &
                          nmesh, ll, node
   real(8),intent(in)  :: rpos(nmesh), wr(nmesh), vloc_scr(nmesh), &
                          dx, eps_de
   integer,intent(out) :: ier, is_solved
   real(8),intent(out) :: ee_solved
   real(8),allocatable :: bsum(:), rphi(:), wt(:), &
                          chi_gl(:), chi_fl(:), &
                          dxchi_gl(:), dxchi_fl(:), &
                          chi_gr(:), chi_fr(:), &
                          dxchi_gr(:), dxchi_fr(:)
   real(8),parameter   :: ARGMAX = 150.d0
   integer :: ir, node_sum, nmesh_max, loop, max_loop, &
              nrm, nrt, num_eslides, max_eslides, lguess
   real(8) :: vloc_min, ee, de, r, vv, ss, rr, fguess, gg_norm, &
              sign_gr, ee_upper_limit, ee_lower_limit,      &
              ee_upper_limit_in, engy_minimum, sum, etest, tmp
   ier = 0
  !++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   allocate(bsum(nmesh),rphi(nmesh),wt(nmesh), &
      chi_gl(nmesh),chi_fl(nmesh),dxchi_gl(nmesh),dxchi_fl(nmesh), &
      chi_gr(nmesh),chi_fr(nmesh),dxchi_gr(nmesh),dxchi_fr(nmesh))
      bsum = 0.d0 ; rphi = 0.d0 ; wt = 0.d0
      chi_gl   = 0.d0 ; chi_fl   = 0.d0
      dxchi_gl = 0.d0 ; dxchi_fl = 0.d0
      chi_gr   = 0.d0 ; chi_fr   = 0.d0
      dxchi_gr = 0.d0 ; dxchi_fr = 0.d0
  !++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   max_eslides  =  25
   max_loop     = 100
   engy_minimum = 1.d-4
   ee_solved    = 0.d0
   rphi(:)      = 0.d0
   is_solved    = 1
   write(IFLOG,*) 'SOL-LOC: ll,node ...',ll,node
   fguess = 1.d0
   lguess = 1
   node_sum = node
   if (mod(node,2) == 0) then
      sign_gr = +1.d0
   else
      sign_gr = -1.d0
   end if
   num_eslides = 0
      write(IFLOG,'(1x,a20,2i5)') &
         'SOL-LOC: ll,node ...',ll,node
   ee = ee_solved
   nmesh_max = nmesh
   do ir = nmesh,10,-1
      r  = rpos(ir)
      vv = vloc_scr(ir)
      ss = sqrt(2.d0*abs(ee-vv))
      if (ss*r < ARGMAX) then
         nmesh_max = ir ; exit
      end if
   end do
   vloc_min = 0.d0
   do ir = 1,nmesh
      r  = rpos(ir)
      vv = vloc_scr(ir)
      if (vv < vloc_min) then
         vloc_min = vv
      end if
   end do
   ee_upper_limit = vloc_scr(nmesh_max) - engy_minimum
   if (ee_upper_limit > -engy_minimum) then
      ee_upper_limit = -engy_minimum
   end if
   ee_upper_limit_in = ee_upper_limit
   ee_lower_limit = vloc_min
   ee = 0.5d0*(ee_upper_limit + ee_lower_limit)
   de = ee
   loop = 0
SRCH_EE:do while (abs(de) > eps_de)
   loop = loop + 1
   if (loop > max_loop) then
      if (lguess < 3) then
         lguess = lguess + 1
         fguess = fguess * 0.5d0
         max_loop = max_loop * 2
         loop = 0
         node_sum = node
         cycle SRCH_EE
      end if
      if (node_sum < node) then
         write(IFLOG,*) '### CAUTION ### node_sum < node'
         write(IFLOG,*) '   node_sum,node ...',node_sum,node
         write(IFLOG,*) &
            '   Following state may be an unbound state.'
         write(IFLOG,*) '      ll ...',ll
         is_solved = 0 ; ee = 0.d0 ; exit SRCH_EE
      else
         write(IFLOG,*) '### ERROR ### loop > max_loop'
         write(IFLOG,*) '   loop, max_loop ...',loop,max_loop
         write(IFLOG,*) '   ll,node        ...',ll,node
         write(IFLOG,*) '   node_sum,node  ...',node_sum,node
         write(IFLOG,*) '   ee_upper_limit ...',ee_upper_limit
         write(IFLOG,*) '   ee_lower_limit ...',ee_lower_limit
         write(IFLOG,*) '   ee             ...',ee
         write(IFLOG,*) '   de             ...',de
         ier=1 ; go to 99
      end if
   end if
   if (num_eslides > max_eslides) then
      write(IFLOG,*) '### CAUTION ### Eigenvalue was not converged !'
      write(IFLOG,*) '      num_eslides  ...',num_eslides
      write(IFLOG,*) '      max_eslides  ...',max_eslides
      write(IFLOG,*) '   Following state may be an unbound state.'
      write(IFLOG,*) '      ll           ...',ll
      is_solved = 0 ; ee = 0.d0 ; exit SRCH_EE
   end if
SRCH_RT:do ir = nmesh_max,10,-1
      r = rpos(ir)
      tmp = vloc_scr(ir)-ee
      if (tmp < 0.d0) then
         nrt = ir ; exit SRCH_RT
      end if
   end do SRCH_RT
   bsum = 0.d0
   call set_initpoints_left_sol(ier,nmesh,ll,ee,rpos, &
           chi_gl,chi_fl,dxchi_gl,dxchi_fl,vloc_scr,bsum)
   call int_from_left_sol(ier,nmesh,node_sum,nrt, &
           ll,ee,iord_nec,dx,rpos, &
           chi_gl,chi_fl,dxchi_gl,dxchi_fl,vloc_scr,bsum)
   if (ier /= 0) then
      write(IFLOG,*) '### ERROR ### in int_from_left_sol'
      go to 99
   end if
   do ir = 1,nrt
      r = rpos(ir)
      chi_fl(ir) = dxchi_gl(ir)/r - dble(ll+1)/r*chi_gl(ir)
   end do
   if (node_sum > node) then
      if (ee < ee_upper_limit) then
         ee_upper_limit = ee
      end if
      if (ee_upper_limit > ee_upper_limit_in) then
         ee_upper_limit = ee_upper_limit_in
      end if
      ee = 0.5d0*(ee + ee_lower_limit)
      ee_lower_limit = ee_lower_limit * 1.2d0
      cycle SRCH_EE
   else if (node_sum < node) then
      if (ee > ee_lower_limit) then
         ee_lower_limit = ee
      end if
      ee = 0.5d0*(ee_upper_limit + ee)
      ee_upper_limit = ee_upper_limit_in
      ee = 0.5d0*(ee_upper_limit + ee)
      cycle SRCH_EE
   end if
      nrm = nrt
SRCH_RM:do ir = nrt,10,-1
      if (sign_gr*(chi_gl(ir-1)-chi_gl(ir)) < 0.d0) then
         nrm = ir ; exit SRCH_RM
      end if
   end do SRCH_RM
   nmesh_max = nmesh
   do ir = nmesh,10,-1
      r  = rpos(ir)
      vv = vloc_scr(ir)
      ss = sqrt(2.d0*abs(ee-vv))
      if (ss*r < ARGMAX) then
         nmesh_max = ir ; exit
      end if
   end do
   if (nmesh_max < nmesh) then
      r  = rpos(nmesh_max)
      vv = vloc_scr(nmesh_max)
      ss = sqrt(2.d0*abs(ee-vv))
      do ir = nmesh_max+1,nmesh
         r  = rpos(ir)
         vv = vloc_scr(ir)
         ss = sqrt(2.d0*abs(ee-vv))
         chi_gr(ir) = exp(-ss*r) * sign_gr
         chi_fr(ir) = -ss * chi_gr(ir) 
         dxchi_gr(ir) = 0.d0
         dxchi_fr(ir) = 0.d0
      end do
   end if
   call set_initpoints_right_sol(ier,nmesh,nmesh_max,ll,ee,rpos, &
           chi_gr,chi_fr,dxchi_gr,dxchi_fr,vloc_scr,bsum,sign_gr)
   if (ier /= 0) then
      write(IFLOG,*) '### ERROR ### in set_initpoints_right_sol'
      go to 99
   end if
   nrt = nrm - 1 - max(iord_pc,iord_diff)
   call int_from_right_sol(ier,nmesh,nmesh_max,nrt, &
           ll,ee,iord_nec,dx,rpos, &
           chi_gr,chi_fr,dxchi_gr,dxchi_fr,vloc_scr,bsum)
   if (ier /= 0) then
      write(IFLOG,*) '### ERROR ### in int_from_right_sol'
      go to 99
   end if
   rr = chi_gl(nrm) / chi_gr(nrm)
   do ir = nmesh,nrt,-1
        chi_gr(ir) =   chi_gr(ir) * rr
        chi_fr(ir) =   chi_fr(ir) * rr
      dxchi_gr(ir) = dxchi_gr(ir) * rr
      dxchi_fr(ir) = dxchi_fr(ir) * rr
   end do
   call guess_de_sol(ier,IFLOG,nmesh,nrm,rpos,wt, &
           chi_gl,chi_fl,chi_gr,chi_fr,de,fguess,gg_norm)
   if (ier /= 0) then
      write(IFLOG,*) '### ERROR ### in guess_de' ; go to 99
   end if
   if (de > 0.d0) then
      ee_lower_limit = ee
   else if (de < 0.d0) then
      ee_upper_limit = ee
      if (ee_upper_limit > ee_upper_limit_in) then
         ee_upper_limit = ee_upper_limit_in
      end if
   end if
   etest = ee + de
   if ((etest-ee_upper_limit)*(etest-ee_lower_limit) < 0.d0) then
      ee = etest
   else
      ee = 0.5d0*(ee_upper_limit + ee_lower_limit)
      num_eslides = num_eslides + 1
   end if
      write(IFLOG,'(1x,a25,i5,f25.15,1pe20.10)') &
        '### SLOC ### ll,ee,de ...',ll,ee,de
end do SRCH_EE
   if (is_solved /= 0) then
      ee_solved = ee
   else
      ee_solved = 0.d0
   end if
   if (is_solved /= 0) then
      do ir = 1,nrm
         rphi(ir) = chi_gl(ir)
      end do
      do ir = nrm,nmesh
         rphi(ir) = chi_gr(ir)
      end do
   else
      rphi(:) = 0.d0
   end if
   if (is_solved /= 0) then
      sum = 0.d0
      do ir = 1,nmesh
         sum = sum + rphi(ir)**2*wr(ir)
      end do
      rphi(:) = rphi(:)/sqrt(sum)*sign_gr
   end if
   do ir = 1,nmesh
      if (abs(rphi(ir)) < 1.d-99) then
         rphi(ir) = 0.d0
      end if
   end do
99 continue
  !++++++++++++++++++++++++++++++++++++++
   deallocate(bsum,rphi,wt, &
      chi_gl,chi_fl,dxchi_gl,dxchi_fl, &
      chi_gr,chi_fr,dxchi_gr,dxchi_fr)
  !++++++++++++++++++++++++++++++++++++++
   end subroutine calc_bound_state_loc

!=====================================================================
   subroutine calc_bound_state_nonscf_sol(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   real(8),allocatable :: &
      bsum(:), amat(:,:), bvec(:), coeff(:), fmat(:,:), hmat(:,:), &
      h0vec(:), rphi_gl(:,:), dxrphi_gl(:,:)
   integer :: ir, ips, ishell, nn, ll, tt, lt, t1, t2, lt1, lt2, &
              ltt, nref, loop, nrm, nrt, node_sum, nmesh_max, &
              max_loop, lguess, nn_sol(0:3), node
   real(8) :: ee, de, r, sign_gr, vv, ss, rr, sum, fguess, gg_norm, &
              eps_de_tmp = 1.d-9, sign_phi
  !++++++++++++++++++++++++++++++++++++
   allocate(bsum(nmesh)) ; bsum = 0.d0
  !++++++++++++++++++++++++++++++++++++
   engy_sol(:)       = 0.d0
   rphi_sol(:,:)     = 0.d0
   beta_phi_sol(:,:) = 0.d0
   nn_sol(:)         = 0
   write(IFLOG,*) 'SOL: nps ...',nps
L_PS:do ips = 1,nps
      ishell = ishell_ps(ips,1)
      if (is_solve(ishell) == 0) then
         cycle L_PS
      end if
      nn = n_qnum(ishell)
      ll = l_qnum(ishell)
      nref = nref_us(ll)
     !++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      allocate(amat(nref,nref),bvec(nref),coeff(nref), &
               fmat(nref,nref),hmat(nref,nref),h0vec(nref), &
               rphi_gl(nmesh,0:nref),dxrphi_gl(nmesh,0:nref))
         amat = 0.d0 ; bvec = 0.d0 ; coeff = 0.d0
         fmat = 0.d0 ; hmat = 0.d0 ; h0vec = 0.d0
         rphi_gl = 0.d0 ; dxrphi_gl = 0.d0
     !++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      if (nn_sol(ll) == 0) then
         nn_sol(ll) = nn
         node = 0
      else if (nn_sol(ll) /= 0) then
         node = nn - nn_sol(ll)
      end if
      node_sum = node
      max_loop = 50
      fguess = 0.5d0
      lguess = 1
      ee  = engy(ishell)
      de  = ee
      nrm = max(nrm_pos(ishell),nrcut_max_us)
      loop = 0
SRCH_EE:do while (abs(de) > eps_de_tmp)
      loop = loop + 1
      if ((loop > max_loop).or.(node_sum /= node)) then
         write(IFLOG,*) &
            '### CAUTION ### loop > max_loop or node_sum != node'
         write(IFLOG,*) '   loop     ...',loop
         write(IFLOG,*) '   max_loop ...',max_loop
         write(IFLOG,*) '   lguess   ...',lguess
         write(IFLOG,*) '   fguess   ...',fguess
         write(IFLOG,*) '   (n,l)    ...',nn,ll
         write(IFLOG,*) '   node_sum ...',node_sum
         write(IFLOG,*) '   node     ...',node
         write(IFLOG,*) '   ee       ...',ee
         write(IFLOG,*) '   de       ...',de
         if (lguess > 1) then
            write(IFLOG,*) '### ERROR ### lguess > 1'
            ier = 1 ; go to 99
         else
            lguess = lguess + 1
            fguess = fguess * 0.5d0
            max_loop = max_loop * 2
            loop = 0
            node_sum = node
            ee = engy(ishell)
            de = ee
            write(IFLOG,*) 'Reset parameters & continue calculation'
            write(IFLOG,*) '   loop     ...',loop
            write(IFLOG,*) '   max_loop ...',max_loop
            write(IFLOG,*) '   lguess   ...',lguess
            write(IFLOG,*) '   fguess   ...',fguess
            write(IFLOG,*) '   ee       ...',ee
            cycle SRCH_EE
         end if
      end if
      nrt = nrm + 1 + max(iord_pc,iord_diff)
      bsum = 0.d0
      call set_initpoints_left_sol(ier,nmesh,ll,ee,rpos, &
              chi_gl,chi_fl,dxchi_gl,dxchi_fl,vloc_scr_sol,bsum)
      call int_from_left_sol(ier,nmesh,node_sum,nrt, &
              ll,ee,iord_nec,dx,rpos, &
              chi_gl,chi_fl,dxchi_gl,dxchi_fl,vloc_scr_sol,bsum)
      if (ier /= 0) then
         write(IFLOG,*) '### ERROR ### in int_from_left_sol [0]'
         go to 99
      end if
      rphi_gl(:,0)   = chi_gl(:)
      dxrphi_gl(:,0) = dxchi_gl(:)
      do tt = 1,nref
         lt = lt_n_us(ll,tt)
         bsum(:) = -rbeta_us(:,lt)
         call set_initpoints_left_sol(ier,nmesh,ll,ee,rpos, &
                 chi_gl,chi_fl,dxchi_gl,dxchi_fl,vloc_scr_sol,bsum)
         call int_from_left_sol(ier,nmesh,node_sum,nrt, &
                 ll,ee,iord_nec,dx,rpos, &
                 chi_gl,chi_fl,dxchi_gl,dxchi_fl,vloc_scr_sol,bsum)
         if (ier /= 0) then
            write(IFLOG,*) '### ERROR ### in int_from_left_sol [1]'
            go to 99
         end if
         rphi_gl(:,tt)   = chi_gl(:)
         dxrphi_gl(:,tt) = dxchi_gl(:)
      end do
      fmat(:,:) = 0.d0
      do t1 = 1,nref
         lt1 = lt_n_us(ll,t1)
         do t2 = 1,nref
            ltt = ltt_nm_us(ll,t1,t2)
            fmat(t1,t2) = dmat_us(ltt) - ee*q_sum_us(ltt)
            sum = 0.d0
            do ir = 1,nmesh
               sum = sum + rbeta_us(ir,lt1)*rphi_gl(ir,t2)*wr(ir)
            end do
            hmat(t1,t2) = sum
         end do
      end do
      amat = matmul(fmat,hmat)
      do tt = 1,nref
         amat(tt,tt) = amat(tt,tt) + 1.d0
         lt = lt_n_us(ll,tt)
         sum = 0.d0
         do ir = 1,nmesh
            sum = sum + rbeta_us(ir,lt)*rphi_gl(ir,0)*wr(ir)
         end do
         h0vec(tt) = sum
      end do
      bvec = -matmul(fmat,h0vec)
      call axb_real_matrix(ier,nref,1,amat,coeff,bvec)
      chi_gl(:)   = rphi_gl(:,0)
      dxchi_gl(:) = dxrphi_gl(:,0)
      do tt = 1,nref
         chi_gl(:) = chi_gl(:) + coeff(tt)*rphi_gl(:,tt)
         dxchi_gl(:) = dxchi_gl(:) + coeff(tt)*dxrphi_gl(:,tt)
      end do
      do ir = 1,nrt
         r = rpos(ir)
         chi_fl(ir) = dxchi_gl(ir)/r - dble(ll+1)/r*chi_gl(ir)
      end do
      call calc_nodes_us(nmesh,chi_gl,nrm,node_sum)
      if (mod(node_sum,2) == 0) then
         sign_gr = +1.d0
      else
         sign_gr = -1.d0
      end if
      nmesh_max = nmesh
      do ir = nmesh,10,-1
         r  = rpos(ir)

! =========================================== modified by K. T. ===============4.0
!         vv = vloc_scr_sol(ir)
         vv = vloc_scr_sol(ir,1)
! ============================================================================= 4.0
         ss = sqrt(2.d0*abs(ee-vv))
         if (ss*r < ARGMAX) then
            nmesh_max = ir ; exit
         end if
      end do
      if (nmesh_max < nmesh) then
         r  = rpos(nmesh_max)

! ============================================ modified by K. T. ============== 4.0
!         vv = vloc_scr_sol(nmesh_max)
         vv = vloc_scr_sol(nmesh_max,1)
! ============================================================================= 4.0

         ss = sqrt(2.d0*abs(ee-vv))
         do ir = nmesh_max+1,nmesh
            r  = rpos(ir)

! =========================================== modified by K. T. ============= 4.0
!            vv = vloc_scr_sol(ir)
            vv = vloc_scr_sol(ir,1)
! ============================================================================ 4.0
            ss = sqrt(2.d0*abs(ee-vv))
            chi_gr(ir) = exp(-ss*r) * sign_gr
            chi_fr(ir) = -ss * chi_gr(ir) 
            dxchi_gr(ir) = 0.d0
            dxchi_fr(ir) = 0.d0
         end do
      end if
      call set_initpoints_right_sol(ier, &
              nmesh,nmesh_max,ll,ee,rpos, &
              chi_gr,chi_fr,dxchi_gr,dxchi_fr,vloc_scr_sol,bsum, &
              sign_gr)
      if (ier /= 0) then
         write(IFLOG,*) '### ERROR ### in set_initpoints_right_sol'
         go to 99
      end if
      nrt = nrm - 1 - max(iord_pc,iord_diff)
      call int_from_right_sol(ier,nmesh,nmesh_max,nrt, &
              ll,ee,iord_nec,dx,rpos, &
              chi_gr,chi_fr,dxchi_gr,dxchi_fr,vloc_scr_sol,bsum)
      if (ier /= 0) then
         write(IFLOG,*) '### ERROR ### in int_from_right_sol'
         go to 99
      end if
      rr = chi_gl(nrm) / chi_gr(nrm)
      do ir = nmesh,nrt,-1
           chi_gr(ir) =   chi_gr(ir) * rr
           chi_fr(ir) =   chi_fr(ir) * rr
         dxchi_gr(ir) = dxchi_gr(ir) * rr
         dxchi_fr(ir) = dxchi_fr(ir) * rr
      end do
      call guess_de_sol(ier,IFLOG,nmesh,nrm,rpos,wt, &
              chi_gl,chi_fl,chi_gr,chi_fr,de,fguess,gg_norm)
      if (ier /= 0) then
         write(IFLOG,*) '### ERROR ### in guess_de' ; go to 99
      end if
      ee = ee + de
      write(IFLOG,'(1x,a33,3i3,2(1pe20.10))') &
         '### SEE ### ips,ll,node,ee,de ...',ips,ll,node_sum,ee,de
end do SRCH_EE
      engy_sol(ips) = ee
      do ir = 1,nrm
         rphi_sol(ir,ips) = chi_gl(ir)
      end do
      do ir = nrm,nmesh
         rphi_sol(ir,ips) = chi_gr(ir)
      end do
      call calc_beta_phi_sol(ier,ips)
      sum = 0.d0
      do ir = 1,nmesh
         sum = sum + rphi_sol(ir,ips)**2*wr(ir)
      end do
      do t1 = 1,nref
      do t2 = 1,nref
         lt1 = lt_n_us(ll,t1)
         lt2 = lt_n_us(ll,t2)
         ltt = ltt_nm_us(ll,t1,t2)
         sum = sum + q_sum_us(ltt) &
                   * beta_phi_sol(lt1,ips) &
                   * beta_phi_sol(lt2,ips)
      end do
      end do
      sign_phi = sign(1.d0,rphi_sol(nmesh,ips))
      !rphi_sol(:,ips) = rphi_sol(:,ips)/sqrt(sum)*sign_gr
      rphi_sol(:,ips) = rphi_sol(:,ips)/sqrt(sum)*sign_phi
      call calc_beta_phi_sol(ier,ips)
      do ir = 1,nmesh
         if (abs(rphi_sol(ir,ips)) < 1.d-99) then
            rphi_sol(ir,ips) = 0.d0
         end if
      end do
     !++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      deallocate(amat,bvec,coeff,fmat,hmat,h0vec,rphi_gl,dxrphi_gl)
     !++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
end do L_PS
99 continue
  !+++++++++++++++++
   deallocate(bsum)
  !+++++++++++++++++
   end subroutine calc_bound_state_nonscf_sol

!============================= added by K. T. ============================ 4.0
subroutine calc_bound_state_nonscf_sol_kt(ier)
  use parameters
  implicit none

  integer,intent(out) :: ier

  real(8),allocatable :: &
       bsum(:), amat(:,:), bvec(:), coeff(:), fmat(:,:), hmat(:,:), &
       h0vec(:), rphi_gl(:,:), dxrphi_gl(:,:)

  integer :: ir, ips, ishell, nn, ll, tt, lt, t1, t2, lt1, lt2, &
       ltt, nref, loop, nrm, nrt, node_sum, nmesh_max, &
       max_loop, lguess, nn_sol(0:3), node

  real(8) :: ee, de, r, sign_gr, vv, ss, rr, sum, fguess, gg_norm, &
       eps_de_tmp = 1.d-9, sign_phi

  integer :: ispin, itmp1, itmp2

  !++++++++++++++++++++++++++++++++++++
  allocate(bsum(nmesh)) ; bsum = 0.d0
  !++++++++++++++++++++++++++++++++++++
  engy_sol(:)       = 0.d0
  rphi_sol(:,:)     = 0.d0
  beta_phi_sol(:,:) = 0.d0
  nn_sol(:)         = 0
  write(IFLOG,*) 'SOL: nps ...',nps

  L_PS:do ips = 1,nps

     ishell = ishell_ps(ips,1)
     if (is_solve(ishell) == 0) then
        cycle L_PS
     end if

     nn = n_qnum(ishell)
     ll = l_qnum(ishell)
     nref = nref_us(ll)

     ispin = ( 1-spin(ishell) ) /2 +1

     !++++++++++++++++++++++++++++++++++++++++++++++++++++++++
     allocate(amat(nref,nref),bvec(nref),coeff(nref), &
          fmat(nref,nref),hmat(nref,nref),h0vec(nref), &
          rphi_gl(nmesh,0:nref),dxrphi_gl(nmesh,0:nref))
     amat = 0.d0 ; bvec = 0.d0 ; coeff = 0.d0
     fmat = 0.d0 ; hmat = 0.d0 ; h0vec = 0.d0
     rphi_gl = 0.d0 ; dxrphi_gl = 0.d0
     !++++++++++++++++++++++++++++++++++++++++++++++++++++++++

     if (nn_sol(ll) == 0) then
        nn_sol(ll) = nn
        node = 0
     else if (nn_sol(ll) /= 0) then
        node = nn - nn_sol(ll)
     end if

     node_sum = node
     max_loop = 50
     fguess = 0.5d0
     lguess = 1

     ee  = engy(ishell)
     de  = ee

     nrm = max(nrm_pos(ishell),nrcut_max_us)
     loop = 0

     SRCH_EE:do while (abs(de) > eps_de_tmp)
        loop = loop + 1

        if ((loop > max_loop).or.(node_sum /= node)) then
           write(IFLOG,*) &
                '### CAUTION ### loop > max_loop or node_sum != node'
           write(IFLOG,*) '   loop     ...',loop
           write(IFLOG,*) '   max_loop ...',max_loop
           write(IFLOG,*) '   lguess   ...',lguess
           write(IFLOG,*) '   fguess   ...',fguess
           write(IFLOG,*) '   (n,l)    ...',nn,ll
           write(IFLOG,*) '   node_sum ...',node_sum
           write(IFLOG,*) '   node     ...',node
           write(IFLOG,*) '   ee       ...',ee
           write(IFLOG,*) '   de       ...',de

           if (lguess > 1) then
              write(IFLOG,*) '### ERROR ### lguess > 1'
              ier = 1 ; go to 99
           else
              lguess = lguess + 1
              fguess = fguess * 0.5d0
              max_loop = max_loop * 2
              loop = 0
              node_sum = node
              ee = engy(ishell)
              de = ee
              write(IFLOG,*) 'Reset parameters & continue calculation'
              write(IFLOG,*) '   loop     ...',loop
              write(IFLOG,*) '   max_loop ...',max_loop
              write(IFLOG,*) '   lguess   ...',lguess
              write(IFLOG,*) '   fguess   ...',fguess
              write(IFLOG,*) '   ee       ...',ee
              cycle SRCH_EE
           end if

        end if

        nrt = nrm + 1 + max(iord_pc,iord_diff)

        bsum = 0.d0
        call set_initpoints_left_sol(ier,nmesh,ll,ee,rpos, &
             & chi_gl,chi_fl,dxchi_gl,dxchi_fl,&
             & vloc_scr_sol(:,ispin),bsum )

        call int_from_left_sol(ier,nmesh,node_sum,nrt, &
             & ll,ee,iord_nec,dx,rpos, &
             & chi_gl,chi_fl,dxchi_gl,dxchi_fl, &
             & vloc_scr_sol(:,ispin),bsum )

        if (ier /= 0) then
           write(IFLOG,*) '### ERROR ### in int_from_left_sol [0]'
           go to 99
        end if

        rphi_gl(:,0)   = chi_gl(:)
        dxrphi_gl(:,0) = dxchi_gl(:)

        do tt = 1, nref

           itmp1 = tt + nref_max_us *(ispin -1)
           lt = lt_n_us(ll,itmp1)

           bsum(:) = -rbeta_us(:,lt)

           call set_initpoints_left_sol(ier,nmesh,ll,ee,rpos, &
                & chi_gl,chi_fl,dxchi_gl,dxchi_fl, &
                & vloc_scr_sol(:,ispin),bsum )

           call int_from_left_sol(ier,nmesh,node_sum,nrt, &
                & ll,ee,iord_nec,dx,rpos, &
                & chi_gl,chi_fl,dxchi_gl,dxchi_fl, &
                & vloc_scr_sol(:,ispin),bsum )

           if (ier /= 0) then
              write(IFLOG,*) '### ERROR ### in int_from_left_sol [1]'
              go to 99
           end if

           rphi_gl(:,tt)   = chi_gl(:)
           dxrphi_gl(:,tt) = dxchi_gl(:)
        end do

        fmat(:,:) = 0.d0

        do t1 = 1,nref
           itmp1 = t1 + nref_max_us *( ispin -1 )
           lt1 = lt_n_us(ll,itmp1)

           do t2 = 1,nref
              itmp2 = t2 + nref_max_us *( ispin -1 )

              ltt = ltt_nm_us(ll,itmp1,itmp2)

              fmat(t1,t2) = dmat_us(ltt) - ee*q_sum_us(ltt)
              sum = 0.d0
              do ir = 1,nmesh
                 sum = sum + rbeta_us(ir,lt1)*rphi_gl(ir,t2)*wr(ir)
              end do
              hmat(t1,t2) = sum
           end do
        end do

        amat = matmul(fmat,hmat)

        do tt = 1,nref
           amat(tt,tt) = amat(tt,tt) + 1.d0

           itmp1 = tt + nref_max_us *(ispin -1 )
           lt = lt_n_us(ll,itmp1)

           sum = 0.d0
           do ir = 1,nmesh
              sum = sum + rbeta_us(ir,lt)*rphi_gl(ir,0)*wr(ir)
           end do
           h0vec(tt) = sum
        end do

        bvec = -matmul(fmat,h0vec)

        call axb_real_matrix(ier,nref,1,amat,coeff,bvec)

        chi_gl(:)   = rphi_gl(:,0)
        dxchi_gl(:) = dxrphi_gl(:,0)
        
        do tt = 1,nref
           chi_gl(:) = chi_gl(:) + coeff(tt)*rphi_gl(:,tt)
           dxchi_gl(:) = dxchi_gl(:) + coeff(tt)*dxrphi_gl(:,tt)
        end do

        do ir = 1,nrt
           r = rpos(ir)
           chi_fl(ir) = dxchi_gl(ir)/r - dble(ll+1)/r*chi_gl(ir)
        end do

        call calc_nodes_us(nmesh,chi_gl,nrm,node_sum)
        if (mod(node_sum,2) == 0) then
           sign_gr = +1.d0
        else
           sign_gr = -1.d0
        end if

        nmesh_max = nmesh

        do ir = nmesh,10,-1
           r  = rpos(ir)

           vv = vloc_scr_sol(ir,ispin)

           ss = sqrt(2.d0*abs(ee-vv))
           if (ss*r < ARGMAX) then
              nmesh_max = ir ; exit
           end if
        end do

        if (nmesh_max < nmesh) then
           r  = rpos(nmesh_max)

           vv = vloc_scr_sol(nmesh_max,ispin)

           ss = sqrt(2.d0*abs(ee-vv))
           do ir = nmesh_max+1,nmesh
              r  = rpos(ir)
              
              vv = vloc_scr_sol(ir,ispin)

              ss = sqrt(2.d0*abs(ee-vv))
              chi_gr(ir) = exp(-ss*r) * sign_gr
              chi_fr(ir) = -ss * chi_gr(ir) 
              dxchi_gr(ir) = 0.d0
              dxchi_fr(ir) = 0.d0
           end do
        end if

        call set_initpoints_right_sol(ier, &
             & nmesh,nmesh_max,ll,ee,rpos, &
             & chi_gr,chi_fr,dxchi_gr,dxchi_fr,&
             & vloc_scr_sol(:,ispin), bsum, &
             & sign_gr )

        if (ier /= 0) then
           write(IFLOG,*) '### ERROR ### in set_initpoints_right_sol'
           go to 99
        end if

        nrt = nrm - 1 - max(iord_pc,iord_diff)

        call int_from_right_sol(ier,nmesh,nmesh_max,nrt, &
             & ll,ee,iord_nec,dx,rpos, &
             & chi_gr,chi_fr,dxchi_gr,dxchi_fr, &
             & vloc_scr_sol(:,ispin), bsum )

        if (ier /= 0) then
           write(IFLOG,*) '### ERROR ### in int_from_right_sol'
           go to 99
        end if

        rr = chi_gl(nrm) / chi_gr(nrm)
        do ir = nmesh,nrt,-1
           chi_gr(ir) =   chi_gr(ir) * rr
           chi_fr(ir) =   chi_fr(ir) * rr
           dxchi_gr(ir) = dxchi_gr(ir) * rr
           dxchi_fr(ir) = dxchi_fr(ir) * rr
        end do

        call guess_de_sol(ier,IFLOG,nmesh,nrm,rpos,wt, &
             chi_gl,chi_fl,chi_gr,chi_fr,de,fguess,gg_norm)
        if (ier /= 0) then
           write(IFLOG,*) '### ERROR ### in guess_de' ; go to 99
        end if

        ee = ee + de
        write(IFLOG,'(1x,a33,3i3,2(1pe20.10))') &
             '### SEE ### ips,ll,node,ee,de ...',ips,ll,node_sum,ee,de

     end do SRCH_EE

     engy_sol(ips) = ee
     do ir = 1,nrm
        rphi_sol(ir,ips) = chi_gl(ir)
     end do

     do ir = nrm,nmesh
        rphi_sol(ir,ips) = chi_gr(ir)
     end do

     call calc_beta_phi_sol_kt(ier,ips)

     sum = 0.d0
     do ir = 1,nmesh
        sum = sum + rphi_sol(ir,ips)**2*wr(ir)
     end do

     do t1 = 1,nref
        do t2 = 1,nref
           itmp1 = t1 + nref_max_us * (ispin -1)
           itmp2 = t2 + nref_max_us * (ispin -1)

           lt1 = lt_n_us(ll,itmp1)
           lt2 = lt_n_us(ll,itmp2)

           ltt = ltt_nm_us(ll,itmp1,itmp2)

           sum = sum + q_sum_us(ltt) &
                * beta_phi_sol(lt1,ips) &
                * beta_phi_sol(lt2,ips)
        end do
     end do

     sign_phi = sign(1.d0,rphi_sol(nmesh,ips))
      !rphi_sol(:,ips) = rphi_sol(:,ips)/sqrt(sum)*sign_gr
     rphi_sol(:,ips) = rphi_sol(:,ips)/sqrt(sum)*sign_phi

     call calc_beta_phi_sol_kt(ier,ips)
     do ir = 1,nmesh
        if (abs(rphi_sol(ir,ips)) < 1.d-99) then
           rphi_sol(ir,ips) = 0.d0
        end if
     end do

     !++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
     deallocate(amat,bvec,coeff,fmat,hmat,h0vec,rphi_gl,dxrphi_gl)
     !++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

  end do L_PS

99 continue
  !+++++++++++++++++
  deallocate(bsum)
  !+++++++++++++++++

end subroutine calc_bound_state_nonscf_sol_kt
! ======================================================================= 4.0
   
!=====================================================================
   subroutine calc_bound_state_ss(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   real(8),allocatable :: &
      bsum(:), amat(:,:), bvec(:), coeff(:), fmat(:,:), hmat(:,:), &
      h0vec(:), rphi_gl(:,:), dxrphi_gl(:,:)
   integer :: ir, iss, ishell, nn, ll, tt, lt, t1, t2, lt1, lt2, &
              ltt, nref, nrm, nrt, node_sum, node, nmesh_max, &
              num_eslides, max_eslides, loop, max_loop, ispin, &
              nn_ss(0:3), lguess, max_loop_in
   real(8) :: ee, de, r, vv, ss, rr, &
              sign_gr, ee_upper_limit, ee_lower_limit,  &
              ee_upper_limit_in, engy_minimum,          &
              sum, etest, fguess, gg_norm, ee_in,       &
              eps_de_tmp = 1.d-9
   ier = 0
   max_eslides  =  25
   max_loop_in  =  50
   engy_minimum = 1.d-4
  !++++++++++++++++++++++++++++++++++++
   allocate(bsum(nmesh)) ; bsum = 0.d0
  !++++++++++++++++++++++++++++++++++++
   rphi_ss(:,:)     = 0.d0
   beta_phi_ss(:,:) = 0.d0
   nn_ss(:) = 0
   write(IFLOG,*) 'SS: nss ...',nss
L_SS:do iss = 1,nss
      if (is_solve_ss(iss) == 0) then
         write(IFLOG,*) 'SS: bypass iss =',iss
         engy_ss(iss) = 0.d0 ; cycle L_SS
      end if
      ishell = ishell_ss(iss)
      ispin = (1-spin_ss(iss))/2 + 1
      nn = n_qnum(ishell)
      ll = l_qnum(ishell)
      nref = nref_us(ll)
     !++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      allocate(amat(nref,nref),bvec(nref),coeff(nref), &
               fmat(nref,nref),hmat(nref,nref),h0vec(nref), &
               rphi_gl(nmesh,0:nref),dxrphi_gl(nmesh,0:nref))
         amat = 0.d0 ; bvec = 0.d0 ; coeff = 0.d0
         fmat = 0.d0 ; hmat = 0.d0 ; h0vec = 0.d0
         rphi_gl = 0.d0 ; dxrphi_gl = 0.d0
     !++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      fguess = 1.d0
      lguess = 1
      if (nn_ss(ll) == 0) then
         nn_ss(ll) = nn
         node = 0
      else if (nn_ss(ll) /= 0) then
         node = nn - nn_ss(ll)
      end if
      node_sum = node
      if (mod(node,2) == 0) then
         sign_gr = +1.d0
      else
         sign_gr = -1.d0
      end if
      num_eslides = 0
         write(IFLOG,'(1x,a29,5i5)') &
            'SS: iss,ispin,nn,ll,node ...',ishell,ispin,nn,ll,node
      ee = engy_ss(iss)
   if (is_core == OZAKI_KINO) then
      ee_upper_limit = 100.d0
      nmesh_max = nrcut_ok + 20
   else
      nmesh_max = nmesh
      do ir = nmesh,10,-1
         r  = rpos(ir)
         vv = vloc_scr_ss(ir,ispin)
         ss = sqrt(2.d0*abs(ee-vv))
         if (ss*r < ARGMAX) then
            nmesh_max = ir ; exit
         end if
      end do
      ee_upper_limit = vloc_scr_ss(nmesh_max,ispin) - engy_minimum
      if (ee_upper_limit > -engy_minimum) then
         ee_upper_limit = -engy_minimum
      end if
   end if
      ee_upper_limit_in = ee_upper_limit
      ee_lower_limit = ee - 2.d0
      if ((ee > ee_upper_limit).or.(ee < ee_lower_limit)) then
         ee = 0.5d0*(ee_upper_limit + ee_lower_limit)
      end if
      de = ee
      ee_in = ee
      nrm = max(nrm_pos_ss(iss),nrcut_max_us)
      max_loop = max_loop_in
      loop = 0
SRCH_EE:do while (abs(de) > eps_de_tmp)
      loop = loop + 1
      if (loop > max_loop) then
         if (lguess < 2) then
            lguess = lguess + 1
            fguess = fguess * 0.5d0
            max_loop = max_loop * 2
            loop = 0
            node_sum = node
            ee = ee_in
            de = ee
            write(IFLOG,*) 'Reset parameters & continue calculation'
            write(IFLOG,*) '   loop     ...',loop
            write(IFLOG,*) '   max_loop ...',max_loop
            write(IFLOG,*) '   lguess   ...',lguess
            write(IFLOG,*) '   fguess   ...',fguess
            write(IFLOG,*) '   ee       ...',ee
            cycle SRCH_EE
         end if
         if (node_sum < node) then
            write(IFLOG,*) '### CAUTION ### node_sum < node'
            write(IFLOG,*) '   node_sum,node ...',node_sum,node
            write(IFLOG,*) &
               '   Following state may be an unbound state.'
            write(IFLOG,*) '      iss          ...',iss
            write(IFLOG,*) '      (nn,ll,spin) ...',nn,ll,ispin
            if (abs(focc_ss(iss)) > eps_check) then
               write(IFLOG,*) '   Since focc of the state is non-zero,'
               write(IFLOG,*) '      calculation continues.'
               exit SRCH_EE
            else
               write(IFLOG,*) &
                  '   The state is removed in the later calc.'
               is_solve_ss(iss) = 0 ; ee = 0.d0 ; exit SRCH_EE
            end if
         else
            write(IFLOG,*) '### ERROR ### loop > max_loop'
            write(IFLOG,*) '   loop, max_loop ...',loop,max_loop
            write(IFLOG,*) '   iss,nn,ll,node ...',iss,nn,ll,node
            write(IFLOG,*) '   node_sum,node  ...',node_sum,node
            write(IFLOG,*) '   ee_upper_limit ...',ee_upper_limit
            write(IFLOG,*) '   ee_lower_limit ...',ee_lower_limit
            write(IFLOG,*) '   ee             ...',ee
            write(IFLOG,*) '   de             ...',de
            ier=1 ; go to 99
         end if
      end if
      if (num_eslides > max_eslides) then
         write(IFLOG,*) '### CAUTION ### Eigenvalue was not converged !'
         write(IFLOG,*) '      num_eslides  ...',num_eslides
         write(IFLOG,*) '      max_eslides  ...',max_eslides
         write(IFLOG,*) '   Following state may be an unbound state.'
         write(IFLOG,*) '      iss          ...',iss
         write(IFLOG,*) '      (nn,ll,spin) ...',nn,ll,ispin
         if (abs(focc_ss(iss)) > eps_check) then
            write(IFLOG,*) '   Since focc of the state is non-zero,'
            write(IFLOG,*) '      calculation continues.'
            exit SRCH_EE
         else
            write(IFLOG,*) '   The state is removed in the later calc.'
            is_solve_ss(iss) = 0 ; ee = 0.d0 ; exit SRCH_EE
         end if
      end if
      nrt = nrm + 1 + max(iord_pc,iord_diff)
      bsum = 0.d0
      call set_initpoints_left_sol(ier,nmesh,ll,ee,rpos, &
              chi_gl,chi_fl,dxchi_gl,dxchi_fl, &
              vloc_scr_ss(1,ispin),bsum)
      call int_from_left_sol(ier,nmesh,node_sum,nrt, &
              ll,ee,iord_nec,dx,rpos, &
              chi_gl,chi_fl,dxchi_gl,dxchi_fl, &
              vloc_scr_ss(1,ispin),bsum)
      if (ier /= 0) then
         write(IFLOG,*) '### ERROR ### in int_from_left_sol [0]'
         go to 99
      end if
      rphi_gl(:,0)   = chi_gl(:)
      dxrphi_gl(:,0) = dxchi_gl(:)
      do tt = 1,nref
         lt = lt_n_us(ll,tt)
         bsum(:) = -rbeta_us(:,lt)
         call set_initpoints_left_sol(ier,nmesh,ll,ee,rpos, &
                 chi_gl,chi_fl,dxchi_gl,dxchi_fl, &
                 vloc_scr_ss(1,ispin),bsum)
         call int_from_left_sol(ier,nmesh,node_sum,nrt, &
                 ll,ee,iord_nec,dx,rpos, &
                 chi_gl,chi_fl,dxchi_gl,dxchi_fl, &
                 vloc_scr_ss(1,ispin),bsum)
         if (ier /= 0) then
            write(IFLOG,*) '### ERROR ### in int_from_left_sol [1]'
            go to 99
         end if
         rphi_gl(:,tt)   = chi_gl(:)
         dxrphi_gl(:,tt) = dxchi_gl(:)
      end do
      fmat(:,:) = 0.d0
      do t1 = 1,nref
         lt1 = lt_n_us(ll,t1)
         do t2 = 1,nref
            ltt = ltt_nm_us(ll,t1,t2)
            fmat(t1,t2) = dmat_ss(ltt,ispin) - ee*q_sum_us(ltt)
            sum = 0.d0
            do ir = 1,nmesh
               sum = sum + rbeta_us(ir,lt1)*rphi_gl(ir,t2)*wr(ir)
            end do
            hmat(t1,t2) = sum
         end do
      end do
      amat = matmul(fmat,hmat)
      do tt = 1,nref
         amat(tt,tt) = amat(tt,tt) + 1.d0
         lt = lt_n_us(ll,tt)
         sum = 0.d0
         do ir = 1,nmesh
            sum = sum + rbeta_us(ir,lt)*rphi_gl(ir,0)*wr(ir)
         end do
         h0vec(tt) = sum
      end do
      bvec = -matmul(fmat,h0vec)
      call axb_real_matrix(ier,nref,1,amat,coeff,bvec)
      chi_gl(:)   = rphi_gl(:,0)
      dxchi_gl(:) = dxrphi_gl(:,0)
      do tt = 1,nref
         chi_gl(:) = chi_gl(:) + coeff(tt)*rphi_gl(:,tt)
         dxchi_gl(:) = dxchi_gl(:) + coeff(tt)*dxrphi_gl(:,tt)
      end do
      do ir = 1,nrt
         r = rpos(ir)
         chi_fl(ir) = dxchi_gl(ir)/r - dble(ll+1)/r*chi_gl(ir)
      end do
      call calc_nodes_us(nmesh,chi_gl,nrm,node_sum)
      if (node_sum > node) then
         if (ee < ee_upper_limit) then
            ee_upper_limit = ee
         end if
         if (ee_upper_limit > ee_upper_limit_in) then
            ee_upper_limit = ee_upper_limit_in
         end if
         ee = 0.5d0*(ee + ee_lower_limit)
         ee_lower_limit = ee_lower_limit * 1.2d0
         cycle SRCH_EE
      else if (node_sum < node) then
         if (ee > ee_lower_limit) then
            ee_lower_limit = ee
         end if
         ee = 0.5d0*(ee_upper_limit + ee)
         ee_upper_limit = ee_upper_limit_in
         ee = 0.5d0*(ee_upper_limit + ee)
         cycle SRCH_EE
      end if
   if (is_core == OZAKI_KINO) then
      nmesh_max = nrcut_ok + 20
   else
      nmesh_max = nmesh
      do ir = nmesh,10,-1
         r  = rpos(ir)
         vv = vloc_scr_ss(ir,ispin)
         ss = sqrt(2.d0*abs(ee-vv))
         if (ss*r < ARGMAX) then
            nmesh_max = ir ; exit
         end if
      end do
   end if
      if (nmesh_max < nmesh) then
         r  = rpos(nmesh_max)
         vv = vloc_scr_ss(nmesh_max,ispin)
         ss = sqrt(2.d0*abs(ee-vv))
         do ir = nmesh_max+1,nmesh
            r  = rpos(ir)
            vv = vloc_scr_ss(ir,ispin)
            ss = sqrt(2.d0*abs(ee-vv))
            chi_gr(ir) = exp(-ss*r) * sign_gr
            chi_fr(ir) = -ss * chi_gr(ir) 
            dxchi_gr(ir) = 0.d0
            dxchi_fr(ir) = 0.d0
         end do
      end if
      call set_initpoints_right_sol(ier, &
              nmesh,nmesh_max,ll,ee,rpos, &
              chi_gr,chi_fr,dxchi_gr,dxchi_fr, &
              vloc_scr_ss(1,ispin),bsum,sign_gr)
      if (ier /= 0) then
         write(IFLOG,*) '### ERROR ### in set_initpoints_right_sol'
         go to 99
      end if
      nrt = nrm - 1 - max(iord_pc,iord_diff)
      call int_from_right_sol(ier,nmesh,nmesh_max,nrt, &
              ll,ee,iord_nec,dx,rpos, &
              chi_gr,chi_fr,dxchi_gr,dxchi_fr, &
              vloc_scr_ss(1,ispin),bsum)
      if (ier /= 0) then
         write(IFLOG,*) '### ERROR ### in int_from_right_sol'
         go to 99
      end if
      rr = chi_gl(nrm) / chi_gr(nrm)
      do ir = nmesh,nrt,-1
           chi_gr(ir) =   chi_gr(ir) * rr
           chi_fr(ir) =   chi_fr(ir) * rr
         dxchi_gr(ir) = dxchi_gr(ir) * rr
         dxchi_fr(ir) = dxchi_fr(ir) * rr
      end do
      call guess_de_sol(ier,IFLOG,nmesh,nrm,rpos,wt, &
              chi_gl,chi_fl,chi_gr,chi_fr,de,fguess,gg_norm)
      if (ier /= 0) then
         write(IFLOG,*) '### ERROR ### in guess_de' ; go to 99
      end if
      if (de > 0.d0) then
         ee_lower_limit = ee
      else if (de < 0.d0) then
         ee_upper_limit = ee
         if (ee_upper_limit > ee_upper_limit_in) then
            ee_upper_limit = ee_upper_limit_in
         end if
      end if
      etest = ee + de
      if ((etest-ee_upper_limit)*(etest-ee_lower_limit) < 0.d0) then
         ee = etest
      else
         ee = 0.5d0*(ee_upper_limit + ee_lower_limit)
         num_eslides = num_eslides + 1
      end if
         write(IFLOG,'(1x,a21,2i5,f25.15,1pe20.10)') &
           'SS: iss,ll,ee,de ...',iss,ll,ee,de
end do SRCH_EE
      if (is_solve_ss(iss) /= 0) then
         engy_ss(iss) = ee
      else
         engy_ss(iss) = 0.d0
      end if
      if (is_solve_ss(iss) /= 0) then
         do ir = 1,nrm
            rphi_ss(ir,iss) = chi_gl(ir)
         end do
         do ir = nrm,nmesh
            rphi_ss(ir,iss) = chi_gr(ir)
         end do
      else
         rphi_ss(:,iss) = 0.d0
      end if
      if (is_solve_ss(iss) /= 0) then
         call calc_beta_phi_ss(ier,iss)
         sum = 0.d0
         do ir = 1,nmesh
            sum = sum + rphi_ss(ir,iss)**2*wr(ir)
         end do
         do t1 = 1,nref
         do t2 = 1,nref
            lt1 = lt_n_us(ll,t1)
            lt2 = lt_n_us(ll,t2)
            ltt = ltt_nm_us(ll,t1,t2)
            sum = sum + q_sum_us(ltt) &
                      * beta_phi_ss(lt1,iss) &
                      * beta_phi_ss(lt2,iss)
         end do
         end do
         rphi_ss(:,iss) = rphi_ss(:,iss)/sqrt(sum)*sign_gr
         call calc_beta_phi_ss(ier,iss)
      else
         beta_phi_ss(:,iss) = 0.d0
      end if
      do ir = 1,nmesh
         if (abs(rphi_ss(ir,iss)) < 1.d-99) then
            rphi_ss(ir,iss) = 0.d0
         end if
      end do
     !++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      deallocate(amat,bvec,coeff,fmat,hmat,h0vec,rphi_gl,dxrphi_gl)
     !++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
end do L_SS
99 continue
  !+++++++++++++++++
   deallocate(bsum)
  !+++++++++++++++++
   end subroutine calc_bound_state_ss

!============================================== added by K. T. =========== 4.0
subroutine calc_bound_state_ss_kt(ier)
  use parameters
  implicit none

  integer,intent(out) :: ier
  real(8),allocatable :: &
       bsum(:), amat(:,:), bvec(:), coeff(:), fmat(:,:), hmat(:,:), &
       h0vec(:), rphi_gl(:,:), dxrphi_gl(:,:)

  integer :: ir, iss, ishell, nn, ll, tt, lt, t1, t2, lt1, lt2, &
       ltt, nref, nrm, nrt, node_sum, node, nmesh_max, &
       num_eslides, max_eslides, loop, max_loop, ispin, &
       nn_ss(0:3), lguess, max_loop_in
  real(8) :: ee, de, r, vv, ss, rr, &
       sign_gr, ee_upper_limit, ee_lower_limit,  &
       ee_upper_limit_in, engy_minimum,          &
       sum, etest, fguess, gg_norm, ee_in,       &
       eps_de_tmp = 1.d-9

  integer :: itmp1, itmp2

  ier = 0

  max_eslides  =  25
  max_loop_in  =  50
  engy_minimum = 1.d-4

  !++++++++++++++++++++++++++++++++++++
  allocate(bsum(nmesh)) ; bsum = 0.d0
  !++++++++++++++++++++++++++++++++++++

  rphi_ss(:,:)     = 0.d0
  beta_phi_ss(:,:) = 0.d0
  nn_ss(:) = 0

  write(IFLOG,*) 'SS: nss ...',nss

  L_SS:do iss = 1,nss

     if (is_solve_ss(iss) == 0) then
        write(IFLOG,*) 'SS: bypass iss =',iss
        engy_ss(iss) = 0.d0 ; cycle L_SS
     end if

     ishell = ishell_ss(iss)
     ispin = (1-spin_ss(iss))/2 + 1

!     write(*,*) 'ispin @iss = ', iss, ispin

     nn = n_qnum(ishell)
     ll = l_qnum(ishell)
     nref = nref_us(ll)

     !++++++++++++++++++++++++++++++++++++++++++++++++++++++++
     allocate(amat(nref,nref),bvec(nref),coeff(nref), &
          fmat(nref,nref),hmat(nref,nref),h0vec(nref), &
          rphi_gl(nmesh,0:nref),dxrphi_gl(nmesh,0:nref))
     amat = 0.d0 ; bvec = 0.d0 ; coeff = 0.d0
     fmat = 0.d0 ; hmat = 0.d0 ; h0vec = 0.d0
     rphi_gl = 0.d0 ; dxrphi_gl = 0.d0
     !++++++++++++++++++++++++++++++++++++++++++++++++++++++++

     fguess = 1.d0
     lguess = 1

     if (nn_ss(ll) == 0) then
        nn_ss(ll) = nn
        node = 0
     else if (nn_ss(ll) /= 0) then
        node = nn - nn_ss(ll)
     end if

     node_sum = node
     if (mod(node,2) == 0) then
        sign_gr = +1.d0
     else
        sign_gr = -1.d0
     end if

     num_eslides = 0
     write(IFLOG,'(1x,a29,5i5)') &
          'SS: ishell,ispin,nn,ll,node ...',ishell,ispin,nn,ll,node

     ee = engy_ss(iss)

     if (is_core == OZAKI_KINO) then
        ee_upper_limit = 100.d0
        nmesh_max = nrcut_ok + 20

     else
        nmesh_max = nmesh
        do ir = nmesh,10,-1
           r  = rpos(ir)
           vv = vloc_scr_ss(ir,ispin)
           ss = sqrt(2.d0*abs(ee-vv))
           if (ss*r < ARGMAX) then
              nmesh_max = ir ; exit
           end if
        end do

        ee_upper_limit = vloc_scr_ss(nmesh_max,ispin) - engy_minimum
        if (ee_upper_limit > -engy_minimum) then
           ee_upper_limit = -engy_minimum

        end if
     end if

     ee_upper_limit_in = ee_upper_limit
     ee_lower_limit = ee - 2.d0

     if ((ee > ee_upper_limit).or.(ee < ee_lower_limit)) then
        ee = 0.5d0*(ee_upper_limit + ee_lower_limit)
     end if

     de = ee
     ee_in = ee

     nrm = max(nrm_pos_ss(iss),nrcut_max_us)
     max_loop = max_loop_in

     loop = 0

     SRCH_EE:do while (abs(de) > eps_de_tmp)
        loop = loop + 1
        if (loop > max_loop) then
           if (lguess < 2) then
              lguess = lguess + 1
              fguess = fguess * 0.5d0
              max_loop = max_loop * 2
              loop = 0
              node_sum = node
              ee = ee_in
              de = ee
              write(IFLOG,*) 'Reset parameters & continue calculation'
              write(IFLOG,*) '   loop     ...',loop
              write(IFLOG,*) '   max_loop ...',max_loop
              write(IFLOG,*) '   lguess   ...',lguess
              write(IFLOG,*) '   fguess   ...',fguess
              write(IFLOG,*) '   ee       ...',ee
              cycle SRCH_EE
           end if

           if (node_sum < node) then
              write(IFLOG,*) '### CAUTION ### node_sum < node'
              write(IFLOG,*) '   node_sum,node ...',node_sum,node
              write(IFLOG,*) &
                   '   Following state may be an unbound state.'
              write(IFLOG,*) '      iss          ...',iss
              write(IFLOG,*) '      (nn,ll,spin) ...',nn,ll,ispin
              if (abs(focc_ss(iss)) > eps_check) then
                 write(IFLOG,*) '   Since focc of the state is non-zero,'
                 write(IFLOG,*) '      calculation continues.'
                 exit SRCH_EE
              else
                 write(IFLOG,*) &
                      '   The state is removed in the later calc.'
                 is_solve_ss(iss) = 0 ; ee = 0.d0 ; exit SRCH_EE
              end if

           else
              write(IFLOG,*) '### ERROR ### loop > max_loop'
              write(IFLOG,*) '   loop, max_loop ...',loop,max_loop
              write(IFLOG,*) '   iss,nn,ll,node ...',iss,nn,ll,node
              write(IFLOG,*) '   node_sum,node  ...',node_sum,node
              write(IFLOG,*) '   ee_upper_limit ...',ee_upper_limit
              write(IFLOG,*) '   ee_lower_limit ...',ee_lower_limit
              write(IFLOG,*) '   ee             ...',ee
              write(IFLOG,*) '   de             ...',de
              ier=1 ; go to 99
           end if

        end if

        if (num_eslides > max_eslides) then
           write(IFLOG,*) '### CAUTION ### Eigenvalue was not converged !'
           write(IFLOG,*) '      num_eslides  ...',num_eslides
           write(IFLOG,*) '      max_eslides  ...',max_eslides
           write(IFLOG,*) '   Following state may be an unbound state.'
           write(IFLOG,*) '      iss          ...',iss
           write(IFLOG,*) '      (nn,ll,spin) ...',nn,ll,ispin
           if (abs(focc_ss(iss)) > eps_check) then
              write(IFLOG,*) '   Since focc of the state is non-zero,'
              write(IFLOG,*) '      calculation continues.'
              exit SRCH_EE
           else
              write(IFLOG,*) '   The state is removed in the later calc.'
              is_solve_ss(iss) = 0 ; ee = 0.d0 ; exit SRCH_EE
           end if
        end if

        nrt = nrm + 1 + max(iord_pc,iord_diff)
        bsum = 0.d0

        call set_initpoints_left_sol(ier,nmesh,ll,ee,rpos, &
             chi_gl,chi_fl,dxchi_gl,dxchi_fl, &
             vloc_scr_ss(1,ispin),bsum)

        call int_from_left_sol(ier,nmesh,node_sum,nrt, &
              ll,ee,iord_nec,dx,rpos, &
              chi_gl,chi_fl,dxchi_gl,dxchi_fl, &
              vloc_scr_ss(1,ispin),bsum)

        if (ier /= 0) then
           write(IFLOG,*) '### ERROR ### in int_from_left_sol [0]'
           go to 99
        end if

        rphi_gl(:,0)   = chi_gl(:)
        dxrphi_gl(:,0) = dxchi_gl(:)

        do tt = 1,nref
           
           if ( nspin == 1 ) then
              itmp1 = tt
           else if ( nspin ==2 ) then
              itmp1 = tt + nref_max_us *( ispin -1 )
           endif

           lt = lt_n_us(ll,itmp1)

           bsum(:) = -rbeta_us(:,lt)

           call set_initpoints_left_sol(ier,nmesh,ll,ee,rpos, &
                chi_gl,chi_fl,dxchi_gl,dxchi_fl, &
                vloc_scr_ss(1,ispin),bsum)

           call int_from_left_sol(ier,nmesh,node_sum,nrt, &
                ll,ee,iord_nec,dx,rpos, &
                chi_gl,chi_fl,dxchi_gl,dxchi_fl, &
                vloc_scr_ss(1,ispin),bsum)

           if (ier /= 0) then
              write(IFLOG,*) '### ERROR ### in int_from_left_sol [1]'
              go to 99
           end if

           rphi_gl(:,tt)   = chi_gl(:)
           dxrphi_gl(:,tt) = dxchi_gl(:)
        end do

        fmat(:,:) = 0.d0

        do t1 = 1,nref

           if ( nspin == 1 ) then
              itmp1 = t1
           else if ( nspin == 2 ) then
              itmp1 = t1 + nref_max_us *( ispin -1 )
           endif

           lt1 = lt_n_us(ll,itmp1)

           do t2 = 1,nref

              if ( nspin == 1 ) then
                 itmp2 = t2
              else if ( nspin == 2 ) then
                 itmp2 = t2 + nref_max_us *( ispin -1 )
              endif

              ltt = ltt_nm_us(ll,itmp1,itmp2)

              fmat(t1,t2) = dmat_ss(ltt,ispin) - ee*q_sum_us(ltt)

              sum = 0.d0
              do ir = 1,nmesh
                 sum = sum + rbeta_us(ir,lt1)*rphi_gl(ir,t2)*wr(ir)
              end do
              hmat(t1,t2) = sum

           end do
        end do

        amat = matmul(fmat,hmat)

        do tt = 1,nref
           amat(tt,tt) = amat(tt,tt) + 1.d0

           if ( nspin == 1 ) then
              itmp1 = tt
           else if ( nspin == 2 ) then
              itmp1 = tt + nref_max_us *(ispin -1 )
           endif

           lt = lt_n_us(ll,itmp1)

           sum = 0.d0
           do ir = 1,nmesh
              sum = sum + rbeta_us(ir,lt)*rphi_gl(ir,0)*wr(ir)
           end do
           h0vec(tt) = sum
        end do

        bvec = -matmul(fmat,h0vec)

        call axb_real_matrix(ier,nref,1,amat,coeff,bvec)
        chi_gl(:)   = rphi_gl(:,0)
        dxchi_gl(:) = dxrphi_gl(:,0)

        do tt = 1,nref
           chi_gl(:) = chi_gl(:) + coeff(tt)*rphi_gl(:,tt)
           dxchi_gl(:) = dxchi_gl(:) + coeff(tt)*dxrphi_gl(:,tt)
        end do

        do ir = 1,nrt
           r = rpos(ir)
           chi_fl(ir) = dxchi_gl(ir)/r - dble(ll+1)/r*chi_gl(ir)
        end do

        call calc_nodes_us(nmesh,chi_gl,nrm,node_sum)

        if (node_sum > node) then
           if (ee < ee_upper_limit) then
              ee_upper_limit = ee
           end if
           if (ee_upper_limit > ee_upper_limit_in) then
              ee_upper_limit = ee_upper_limit_in
           end if
           ee = 0.5d0*(ee + ee_lower_limit)
           ee_lower_limit = ee_lower_limit * 1.2d0
           cycle SRCH_EE

        else if (node_sum < node) then
           if (ee > ee_lower_limit) then
              ee_lower_limit = ee
           end if
           ee = 0.5d0*(ee_upper_limit + ee)
           ee_upper_limit = ee_upper_limit_in
           ee = 0.5d0*(ee_upper_limit + ee)
           cycle SRCH_EE
        end if

        if (is_core == OZAKI_KINO) then
           nmesh_max = nrcut_ok + 20
        else
           nmesh_max = nmesh
           do ir = nmesh,10,-1
              r  = rpos(ir)
              vv = vloc_scr_ss(ir,ispin)
              ss = sqrt(2.d0*abs(ee-vv))
              if (ss*r < ARGMAX) then
                 nmesh_max = ir ; exit
              end if
           end do
        end if

        if (nmesh_max < nmesh) then
           r  = rpos(nmesh_max)
           vv = vloc_scr_ss(nmesh_max,ispin)
           ss = sqrt(2.d0*abs(ee-vv))
           do ir = nmesh_max+1,nmesh
              r  = rpos(ir)
              vv = vloc_scr_ss(ir,ispin)
              ss = sqrt(2.d0*abs(ee-vv))
              chi_gr(ir) = exp(-ss*r) * sign_gr
              chi_fr(ir) = -ss * chi_gr(ir) 
              dxchi_gr(ir) = 0.d0
              dxchi_fr(ir) = 0.d0
           end do
        end if

        call set_initpoints_right_sol(ier, &
             nmesh,nmesh_max,ll,ee,rpos, &
             chi_gr,chi_fr,dxchi_gr,dxchi_fr, &
             vloc_scr_ss(1,ispin),bsum,sign_gr)

        if (ier /= 0) then
           write(IFLOG,*) '### ERROR ### in set_initpoints_right_sol'
           go to 99
        end if

        nrt = nrm - 1 - max(iord_pc,iord_diff)

        call int_from_right_sol(ier,nmesh,nmesh_max,nrt, &
             ll,ee,iord_nec,dx,rpos, &
             chi_gr,chi_fr,dxchi_gr,dxchi_fr, &
             vloc_scr_ss(1,ispin),bsum)
        if (ier /= 0) then
           write(IFLOG,*) '### ERROR ### in int_from_right_sol'
           go to 99
        end if

        rr = chi_gl(nrm) / chi_gr(nrm)
        do ir = nmesh,nrt,-1
           chi_gr(ir) =   chi_gr(ir) * rr
           chi_fr(ir) =   chi_fr(ir) * rr
           dxchi_gr(ir) = dxchi_gr(ir) * rr
           dxchi_fr(ir) = dxchi_fr(ir) * rr
        end do

        call guess_de_sol(ier,IFLOG,nmesh,nrm,rpos,wt, &
             chi_gl,chi_fl,chi_gr,chi_fr,de,fguess,gg_norm)
        if (ier /= 0) then
           write(IFLOG,*) '### ERROR ### in guess_de' ; go to 99
        end if

        if (de > 0.d0) then
           ee_lower_limit = ee
        else if (de < 0.d0) then
           ee_upper_limit = ee
           if (ee_upper_limit > ee_upper_limit_in) then
              ee_upper_limit = ee_upper_limit_in
           end if
        end if

        etest = ee + de
        if ((etest-ee_upper_limit)*(etest-ee_lower_limit) < 0.d0) then
           ee = etest
        else
           ee = 0.5d0*(ee_upper_limit + ee_lower_limit)
           num_eslides = num_eslides + 1
        end if

        write(IFLOG,'(1x,a21,2i5,f25.15,1pe20.10)') &
             'SS: iss,ll,ee,de ...',iss,ll,ee,de

     end do SRCH_EE

     if (is_solve_ss(iss) /= 0) then
        engy_ss(iss) = ee
     else
        engy_ss(iss) = 0.d0
     end if

     if (is_solve_ss(iss) /= 0) then
        do ir = 1,nrm
           rphi_ss(ir,iss) = chi_gl(ir)
        end do
        do ir = nrm,nmesh
           rphi_ss(ir,iss) = chi_gr(ir)
        end do

     else
        rphi_ss(:,iss) = 0.d0
     end if

     if (is_solve_ss(iss) /= 0) then

        call calc_beta_phi_ss_kt(ier,iss)

        sum = 0.d0
        do ir = 1,nmesh
           sum = sum + rphi_ss(ir,iss)**2*wr(ir)
        end do

        do t1 = 1,nref
           do t2 = 1,nref
              itmp1 = t1 + nref_max_us * (ispin -1)
              itmp2 = t2 + nref_max_us * (ispin -1)

              if ( nspin == 1 ) then
                 itmp1 = t1; itmp2 = t2
              endif

              lt1 = lt_n_us(ll,itmp1)
              lt2 = lt_n_us(ll,itmp2)

              ltt = ltt_nm_us(ll,itmp1,itmp2)

              sum = sum + q_sum_us(ltt) &
                   * beta_phi_ss(lt1,iss) &
                   * beta_phi_ss(lt2,iss)
           end do
        end do

        rphi_ss(:,iss) = rphi_ss(:,iss)/sqrt(sum)*sign_gr
        call calc_beta_phi_ss_kt(ier,iss)

     else
        beta_phi_ss(:,iss) = 0.d0
     end if

     do ir = 1,nmesh
        if (abs(rphi_ss(ir,iss)) < 1.d-99) then
           rphi_ss(ir,iss) = 0.d0
        end if
     end do

     !++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
     deallocate(amat,bvec,coeff,fmat,hmat,h0vec,rphi_gl,dxrphi_gl)
     !++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  end do L_SS

99 continue

  !+++++++++++++++++
  deallocate(bsum)
  !+++++++++++++++++

end subroutine calc_bound_state_ss_kt
! ============================================================================== 4.0

!=====================================================================
   subroutine set_initpoints_right_sol(ier, &
              nmesh,nmesh_max,ll,ee,rpos,g,f,dxg,dxf,vloc,bsum,sign_g)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   implicit none
   integer,intent(in)  :: nmesh_max, nmesh, ll
   real(8),intent(in)  :: sign_g, ee, rpos(nmesh), vloc(nmesh), &
                          bsum(nmesh)
   integer,intent(out) :: ier
   real(8),intent(out) :: g(nmesh), f(nmesh), &
                          dxg(nmesh), dxf(nmesh)
   integer :: ir
   real(8) :: vv, ss, r
   ier = 0
   vv = vloc(nmesh_max)
   ss = sqrt(2.d0*abs(ee-vv))
   do ir = nmesh_max-10,nmesh_max
      r  = rpos(ir)
      g(ir) = exp(-ss*r) * sign_g
      f(ir) = -ss * g(ir)
      call dgdx_dfdx_sol(rpos(ir),g(ir),f(ir),dxg(ir),dxf(ir), &
                         ll,ee,vloc(ir),bsum(ir))
   end do
99 continue
   end subroutine set_initpoints_right_sol

!=====================================================================
   subroutine int_from_right_sol(ier,nmesh,nmesh_max,nrt, &
              ll,ee,nec,dx,rpos,g,f,dxg,dxf,vloc,bsum)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   implicit none
   integer,intent(in)    :: nmesh, nmesh_max, nrt, ll, nec
   real(8),intent(in)    :: ee, dx, &
                            rpos(nmesh), vloc(nmesh), bsum(nmesh)
   real(8),intent(inout) :: g(nmesh), f(nmesh), &
                            dxg(nmesh), dxf(nmesh)
   integer,intent(out)   :: ier
   integer :: ir, id
   ier =  0
   id  = -1
   do ir = nmesh_max-3,nrt-1,-1
      call pc_adams_5_sol(ier, &
              nmesh,ir,id,ll,ee,nec,dx,rpos, &
              g,f,dxg,dxf,vloc,bsum)
   end do
99 continue
   end subroutine int_from_right_sol

!=====================================================================
   subroutine guess_de_sol(ier,ifile, &
      nmesh,nrm,rpos,wt,gl,fl,gr,fr,de,fguess,gg_norm)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   implicit none
   integer,intent(in)    :: nrm, nmesh, ifile
   real(8),intent(in)    :: rpos(nmesh),fguess, &
                            gl(nmesh), fl(nmesh), gr(nmesh), fr(nmesh)
   real(8),intent(inout) :: wt(nmesh)
   integer,intent(out)   :: ier
   real(8),intent(out)   :: de, gg_norm
   integer :: ir
   real(8) :: sum1, sum2
   ier = 0
   call set_weight_exp(ier,1,nrm,rpos,wt)
   if (ier /= 0) then
      write(ifile,*) '### ERROR ### in set_weight_exp(1)' ; go to 99
   end if
   sum1 = 0.d0
   do ir = 1,nrm
      sum1 = sum1 + gl(ir)**2*wt(ir)
   end do
   call set_weight_exp(ier,nrm,nmesh,rpos,wt)
   if (ier /= 0) then
      write(ifile,*) '### ERROR ### in set_weight_exp(2)' ; go to 99
   end if
   sum2 = 0.d0
   do ir = nrm,nmesh
      sum2 = sum2 + gr(ir)**2*wt(ir)
   end do
   gg_norm = sum1 + sum2
   de = 0.5d0 * gl(nrm) * (fl(nrm) - fr(nrm)) / gg_norm * fguess
99 continue
   end subroutine guess_de_sol

!=====================================================================
   subroutine calc_beta_phi_sol(ier,ips)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(in)  :: ips
   integer,intent(out) :: ier
   integer :: ir, ishell, ll, nref, tt, lt
   real(8) :: sum
   ier = 0
   beta_phi_sol(:,ips) = 0.d0
   ishell = ishell_ps(ips,1)
   ll = l_qnum(ishell)
   nref = nref_us(ll)
   do tt = 1,nref
      lt = lt_n_us(ll,tt)
      if (ll == lloc) then
         sum = 1.d0
      else
         sum = 0.d0
         do ir = 1,nmesh
            sum = sum &
                + wr(ir) * rbeta_us(ir,lt) * rphi_sol(ir,ips)
         end do
      end if
      beta_phi_sol(lt,ips) = sum
   end do
99 continue
   end subroutine calc_beta_phi_sol

!============================== added by K. T. ================= 4.0
subroutine calc_beta_phi_sol_kt(ier,ips)
  use parameters
  implicit none

  integer,intent(in)  :: ips
  integer,intent(out) :: ier
  integer :: ir, ishell, ll, nref, tt, lt
  integer :: ispin, itmp1

  real(8) :: sum

  ier = 0
  beta_phi_sol(:,ips) = 0.d0
  ishell = ishell_ps(ips,1)
  ll = l_qnum(ishell)
  nref = nref_us(ll)

  ispin = ( 1-spin(ishell) ) /2 +1

  do tt = 1,nref
     itmp1 = tt + nref_max_us *( ispin - 1 )

     lt = lt_n_us(ll,itmp1)
     if (ll == lloc) then
        sum = 1.d0
     else
        sum = 0.d0
        do ir = 1,nmesh
           sum = sum &
                + wr(ir) * rbeta_us(ir,lt) * rphi_sol(ir,ips)
        end do
     end if
     beta_phi_sol(lt,ips) = sum
  end do

99 continue

end subroutine calc_beta_phi_sol_kt
! ======================================================================== 4.0

!=====================================================================
   subroutine calc_beta_phi_ss(ier,iss)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(in)  :: iss
   integer,intent(out) :: ier
   integer :: ir, ishell, ll, nref, tt, lt
   real(8) :: sum
   ier = 0
   beta_phi_ss(:,iss) = 0.d0
   ishell = ishell_ss(iss)
   ll = l_qnum(ishell)
   nref = nref_us(ll)
   do tt = 1,nref
      lt = lt_n_us(ll,tt)
      if (ll == lloc) then
         sum = 1.d0
      else
         sum = 0.d0
         do ir = 1,nmesh
            sum = sum &
                + wr(ir) * rbeta_us(ir,lt) * rphi_ss(ir,iss)
         end do
      end if
      beta_phi_ss(lt,iss) = sum
   end do
99 continue
   end subroutine calc_beta_phi_ss

!================================== added by K. T. ======================== 4.0
subroutine calc_beta_phi_ss_kt(ier,iss)
  use parameters
  implicit none

  integer,intent(in)  :: iss
  integer,intent(out) :: ier
  integer :: ir, ishell, ll, nref, tt, lt

  integer :: ispin, itmp1
  real(8) :: sum

  ier = 0

  beta_phi_ss(:,iss) = 0.d0

  ishell = ishell_ss(iss)
  ll = l_qnum(ishell)
  nref = nref_us(ll)

  ispin = ( 1-spin_ss(iss) ) /2 +1

  do tt = 1,nref
     itmp1 = tt + nref_max_us *( ispin - 1 )

     if ( nspin == 1 ) then
        itmp1 = tt
     endif
     
     lt = lt_n_us(ll,itmp1)

     if (ll == lloc) then
        sum = 1.d0
     else
        sum = 0.d0
        do ir = 1,nmesh
           sum = sum &
                + wr(ir) * rbeta_us(ir,lt) * rphi_ss(ir,iss)
        end do
     end if
     beta_phi_ss(lt,iss) = sum
  end do

99 continue

end subroutine calc_beta_phi_ss_kt
! ========================================================================= 4.0

!=====================================================================
   subroutine set_initpoints_left_sol(ier, &
              nmesh,ll,ee,rpos,g,f,dxg,dxf,vloc,bsum)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   implicit none
   integer,intent(in)  :: ll, nmesh
   real(8),intent(in)  :: ee, rpos(nmesh), vloc(nmesh), bsum(nmesh)
   integer,intent(out) :: ier
   real(8),intent(out) :: g(nmesh), f(nmesh), &
                          dxg(nmesh), dxf(nmesh)
   integer :: ir
   ier = 0
   do ir = 1,10
      g(ir) = rpos(ir)**(ll+1)
      f(ir) = 0.d0
      call dgdx_dfdx_sol(rpos(ir),g(ir),f(ir),dxg(ir),dxf(ir), &
                         ll,ee,vloc(ir),bsum(ir))
   end do
   end subroutine set_initpoints_left_sol

!=====================================================================
   subroutine int_from_left_sol(ier,nmesh,node_sum,nrt, &
              ll,ee,nec,dx,rpos,g,f,dxg,dxf,vloc,bsum)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   implicit none
   integer,intent(in)    :: nrt, ll, nec, nmesh
   real(8),intent(in)    :: ee, dx, &
                            rpos(nmesh), vloc(nmesh), bsum(nmesh)
   real(8),intent(inout) :: g(nmesh), f(nmesh), &
                            dxg(nmesh), dxf(nmesh)
   integer,intent(out)   :: ier, node_sum
   integer :: id, ir
   ier = 0
   id = +1
   node_sum = 0
   do ir = 4,nrt+1
      call pc_adams_5_sol(ier, &
              nmesh,ir,id,ll,ee,nec,dx,rpos, &
              g,f,dxg,dxf,vloc,bsum)
      if (g(ir)*g(ir-1) < 0.d0) then
         node_sum = node_sum + 1
      end if
   end do
99 continue
   end subroutine int_from_left_sol

!=====================================================================
   subroutine pc_adams_5_sol(ier, &
              nmesh,ir,id,ll,ee,nec,dx,rpos,g,f,dxg,dxf,vloc,bsum)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   implicit none
   integer,intent(in)    :: ir, ll, nec, nmesh
   real(8),intent(in)    :: ee, dx, &
                            rpos(nmesh), vloc(nmesh), bsum(nmesh)
   integer,intent(inout) :: id
   real(8),intent(inout) :: g(nmesh), f(nmesh), &
                            dxg(nmesh), dxf(nmesh)
   integer,intent(out)   :: ier
   integer :: iec
   real(8) :: dx24, &
              g0, g1, g2, g3, dg0, dg1, dg2, dg3, g9, dg9, &
              f0, f1, f2, f3, df0, df1, df2, df3, f9, df9
   ier = 0
   id   = sign(1,id)
   dx24 = dx / 24.d0 * dble(id)
   select case (id)
   case(+1)
      g0  =   g(ir     ) ; f0  =   f(ir     )
      g1  =   g(ir-1*id) ; f1  =   f(ir-1*id)
      g2  =   g(ir-2*id) ; f2  =   f(ir-2*id)
      g3  =   g(ir-3*id) ; f3  =   f(ir-3*id)
      dg0 = dxg(ir     ) ; df0 = dxf(ir     )
      dg1 = dxg(ir-1*id) ; df1 = dxf(ir-1*id)
      dg2 = dxg(ir-2*id) ; df2 = dxf(ir-2*id)
      dg3 = dxg(ir-3*id) ; df3 = dxf(ir-3*id)
   case(-1)
      g0  =   g(ir     ) ; f0  =   f(ir     )
      g1  =   g(ir-1*id) ; f1  =   f(ir-1*id)
      g2  =   g(ir-2*id) ; f2  =   f(ir-2*id)
      g3  =   g(ir-3*id) ; f3  =   f(ir-3*id)
      dg0 = dxg(ir     ) ; df0 = dxf(ir     )
      dg1 = dxg(ir-1*id) ; df1 = dxf(ir-1*id)
      dg2 = dxg(ir-2*id) ; df2 = dxf(ir-2*id)
      dg3 = dxg(ir-3*id) ; df3 = dxf(ir-3*id)
   end select
   g9 = g0 + dx24 * (55.d0*dg0 - 59.d0*dg1 + 37.d0*dg2 - 9.d0*dg3)
   f9 = f0 + dx24 * (55.d0*df0 - 59.d0*df1 + 37.d0*df2 - 9.d0*df3)
   do iec = 1,nec
      call dgdx_dfdx_sol(rpos(ir+id),g9,f9,dg9,df9, &
                         ll,ee,vloc(ir+id),bsum(ir+id))
      g9 = g0 + dx24 * (9.d0*dg9 + 19.d0*dg0 - 5.d0*dg1 + dg2)
      f9 = f0 + dx24 * (9.d0*df9 + 19.d0*df0 - 5.d0*df1 + df2)
   end do
   call dgdx_dfdx_sol(rpos(ir+id),g9,f9,dg9,df9, &
                      ll,ee,vloc(ir+id),bsum(ir+id))
   select case (id)
   case(+1)
        g(ir+id) =  g9 ;   f(ir+id) =  f9
      dxg(ir+id) = dg9 ; dxf(ir+id) = df9
   case(-1)
        g(ir+id) =  g9 ;   f(ir+id) =  f9
      dxg(ir+id) = dg9 ; dxf(ir+id) = df9
   end select
   end subroutine pc_adams_5_sol

!=====================================================================
   subroutine write_energy_level_sol(ifile)
!=====================================================================  
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(in) :: ifile
   integer        :: i, nn, ll, lshell, ips, lps
   character(100) :: line, buffer
   do i = 1,100
      line(i:i)='-'
   end do
   write(ifile,*)
      read(atom_label(zatom),*) buffer
   write(ifile,*) 'eng  Energy levels for the present PP [Solved]'
   write(ifile,*) 'eng  Element ---> ',buffer(1:3)

   write(ifile,10) line(1:100)
   write(ifile,11) 'symm', &
                   'Energy (Ha)','Energy (eV)','nocc','focc'
   write(ifile,10) line(1:100)
   do ips = 1,nps
      lps = list_sol(ips)
      lshell = ishell_ps(lps,1)
      if (is_solve(lshell) == 0) then
         cycle
      end if
      nn = n_qnum(lshell)
      ll = l_qnum(lshell)
      write(ifile,12) state(lshell)(1:2), &
         engy_sol(lps),engy_sol(lps)*HARTREE,nocc(lshell),focc_sol(lps)
   end do
   write(ifile,10) line(1:100)
   write(ifile,13) 'Total number of electrons',felec_sol
   write(ifile,10) line(1:100)
10 format(1x,'eng',a65)
11 format(1x,'eng',(3x,a4),2(9x,a11),(2x,a4),(6x,a4))
12 format(1x,'eng',(4x,a2,1x),2(f20.10),i6,f10.5)
13 format(1x,'eng',2x,a25,26x,f10.5)
   end subroutine write_energy_level_sol

!========================================= added by K. T. ======== 4.0
subroutine write_energy_level_sol_kt(ifile)
  use parameters
  implicit none

  integer,intent(in) :: ifile
  integer        :: i, nn, ll, lshell, ips, lps
  character(100) :: line, buffer

  real(8) :: felec1_tmp, felec2_tmp

  do i = 1,100
     line(i:i)='-'
  end do

  write(ifile,*)
  read(atom_label(zatom),*) buffer
  write(ifile,*) 'eng  Energy levels for the present PP [Solved]'
  write(ifile,*) 'eng  Element ---> ',buffer(1:3)
  
  if ( nspin == 1 ) then
     write(ifile,10) line(1:100)
     write(ifile,11) 'symm', &
          'Energy (Ha)','Energy (eV)','nocc','focc'
     write(ifile,10) line(1:100)
     
     do ips = 1,nps
        lps = list_sol(ips)
        lshell = ishell_ps(lps,1)
        
        if (is_solve(lshell) == 0) then
           cycle
        end if
        
        nn = n_qnum(lshell)
        ll = l_qnum(lshell)
        
        write(ifile,12) state(lshell)(1:2), &
             engy_sol(lps),engy_sol(lps)*HARTREE,nocc(lshell),focc_sol(lps)
     end do
     
     write(ifile,10) line(1:100)
     write(ifile,13) 'Total number of electrons',felec_sol
     write(ifile,10) line(1:100)
     
10   format(1x,'eng',a65)
11   format(1x,'eng',(3x,a4),2(9x,a11),(2x,a4),(6x,a4))
12   format(1x,'eng',(4x,a2,1x),2(f20.10),i6,f10.5)
13   format(1x,'eng',2x,a25,26x,f10.5)

  else if ( nspin == 2 ) then

     write(ifile,20) line(1:100)
     write(ifile,21) 'symm', 's', &
          'Energy (Ha)','Energy (eV)','nocc','focc'
     write(ifile,20) line(1:100)
     
     do ips = 1,nps
        lps = list_sol(ips)
        lshell = ishell_ps(lps,1)
        
        if (is_solve(lshell) == 0) then
           cycle
        end if
        
        nn = n_qnum(lshell)
        ll = l_qnum(lshell)
        
        write(ifile,22) state(lshell)(1:2), spin_label(lshell), &
             engy_sol(lps),engy_sol(lps)*HARTREE,nocc(lshell),focc_sol(lps)
     end do
!
! ----------------------------------------------------------
     felec1_tmp = 0
     felec2_tmp = 0
     Do ips=1, nps
        lps = list_sol(ips);   lshell = ishell_ps(lps,1)
        if ( spin(lshell) == 1 ) then
           felec1_tmp = felec1_tmp + focc_sol(lps)
        else
           felec2_tmp = felec2_tmp + focc_sol(lps)
        endif
     End do
! ----------------------------------------------------------
     write(ifile,20) line(1:100)
     write(ifile,23) 'Number of electrons (+)',felec1_tmp
     write(ifile,23) '                    (-)',felec2_tmp
     write(ifile,20) line(1:100)
     
20   format(1x,'eng',a70)
21   format(1x,'eng',(3x,a4),(4x,a1),2(9x,a11),(2x,a4),(6x,a4))
22   format(1x,'eng',(4x,a2,1x),(4x,a1),2(f20.10),i6,f10.5)
23   format(1x,'eng',2x,a23,33x,f10.5)

  endif

end subroutine write_energy_level_sol_kt

!=====================================================================
   subroutine write_energy_level_ss(ifile)
!=====================================================================  
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(in) :: ifile
   integer        :: i, nn, ll, ishell, iss, lss, lshell
   character(100) :: line, buffer
   do i = 1,100
      line(i:i)='-'
   end do
   write(ifile,*)
      read(atom_label(zatom),*) buffer
   write(ifile,*) 'eng  Energy levels for the present PP [Solved]'
   write(ifile,*) 'eng  Element ---> ',buffer(1:3)

   select case (is_spin_ss)

   case (RESTRICTED)
   write(ifile,10) line(1:100)
   write(ifile,11) 'symm', &
                   'Energy (Ha)','Energy (eV)','nocc','focc'
   write(ifile,10) line(1:100)
   do iss = 1,nss
      ishell = ishell_ss(iss)
      if (is_solve_ss(iss) == 0) then
         cycle
      end if
      nn = n_qnum(ishell)
      ll = l_qnum(ishell)
      write(ifile,12) state(ishell)(1:2), &
         engy_ss(iss),engy_ss(iss)*HARTREE,nocc_ss(iss),focc_ss(iss)
   end do
   write(ifile,10) line(1:100)
   write(ifile,13) 'Total number of electrons',felec_ss
   write(ifile,10) line(1:100)
10 format(1x,'eng',a65)
11 format(1x,'eng',(3x,a4),2(9x,a11),(2x,a4),(6x,a4))
12 format(1x,'eng',(4x,a2,1x),2(f20.10),i6,f10.5)
13 format(1x,'eng',2x,a25,26x,f10.5)

   case (POLARIZED)
   write(ifile,20) line(1:100)
   write(ifile,21) 'symm','s', &
                   'Energy (Ha)','Energy (eV)','nocc','focc'
   write(ifile,20) line(1:100)
   do iss = 1,nss
      lss = list_ss(iss)
      lshell = ishell_ss(lss)
      if (is_solve_ss(lss) == 0) then
         cycle
      end if
      nn = n_qnum(lshell)
      ll = l_qnum(lshell)
      write(ifile,22) state(lshell)(1:2),spin_label_ss(lss)(1:1), &
         engy_ss(lss),engy_ss(lss)*HARTREE,nocc_ss(lss),focc_ss(lss)
   end do
   write(ifile,20) line(1:100)
   write(ifile,23) 'Number of electrons (+)',felec1_ss
   write(ifile,23) '                    (-)',felec2_ss
   write(ifile,20) line(1:100)
20 format(1x,'eng',a70)
21 format(1x,'eng',(3x,a4),(4x,a1),2(9x,a11),(2x,a4),(6x,a4))
22 format(1x,'eng',(4x,a2,1x),(4x,a1),2(f20.10),i6,f10.5)
23 format(1x,'eng',2x,a23,33x,f10.5)
   end select
   end subroutine write_energy_level_ss

! ************************************************************* 
!
!   This is a software package CIAO
!
!     developed as a part of the national project "Research and 
!     Development of Innovative Simulation software",which is   
!     supported by the next-generation IT program of MEXT of Japan
!
!   latest version: 
!
!     4.0:  2013/01/17 
!           codes for spin-polarized pseudopotential generation are added
!
! ************************************************************* 
!
!  Software name : CIAO (Code for Investigating Atomic Orbitals)
!  Subroutine(s) : calc_bhs_pp_rel, write_param_bhs, find_nrc_bhs,
!                  calc_bound_state_bhs, calc_vh_bhs, calc_vxc_exc_bhs,
!                  calc_drho_ddrho_ps
!  Function(s)   : fn_bhs_cutoff
!  Author(s)     : Masakuni Okamoto (May 22, 2007)
!
!  The license of the code and contact address :
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)
!
!=====================================================================
   subroutine calc_bhs_pp_rel(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ips, iso, ishell, ll, kk, i, ir, is_solved, node, nrm, &
              loop, ntries, is_converged
   real(8) :: ff, fn_bhs_cutoff, rf, w1rf_sum, rfrf_sum
   real(8) :: cc(3), ee(3), gg, dd, tmp, rr, ee_check, eps_conv, arg
   real(8),allocatable :: vv1(:), vv2(:), ww1(:), ww2(:), ww_check(:)
   real(8),parameter :: EPS = 1.d-8
   real(8),parameter :: LAMBDA = 3.5d0, EPS_EIGEN = 1.d-13
   integer,parameter :: MAXLOOP = 50, MAXTRIES = 3
  !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   allocate(vv1(nmesh),vv2(nmesh),ww1(nmesh),ww2(nmesh),ww_check(nmesh))
      vv1 = 0.d0 ; vv2 = 0.d0 ; ww1 = 0.d0 ; ww2 = 0.d0 ; ww_check = 0.d0
  !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

! ==================================== modified by K. T. ========== 4.0
!   rho_ps(:) = 0.d0
   rho_ps = 0.d0
! ================================================================ 4.0
   chi_ps(:,:,:) = 0.d0
   veff_ps(:,:,:) = 0.d0

   do ips = 1,nps
   do iso = 1,num_so_ps(ips)
      ishell = ishell_ps(ips,iso)
      ll = l_qnum(ishell)
      if (is_solve(ishell) /= 0) then
         call write_param_bhs(ier,IFLOG,ips,iso)
         ntries = 0
         is_converged = NO
         eps_conv = EPS
         do while ((ntries < MAXTRIES).and.(is_converged == NO))
            ntries = ntries + 1
            cc(1) = -200.d0 ; cc(3) = 200.d0 ; cc(2) = (cc(1) + cc(3)) * 0.5d0
            ee(:) = cc(:)
            loop = 0
            do while ((abs(ee(2) - engy(ishell)) > eps_conv).and.(loop < MAXLOOP))
               loop = loop + 1
               write(IFLOG,'(1x,a27,7f15.10)') 'BHS_CCC: c1,c2,c3,e1,e2,e3,ee', &
                  cc(:),ee(:),engy(ishell)
               do i = 1,3
                  do ir = 1,nmesh
                     ff = fn_bhs_cutoff(rpos(ir)/rcut_phi_ps(ips,1))
                     vv1(ir) = veff(ir,nspin,lmax_core)*(1.d0 - ff) + cc(i)*ff
                  end do
                  node = 0
                  call calc_bound_state_bhs(ier,IFLOG, &
                     iord_pc,iord_nec,iord_diff,dx,EPS_EIGEN, &
                     nmesh,rpos,wr,vv1,ll,node, &
                     is_solved,ee(i),ww1)
                  if (ier /= 0) then
                     write(IFLOG,*) '### ERROR ### in calc_bound_state_bhs' ; go to 99
                  end if
               end do
               if (ee(2) < engy(ishell)) then
                  cc(1) = cc(2) ; cc(2) = (cc(1) + cc(3)) * 0.5d0
               else
                  cc(3) = cc(2) ; cc(2) = (cc(1) + cc(3)) * 0.5d0
               end if
            end do
            if (loop < MAXLOOP) then
               is_converged = YES
            else
               is_converged = NO
               eps_conv = eps_conv * 1.d2
            end if
         end do
         if (is_converged == NO) then
            write(IFLOG,*) 'LOOP for finding c0 was not converged. ll =',ll
            write(*,*) 'LOOP for finding c0 was not converged. ll =',ll
            stop
         end if
         write(IFLOG,*) 'BHS_C0: ll,ips,iso,cc(2) ...',ll,ips,iso,cc(2)
         write(IFLOG,*) 'BHS_C0: ee(2) - engy     ...',ee(2) - engy(ishell)
         write(IFLOG,*) 'BHS_C0: <w1|w1>          ...',sum(ww1(:)**2*wr(:))
         nrm = nrm_pos(ishell)
         gg = chi_g(nrm,ishell) / ww1(nrm)
         w1rf_sum = 0.d0
         rfrf_sum = 0.d0
         do ir = 1,nmesh
            ff = fn_bhs_cutoff(rpos(ir)/rcut_phi_ps(ips,1))
            rf = rpos(ir)**(ll+1) * ff
            w1rf_sum = w1rf_sum + ww1(ir)*rf*wr(ir)
            rfrf_sum = rfrf_sum + rf*rf*wr(ir)
         end do
         dd = - w1rf_sum + sqrt( &
               w1rf_sum*w1rf_sum - (1.d0 - 1.d0/(gg*gg)) * rfrf_sum )
         dd = dd / rfrf_sum
         do ir = 1,nmesh
            ff = fn_bhs_cutoff(rpos(ir)/rcut_phi_ps(ips,1))
            rf = rpos(ir)**(ll+1) * ff
            ww2(ir) = gg*( ww1(ir) + dd*rf )
         end do
         chi_ps(:,ips,iso) = ww2(:)

! ======================================== modified by K. T. ============ 4.0
!         rho_ps(:) = rho_ps(:) + focc(ishell)*ww2(:)**2
         rho_ps(:,1) = rho_ps(:,1) + focc(ishell)*ww2(:)**2
! ======================================================================== 4.0
         write(IFLOG,*) 'BHS_C0: gamma            ...',gg
         write(IFLOG,*) 'BHS_C0: delta            ...',dd
         write(IFLOG,*) 'BHS_C0: <w2|w2>          ...',sum(ww2(:)**2*wr(:))
         do ir = 1,nmesh
            ff = fn_bhs_cutoff(rpos(ir)/rcut_phi_ps(ips,1))
            rf = rpos(ir)**(ll+1) * ff
            rr = (rpos(ir)/rcut_phi_ps(ips,1))**LAMBDA
            tmp = LAMBDA*LAMBDA*rr*rr - LAMBDA*(2*ll + LAMBDA + 1)*rr
            vv2(ir) = vv1(ir) + dd*rf/ww2(ir) * ( &
               engy(ishell) - vv1(ir) + tmp/(2.d0*rpos(ir)*rpos(ir)) )
         end do
         veff_ps(:,ips,iso) = vv2(:)
         node = 0
         call calc_bound_state_bhs(ier,IFLOG, &
            iord_pc,iord_nec,iord_diff,dx,eps_de, &
            nmesh,rpos,wr,veff_ps(1,ips,iso),ll,node, &
            is_solved,ee_check,ww_check)
         if (ier /= 0) then
            write(IFLOG,*) '### ERROR ### in calc_bound_state_bhs'
            go to 99
         end if
         write(IFLOG,*) 'BHS_C0: engy             ...',engy(ishell)
         write(IFLOG,*) 'BHS_C0: ee_check         ...',ee_check
      end if
   end do
   end do

! =================================== modified by K. T. ================ 4.0
!   rho_ps(:) = rho_ps(:) / (4.d0*PI*rpos(:)**2)
!   write(IFLOG,*) 'BHS_C0: sum of rho_ps(:) ...',sum(4.d0*PI*rpos(:)**2*rho_ps(:)*wr(:))

   rho_ps(:,1) = rho_ps(:,1) / (4.d0*PI*rpos(:)**2)
   write(IFLOG,*) 'BHS_C0: sum of rho_ps(:) ...',sum(4.d0*PI*rpos(:)**2*rho_ps(:,1)*wr(:))
! ======================================================================= 4.0

   if (is_pcc == PCC) then
      select case (is_pcc_method)
      case (BHSPCC)
         write(IFLOG,*) 'PCC: using special PCC of the BHS type'
         write(IFSUM,*) 'PCC: using special PCC of the BHS type'
         do ir = 1,nmesh
            arg = a_bhspcc * rpos(ir) * rpos(ir)
            arg = min(arg,99.d0)
            rho_pcore(ir) = b_bhspcc * exp(-arg) / (4.d0*PI)
         end do
      case (POLYNOMIAL, SBESSEL)
         call calc_rho_pcore_sol(ier)
      end select
      if (ier /= 0) then
         write(IFLOG,*) '### ERROR ### in calc_rho_pcore_sol' ; go to 99
      end if
      !!!call check_rho_pcore_sol(ier)
      !!!call calc_pcc_fourier_sol(ier)
      !if (ier /= 0) then
      !   write(IFLOG,*) '### ERROR ### in calc_pcc_fourier_sol' ; go to 99
      !end if
   end if
  !++++++++++++++++++++++++++++++++++++++++++++++++++++++
   if (is_xc_class == GGA) then

! =================================== modified by K. T. =================== 4.0
!      allocate(drho_ps(nmesh),ddrho_ps(nmesh))
      allocate(drho_ps(nmesh,1),ddrho_ps(nmesh,1))
! ========================================================================= 4.0

      drho_ps = 0.d0 ; ddrho_ps = 0.d0

      allocate(drho_core(nmesh),ddrho_core(nmesh))
         drho_core = 0.d0 ; ddrho_core = 0.d0
      if (is_pcc == PCC) then
         allocate(drho_pcore(nmesh),ddrho_pcore(nmesh))
            drho_pcore = 0.d0 ; ddrho_pcore = 0.d0
      end if
   end if
  !++++++++++++++++++++++++++++++++++++++++++++++++++++++
   if (is_xc_class == GGA) then
      call calc_drho_ddrho_ps(ier)
   end if
   call calc_vh_bhs(ier,nmesh,rpos,rho_ps,vh_ps)
   if (ier /= 0) then
      write(IFLOG,*) '### ERROR ### in calc_vh_bhs' ; go to 99
   end if

! ================================================ modified by K. T. ========= 4.0
!   vx_ps(:) = 0.d0 ; vxpc_ps(:) = 0.d0
!   vc_ps(:) = 0.d0 ; vcpc_ps(:) = 0.d0
!   ex_ps(:) = 0.d0 ; expc_ps(:) = 0.d0
!   ec_ps(:) = 0.d0 ; ecpc_ps(:) = 0.d0
!
   vx_ps = 0.d0 ; vxpc_ps(:) = 0.d0
   vc_ps = 0.d0 ; vcpc_ps(:) = 0.d0
   ex_ps = 0.d0 ; expc_ps(:) = 0.d0
   ec_ps = 0.d0 ; ecpc_ps(:) = 0.d0
! ============================================================================= 4.0

   call calc_vxc_exc_bhs(ier)
   if (ier /= 0) then
      write(IFLOG,*) '### ERROR ### in calc_vxc_exc_bhs' ; go to 99
   end if
   vion_ps(:,:,:) = 0.d0
   do ips = 1,nps
   do iso = 1,num_so_ps(ips)
      vion_ps(:,ips,iso) = veff_ps(:,ips,iso) &
! ================================================ modified by K. T. ========= 4.0
!         - vh_ps(:) - vx_ps(:) - vc_ps(:)
         - vh_ps(:) - vx_ps(:,1) - vc_ps(:,1)
! ============================================================================ 4.0
   end do
   end do
   vscr_bhs(:,:) = 0.d0
   vion_bhs(:,:) = 0.d0
   vso_bhs(:,:)  = 0.d0
   do ips = 1,nps
      do iso = 1,num_so_ps(ips)
         ishell = ishell_ps(ips,iso)
         ll = l_qnum(ishell)
         kk = k_qnum(ishell)
         if (ll == 0) then
            vscr_bhs(:,ips) = veff_ps(:,ips,iso)
            vion_bhs(:,ips) = vion_ps(:,ips,iso)
            vso_bhs (:,ips) = 0.d0
         else if (kk < 0) then
            vscr_bhs(:,ips) = vscr_bhs(:,ips) + veff_ps(:,ips,iso)*dble(ll+1)
            vion_bhs(:,ips) = vion_bhs(:,ips) + vion_ps(:,ips,iso)*dble(ll+1)
            vso_bhs (:,ips) = vso_bhs (:,ips) + vion_ps(:,ips,iso)*2.d0
         else
            vscr_bhs(:,ips) = vscr_bhs(:,ips) + veff_ps(:,ips,iso)*dble(ll)
            vion_bhs(:,ips) = vion_bhs(:,ips) + vion_ps(:,ips,iso)*dble(ll)
            vso_bhs (:,ips) = vso_bhs (:,ips) - vion_ps(:,ips,iso)*2.d0
         end if
      end do
      vscr_bhs(:,ips) = vscr_bhs(:,ips) / dble(2*ll+1)
      vion_bhs(:,ips) = vion_bhs(:,ips) / dble(2*ll+1)
      vso_bhs (:,ips) = vso_bhs (:,ips) / dble(2*ll+1)
   end do

  !+++++++++++++++++++++++++++++++++++++++++
   if (is_xc_class == GGA) then
      deallocate(drho_core,ddrho_core)
      if (is_pcc == PCC) then
         deallocate(drho_pcore,ddrho_pcore)
      end if
   end if
  !+++++++++++++++++++++++++++++++++++++++++
  !+++++++++++++++++++++++++++++++++++++
   deallocate(vv1,vv2,ww1,ww2,ww_check)
  !+++++++++++++++++++++++++++++++++++++
99 continue
   end subroutine calc_bhs_pp_rel
   
!=====================================================================
   subroutine write_param_bhs(ier,ifile,ips,iso)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(in)  :: ifile, ips, iso
   integer,intent(out) :: ier
   integer :: n1, l1, ishell, n2, l2, k2, jj
   real(8) :: psi2_sum, g2_sum, f2_sum, vmax, vmin
   ier = 0
   n1 = n_val_label_ps(ips)
   l1 = l_val_label_ps(ips)
   ishell = ishell_ps(ips,iso)
   n2 = n_qnum(ishell)
   l2 = l_qnum(ishell)
   k2 = k_qnum(ishell)
   jj = j2_qnum(ishell)
   write(ifile,*)
   write(ifile,*) 'ips,iso   ...',ips,iso
   write(ifile,*) 'n1,l1     ...',n1,l1
   write(ifile,*) 'n2,l2,k2  ...',n2,l2,k2
   write(ifile,*) '2*j       ...',jj
   write(ifile,*) 'ishell    ...',ishell
   write(ifile,*) 'focc      ...',focc(ishell)
   write(ifile,*) 'Rcut      ...',rcut_phi_ps(ips,1)
   write(ifile,*) 'Rcut (A)  ...',rcut_phi_ps(ips,1)*BOHR
   write(ifile,*) 'is_gen_ps ...',is_gen_ps(ips,iso)
   write(ifile,*) 'is_solve  ...',is_solve(ishell)
   write(ifile,*) 'E         ...',engy(ishell)
   write(ifile,*) 'E (eV)    ...',engy(ishell)*HARTREE
   g2_sum = sum(chi_g(:,ishell)**2*wr(:))
   f2_sum = sum(chi_f(:,ishell)**2*wr(:))
   psi2_sum = g2_sum + f2_sum
   !write(ifile,*) 'g2_sum    ...',g2_sum
   !write(ifile,*) 'f2_sum    ...',f2_sum
   write(ifile,*) 'psi2_sum  ...',psi2_sum
   write(ifile,*) 'nrm       ...',nrm_pos(ishell)
   write(ifile,*) 'Rm        ...',rpos(nrm_pos(ishell))
   write(ifile,*) 'Rm (A)    ...',rpos(nrm_pos(ishell))*BOHR
   vmax = maxval(veff(:,nspin,lmax_core))
   vmin = minval(veff(:,nspin,lmax_core))
   write(ifile,*) 'Vmax      ...',vmax
   write(ifile,*) 'Vmin      ...',vmin
   end subroutine write_param_bhs

!=====================================================================
   subroutine find_nrc_bhs(ier,nmesh,rpos,rcut,nrc)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   implicit none
   integer,intent(in)  :: nmesh
   real(8),intent(in)  :: rpos(nmesh), rcut
   integer,intent(out) :: ier, nrc
   integer :: ir
   ier = 0
   do ir = nmesh,10,-1
      if (rpos(ir) < rcut) then
         nrc = ir+1 ; exit
      end if
      if (ir == 10) then
         write(*,*) '### ERROR ### nrc was not found.'
         ier = 1 ; go to 99
      end if
   end do
99 continue
   end subroutine find_nrc_bhs

!=====================================================================
   function fn_bhs_cutoff(x)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   implicit none
   real(8) :: fn_bhs_cutoff
   real(8),intent(in) :: x
   real(8) :: arg
   real(8),parameter :: LAMBDA = 3.5d0
   arg = abs(x)**LAMBDA
   if (arg > 99.d0) then
      fn_bhs_cutoff = 0.d0
   else
      fn_bhs_cutoff = exp(-arg)
   end if
   end function fn_bhs_cutoff
   
!=====================================================================
   subroutine calc_bound_state_bhs(ier,IFLOG, &
                 iord_pc,iord_nec,iord_diff,dx,eps_de, &
                 nmesh,rpos,wr,vloc_scr,ll,node, &
                 is_solved,ee_solved,rphi_solved)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   implicit none
   integer,intent(in)  :: IFLOG, iord_pc, iord_nec, iord_diff, &
                          nmesh, ll, node
   real(8),intent(in)  :: rpos(nmesh), wr(nmesh), vloc_scr(nmesh), &
                          dx, eps_de
   integer,intent(out) :: ier, is_solved
   real(8),intent(out) :: ee_solved, rphi_solved(nmesh)
   real(8),allocatable :: bsum(:), wt(:), &
                          chi_gl(:), chi_fl(:), &
                          dxchi_gl(:), dxchi_fl(:), &
                          chi_gr(:), chi_fr(:), &
                          dxchi_gr(:), dxchi_fr(:)
   real(8),parameter   :: ARGMAX = 150.d0
   integer :: ir, node_sum, nmesh_max, loop, max_loop, &
              nrm, nrt, num_eslides, max_eslides, lguess
   real(8) :: vloc_min, ee, de, r, vv, ss, rr, fguess, gg_norm, &
              sign_gr, ee_upper_limit, ee_lower_limit,          &
              ee_upper_limit_in, engy_minimum, sum, etest, tmp
   ier = 0
  !++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   allocate(bsum(nmesh),wt(nmesh), &
      chi_gl(nmesh),chi_fl(nmesh),dxchi_gl(nmesh),dxchi_fl(nmesh), &
      chi_gr(nmesh),chi_fr(nmesh),dxchi_gr(nmesh),dxchi_fr(nmesh))
      bsum = 0.d0 ; wt = 0.d0
      chi_gl   = 0.d0 ; chi_fl   = 0.d0
      dxchi_gl = 0.d0 ; dxchi_fl = 0.d0
      chi_gr   = 0.d0 ; chi_fr   = 0.d0
      dxchi_gr = 0.d0 ; dxchi_fr = 0.d0
  !++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   max_eslides    =  25
   max_loop       = 100
   engy_minimum   = 1.d-4
   is_solved      = 1
   ee_solved      = 0.d0
   rphi_solved(:) = 0.d0
   write(IFLOG,*) 'SOL-BHS: ll,node ...',ll,node
   fguess = 1.d0
   lguess = 1
   node_sum = node
   if (mod(node,2) == 0) then
      sign_gr = +1.d0
   else
      sign_gr = -1.d0
   end if
   num_eslides = 0
      write(IFLOG,'(1x,a20,2i5)') &
         'SOL-BHS: ll,node ...',ll,node
   ee = ee_solved
   nmesh_max = nmesh
   do ir = nmesh,10,-1
      r  = rpos(ir)
      vv = vloc_scr(ir)
      ss = sqrt(2.d0*abs(ee-vv))
      if (ss*r < ARGMAX) then
         nmesh_max = ir ; exit
      end if
   end do
   vloc_min = 0.d0
   do ir = 1,nmesh
      r  = rpos(ir)
      vv = vloc_scr(ir)
      if (vv < vloc_min) then
         vloc_min = vv
      end if
   end do
   ee_upper_limit = vloc_scr(nmesh_max) - engy_minimum
   if (ee_upper_limit > -engy_minimum) then
      ee_upper_limit = -engy_minimum
   end if
   ee_upper_limit_in = ee_upper_limit
   ee_lower_limit = vloc_min
   ee = 0.5d0*(ee_upper_limit + ee_lower_limit)
   de = ee
   loop = 0
SRCH_EE:do while (abs(de) > eps_de)
   loop = loop + 1
   if (loop > max_loop) then
      if (lguess < 3) then
         lguess = lguess + 1
         fguess = fguess * 0.5d0
         max_loop = max_loop * 2
         loop = 0
         node_sum = node
         cycle SRCH_EE
      end if
      if (node_sum < node) then
         write(IFLOG,*) '### CAUTION ### node_sum < node'
         write(IFLOG,*) '   node_sum,node ...',node_sum,node
         write(IFLOG,*) &
            '   Following state may be an unbound state.'
         write(IFLOG,*) '      ll ...',ll
         is_solved = 0 ; ee = 0.d0 ; exit SRCH_EE
      else
         write(IFLOG,*) '### ERROR ### loop > max_loop'
         write(IFLOG,*) '   loop, max_loop ...',loop,max_loop
         write(IFLOG,*) '   ll,node        ...',ll,node
         write(IFLOG,*) '   node_sum,node  ...',node_sum,node
         write(IFLOG,*) '   ee_upper_limit ...',ee_upper_limit
         write(IFLOG,*) '   ee_lower_limit ...',ee_lower_limit
         write(IFLOG,*) '   ee             ...',ee
         write(IFLOG,*) '   de             ...',de
         ier=1 ; go to 99
      end if
   end if
   if (num_eslides > max_eslides) then
      write(IFLOG,*) '### CAUTION ### Eigenvalue was not converged !'
      write(IFLOG,*) '      num_eslides  ...',num_eslides
      write(IFLOG,*) '      max_eslides  ...',max_eslides
      write(IFLOG,*) '   Following state may be an unbound state.'
      write(IFLOG,*) '      ll           ...',ll
      is_solved = 0 ; ee = 0.d0 ; exit SRCH_EE
   end if
SRCH_RT:do ir = nmesh_max,10,-1
      r = rpos(ir)
      tmp = vloc_scr(ir)-ee
      if (tmp < 0.d0) then
         nrt = ir ; exit SRCH_RT
      end if
   end do SRCH_RT
   bsum = 0.d0
   call set_initpoints_left_sol(ier,nmesh,ll,ee,rpos, &
           chi_gl,chi_fl,dxchi_gl,dxchi_fl,vloc_scr,bsum)
   call int_from_left_sol(ier,nmesh,node_sum,nrt, &
           ll,ee,iord_nec,dx,rpos, &
           chi_gl,chi_fl,dxchi_gl,dxchi_fl,vloc_scr,bsum)
   if (ier /= 0) then
      write(IFLOG,*) '### ERROR ### in int_from_left_sol'
      go to 99
   end if
   do ir = 1,nrt
      r = rpos(ir)
      chi_fl(ir) = dxchi_gl(ir)/r - dble(ll+1)/r*chi_gl(ir)
   end do
   if (node_sum > node) then
      if (ee < ee_upper_limit) then
         ee_upper_limit = ee
      end if
      if (ee_upper_limit > ee_upper_limit_in) then
         ee_upper_limit = ee_upper_limit_in
      end if
      ee = 0.5d0*(ee + ee_lower_limit)
      ee_lower_limit = ee_lower_limit * 1.2d0
      cycle SRCH_EE
   else if (node_sum < node) then
      if (ee > ee_lower_limit) then
         ee_lower_limit = ee
      end if
      ee = 0.5d0*(ee_upper_limit + ee)
      ee_upper_limit = ee_upper_limit_in
      ee = 0.5d0*(ee_upper_limit + ee)
      cycle SRCH_EE
   end if
      nrm = nrt
SRCH_RM:do ir = nrt,10,-1
      if (sign_gr*(chi_gl(ir-1)-chi_gl(ir)) < 0.d0) then
         nrm = ir ; exit SRCH_RM
      end if
   end do SRCH_RM
   nmesh_max = nmesh
   do ir = nmesh,10,-1
      r  = rpos(ir)
      vv = vloc_scr(ir)
      ss = sqrt(2.d0*abs(ee-vv))
      if (ss*r < ARGMAX) then
         nmesh_max = ir ; exit
      end if
   end do
   if (nmesh_max < nmesh) then
      r  = rpos(nmesh_max)
      vv = vloc_scr(nmesh_max)
      ss = sqrt(2.d0*abs(ee-vv))
      do ir = nmesh_max+1,nmesh
         r  = rpos(ir)
         vv = vloc_scr(ir)
         ss = sqrt(2.d0*abs(ee-vv))
         chi_gr(ir) = exp(-ss*r) * sign_gr
         chi_fr(ir) = -ss * chi_gr(ir) 
         dxchi_gr(ir) = 0.d0
         dxchi_fr(ir) = 0.d0
      end do
   end if
   bsum = 0.d0
   call set_initpoints_right_sol(ier,nmesh,nmesh_max,ll,ee,rpos, &
           chi_gr,chi_fr,dxchi_gr,dxchi_fr,vloc_scr,bsum,sign_gr)
   if (ier /= 0) then
      write(IFLOG,*) '### ERROR ### in set_initpoints_right_sol'
      go to 99
   end if
   nrt = nrm - 1 - max(iord_pc,iord_diff)
   call int_from_right_sol(ier,nmesh,nmesh_max,nrt, &
           ll,ee,iord_nec,dx,rpos, &
           chi_gr,chi_fr,dxchi_gr,dxchi_fr,vloc_scr,bsum)
   if (ier /= 0) then
      write(IFLOG,*) '### ERROR ### in int_from_right_sol'
      go to 99
   end if
   rr = chi_gl(nrm) / chi_gr(nrm)
   do ir = nmesh,nrt,-1
        chi_gr(ir) =   chi_gr(ir) * rr
        chi_fr(ir) =   chi_fr(ir) * rr
      dxchi_gr(ir) = dxchi_gr(ir) * rr
      dxchi_fr(ir) = dxchi_fr(ir) * rr
   end do
   call guess_de_sol(ier,IFLOG,nmesh,nrm,rpos,wt, &
           chi_gl,chi_fl,chi_gr,chi_fr,de,fguess,gg_norm)
   if (ier /= 0) then
      write(IFLOG,*) '### ERROR ### in guess_de' ; go to 99
   end if
   if (de > 0.d0) then
      ee_lower_limit = ee
   else if (de < 0.d0) then
      ee_upper_limit = ee
      if (ee_upper_limit > ee_upper_limit_in) then
         ee_upper_limit = ee_upper_limit_in
      end if
   end if
   etest = ee + de
   if ((etest-ee_upper_limit)*(etest-ee_lower_limit) < 0.d0) then
      ee = etest
   else
      ee = 0.5d0*(ee_upper_limit + ee_lower_limit)
      num_eslides = num_eslides + 1
   end if
      write(IFLOG,'(1x,a25,i5,f25.15,1pe20.10)') &
        '### SBHS ### ll,ee,de ...',ll,ee,de
end do SRCH_EE
   if (is_solved /= 0) then
      ee_solved = ee
   else
      ee_solved = 0.d0
   end if
   if (is_solved /= 0) then
      do ir = 1,nrm
         rphi_solved(ir) = chi_gl(ir)
      end do
      do ir = nrm,nmesh
         rphi_solved(ir) = chi_gr(ir)
      end do
   else
      rphi_solved(:) = 0.d0
   end if
   if (is_solved /= 0) then
      sum = 0.d0
      do ir = 1,nmesh
         sum = sum + rphi_solved(ir)**2*wr(ir)
      end do
      rphi_solved(:) = rphi_solved(:)/sqrt(sum)*sign_gr
   end if
   do ir = 1,nmesh
      if (abs(rphi_solved(ir)) < 1.d-99) then
         rphi_solved(ir) = 0.d0
      end if
   end do
99 continue
  !++++++++++++++++++++++++++++++++++++++
   deallocate(bsum,wt, &
      chi_gl,chi_fl,dxchi_gl,dxchi_fl, &
      chi_gr,chi_fr,dxchi_gr,dxchi_fr)
  !++++++++++++++++++++++++++++++++++++++
   end subroutine calc_bound_state_bhs

!=====================================================================
   subroutine calc_vh_bhs(ier,nmesh,rpos,rho,vh)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   implicit none
   integer,intent(in)  :: nmesh
   real(8),intent(in)  :: rpos(nmesh), rho(nmesh)
   integer,intent(out) :: ier
   real(8),intent(out) :: vh(nmesh)
   integer :: ir, ii, i0, is, j, jr
   real(8) :: sum1, sum2
   real(8),allocatable :: wt(:)
   real(8),parameter :: &
      PI = 3.1415926535897932384626433832795028d0
   ier = 0
  !++++++++++++++++++++++++++++++++
   allocate(wt(nmesh)) ; wt = 0.d0
  !++++++++++++++++++++++++++++++++
   do ir = 1,nmesh
      sum1 = 0.d0
      sum2 = 0.d0
      if (ir == 1) then
         sum1 = 0.d0
      else if ((ir >= 2).and.(ir <= 5)) then
         do ii = 2,ir
            i0 = ii-1
            is = 1
            call set_open_weight_exp(ier,i0,is,rpos,wt)
            do j = 1,4
               sum1 = sum1 &
                  + rpos(i0+j*is)**2*rho(i0+j*is)*wt(i0+j*is)
            end do
         end do
      else
         call set_weight_exp(ier,1,ir,rpos,wt)
         do jr = 1,ir
            sum1 = sum1 + rpos(jr)**2*rho(jr)*wt(jr)
         end do
      end if
      sum1 = sum1*(4.d0*PI/rpos(ir))
      if (ir == nmesh) then
            sum2 = 0.d0
      else if ((ir <= nmesh-1).and.(ir >= nmesh-4)) then
         do ii = ir,nmesh-1
            i0 = ii+1
            is = -1
            call set_open_weight_exp(ier,i0,is,rpos,wt)
            do j = 1,4
               sum2 = sum2 &
                    - rpos(i0+j*is)**2*rho(i0+j*is)*wt(i0+j*is)
            end do
         end do
      else
         call set_weight_exp(ier,ir,nmesh,rpos,wt)
         do jr = ir,nmesh
            sum2 = sum2 + rpos(jr)*rho(jr)*wt(jr)
         end do
      end if
      sum2 = sum2*(4.d0*PI)
      vh(ir) = sum1 + sum2
   end do
  !+++++++++++++++
   deallocate(wt)
  !+++++++++++++++
99 continue
   end subroutine calc_vh_bhs

!=====================================================================
   subroutine calc_vxc_exc_bhs(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
  !++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

! ================================ modified by K. T. ================== 4.0
!   allocate(rho_sol(nmesh)) ; rho_sol = 0.d0
!   allocate(ex_sol(nmesh),ec_sol(nmesh),vx_sol(nmesh),vc_sol(nmesh))
!
   allocate(rho_sol(nmesh,1)) ; rho_sol = 0.d0
   allocate(ex_sol(nmesh),ec_sol(nmesh),vx_sol(nmesh,1),vc_sol(nmesh,1))
! ======================================================================= 4.0

   ex_sol = 0.d0 ; ec_sol = 0.d0
   vx_sol = 0.d0 ; vc_sol = 0.d0

   allocate( &
      expc_sol(nmesh),ecpc_sol(nmesh),vxpc_sol(nmesh),vcpc_sol(nmesh))
      expc_sol = 0.d0 ; ecpc_sol = 0.d0
      vxpc_sol = 0.d0 ; vcpc_sol = 0.d0

   if (is_xc_class == GGA) then
! ============================================ modified by K. T. ========== 4.0
!      allocate(drho_sol(nmesh),ddrho_sol(nmesh))
      allocate(drho_sol(nmesh,1),ddrho_sol(nmesh,1))
! =========================================================================== 4.0
         drho_sol = 0.d0 ; ddrho_sol = 0.d0
   end if
  !++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

! ======================================= modified by K. T. ================ 4.0
!   rho_sol(:) = rho_ps(:)
!  if (is_xc_class == GGA) then
!      drho_sol (:) = drho_ps (:)
!      ddrho_sol(:) = ddrho_ps(:)
!   end if
!
   rho_sol(:,:) = rho_ps(:,:)
   if (is_xc_class == GGA) then
      drho_sol (:,:) = drho_ps (:,:)
      ddrho_sol(:,:) = ddrho_ps(:,:)
   end if
! ============================================================================ 4.0

   call calc_vxc_exc_sol(ier)
   if (ier /= 0) then
      write(IFLOG,*) '### ERROR ### in calc_vxc_exc_sol' ; go to 99
   end if

! ========================================= modified by K. T. ============ 4.0
!   vx_ps(:) = vx_sol(:)
!   vc_ps(:) = vc_sol(:)
   vx_ps(:,:) = vx_sol(:,:)
   vc_ps(:,:) = vc_sol(:,:)
! ========================================================================= 4.0

   ex_ps(:) = ex_sol(:)
   ec_ps(:) = ec_sol(:)

   vxpc_ps(:) = vxpc_sol(:)
   vcpc_ps(:) = vcpc_sol(:)
   expc_ps(:) = expc_sol(:)
   ecpc_ps(:) = ecpc_sol(:)
  !++++++++++++++++++++++++++++++++++++++++++++++++
   if (allocated(drho_sol)) then
      deallocate(drho_sol,ddrho_sol)
   end if
   deallocate(expc_sol,ecpc_sol,vxpc_sol,vcpc_sol)
   deallocate(ex_sol,ec_sol,vx_sol,vc_sol)
   deallocate(rho_sol)
  !++++++++++++++++++++++++++++++++++++++++++++++++
99 continue
   end subroutine calc_vxc_exc_bhs

!=====================================================================
   subroutine calc_drho_ddrho_ps(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ir
   ier = 0
   call calc_ddiff_exp(ier,iord_diff,nmesh,rpos, &
           rho_ps,drho_ps,ddrho_ps)
   call calc_ddiff_rho_origin(ier,iord_diff,nmesh, &
           rpos,rho_ps,drho_ps,ddrho_ps)
   do ir = nmesh-iord_diff*2-1,nmesh
! ========================================================== modified by K. T. ==== 4.0
!        rho_ps(ir) =   rho_ps(nmesh-iord_diff*2-2)
!       drho_ps(ir) =  drho_ps(nmesh-iord_diff*2-2)
!      ddrho_ps(ir) = ddrho_ps(nmesh-iord_diff*2-2)
!
        rho_ps(ir,1) =   rho_ps(nmesh-iord_diff*2-2,1)
       drho_ps(ir,1) =  drho_ps(nmesh-iord_diff*2-2,1)
      ddrho_ps(ir,1) = ddrho_ps(nmesh-iord_diff*2-2,1)
! ================================================================================ 4.0
   end do
99 continue
   end subroutine calc_drho_ddrho_ps

!=====================================================================
   subroutine write_bhspp(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ips, ishell, ll, ir
   character(1) :: fn_label_orbital
   ier = 0
   do ips = 1,nps
      if (is_gen_ps(ips,1) == 0) then
         cycle
      end if
      ishell = ishell_ps(ips,1)
      ll = l_qnum(ishell)
      bhsppfile = trim(jobname)//'_'//fn_label_orbital(ll)//'.bhspp'
      open(IFBHSPP,file=trim(bhsppfile),status='unknown')
      rewind(IFBHSPP)
      write(IFLOG,*) '   Writing BHSPP for l -->',ll
      write(IFBHSPP,10) 'BHS pseudopotential for valence-orbital ll =',ll
      write(IFBHSPP,20) 'r', 'r*psi', 'r*phi', 'rho_core', 'rho_pc', 'rho_pp', &
                        'vae_scr', 'vpp_scr', 'vpp_ion', 'vpp_so'
      do ir = 1,nmesh
         write(IFBHSPP,21) &
            rpos(ir), &
            chi_g(ir,ishell), &
            !chi_f(ir,ishell), &
            chi_ps(ir,ips,1), &
            !chi_ps(ir,ips,2), &
            rho_core(ir), &
            rho_pcore(ir), &

! ================================================== modified by K. T. ======= 4.0
!            rho_ps(ir), &
            rho_ps(ir,1), &
! =========================================================================== 4.0

            veff(ir,nspin,lmax_core), &
            vscr_bhs(ir,ips), &
            vion_bhs(ir,ips), &
            vso_bhs(ir,ips)
      end do
      write(IFLOG,*) 'BHSPP data have been saved into ... ',trim(bhsppfile)
      write(IFSUM,*) 'BHSPP data have been saved into ... ',trim(bhsppfile)
      close(IFBHSPP)
   end do
10 format('#',1x,a45,i5)
20 format(('#',18x,a1),2(15x,a5),(12x,a8),2(14x,a6),3(13x,a7),(14x,a6))
21 format(12(1pe20.10))
   end subroutine write_bhspp

!=====================================================================
   subroutine calc_rcut_bhs
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer :: ips, ishell, iso, tt
   real(8) :: rsum
   do ips = 1,nps
      tt = 1
      if (is_gen_ps(ips,1) == 0) then
         cycle
      end if
      rsum = 0.d0
      do iso = 1,num_so_ps(ips)
         ishell = ishell_ps(ips,iso)
         rsum = rsum + rpos(nrm_pos(ishell))
      end do
      rsum = rsum / dble(num_so_ps(ips))
      rcut_phi_ps(ips,tt) = rsum / rcut_phi_ps(ips,tt)
   end do
   end subroutine calc_rcut_bhs

!=====================================================================
   subroutine write_rcut_bhs(ifile)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(in) :: ifile
   integer        :: i, ishell, ips, iso, tt
   real(8)        :: rcut
   character(100) :: line
   do i = 1,100
      line(i:i)='-'
   end do
   write(ifile,*)
   write(ifile,*) 'rcut  Cutoff radii for BHS-PP'
   write(ifile,10) line(1:100)
   write(ifile,11) 'symm','j', &
                   'rcut (Bohr)','   rcut (A)'
   write(ifile,10) line(1:100)
   do ips = 1,nps
      tt = 1
      !if (is_gen_ps(ips,1) == 0) then
      !   cycle
      !end if
      do iso = 1,num_so_ps(ips)
         ishell = ishell_ps(ips,iso)
         rcut = rcut_phi_ps(ips,tt)
         write(ifile,12) state(ishell)(1:2),j2_qnum(ishell), &
            rcut,rcut*BOHR
      end do
   end do
   write(ifile,10) line(1:100)
10 format(1x,'rcut',a55)
11 format(1x,'rcut',(3x,a4),(4x,a1,1x),2(9x,a11))
12 format(1x,'rcut',(4x,a2,1x),(3x,i1,'/2'),2(f20.10))
   end subroutine write_rcut_bhs

! ************************************************************* 
!
!   This is a software package CIAO
!
!     developed as a part of the national project "Research and 
!     Development of Innovative Simulation software",which is   
!     supported by the next-generation IT program of MEXT of Japan
!
!   latest version: 
!
!     4.0:  2013/01/17 
!           codes for spin-polarized pseudopotential generation are added
!
! ************************************************************* 
!
!  Software name : CIAO (Code for Investigating Atomic Orbitals)
!  Subroutine(s) : calc_nonscf_sol, calc_scf_ss, check_conv_ss
!                : mix_rho_ss
!  Author(s)     : Masakuni Okamoto (August 25, 2003)
!
!  The license of the code and contact address :
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)
!
!=====================================================================
   subroutine calc_nonscf_sol(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------  
   use parameters   
   implicit none
   integer,intent(out) :: ier
   ier = 0
   felec_sol = felec_val

! ============================================ modified by K. T. ========= 4.0
!   vloc_scr_sol(:) = vloc_scr_us(:)
   vloc_scr_sol(:,:) = vloc_scr_us(:,:)
! ======================================================================== 4.0

   call set_focc_sol(ier)
   if (ier /= 0) then
      write(IFLOG,*) '### ERROR ### in set_focc_sol' ; go to 99
   end if
   call calc_bound_state_nonscf_sol(ier)
   if (ier /= 0) then
      write(IFLOG,*) '### ERROR ### in calc_bound_state_nonscf_sol' ; go to 99
   end if
   call sort_engy_sol(ier)
   if (ier /= 0) then
      write(IFLOG,*) '### ERROR ### in sort_engy_sol' ; go to 99
   end if
   call calc_rho_sol(ier)
   if (ier /= 0) then
      write(IFLOG,*) '### ERROR ### in calc_rho_sol' ; go to 99
   end if
   if (is_pcc == PCC) then
      call calc_rho_pcore_sol(ier)
      if (ier /= 0) then
         write(IFLOG,*) '### ERROR ### in calc_rho_pcore_sol' ; go to 99
      end if
      call check_rho_pcore_sol(ier)
      call calc_pcc_fourier_sol(ier)
      if (ier /= 0) then
         write(IFLOG,*) '### ERROR ### in calc_pcc_fourier_sol' ; go to 99
     end if
   end if
   call check_negative_rho_sol(ier)
   if (ier /= 0) then
      write(IFLOG,*) '### ERROR ### in check_negative_rho_sol' ; go to 99
   end if
   if (is_xc_class == GGA) then
   select case (is_xc)
   case (GGAPBE96_MOMO)
      call calc_drho_ddrho_sol(ier)
      if (ier /= 0) then
         write(IFLOG,*) '### ERROR ### in calc_drho_ddrho_sol' ; go to 99
      end if
      call calc_drho_ddrho_core_sol(ier)
      if (ier /= 0) then
         write(IFLOG,*) '### ERROR ### in calc_drho_ddrho_core' ; go to 99
      end if
      if (is_pcc == PCC) then
         call calc_drho_ddrho_pcore_sol(ier)
         if (ier /= 0) then
            write(IFLOG,*) '### ERROR ### in calc_drho_ddrho_pcore' ; go to 99
         end if
      end if
   case default
      call calc_drho_sol(ier)
      if (ier /= 0) then
         write(IFLOG,*) '### ERROR ### in calc_drho_sol' ; go to 99
      end if
      call calc_drho_core_sol(ier)
      if (ier /= 0) then
         write(IFLOG,*) '### ERROR ### in calc_drho_core' ; go to 99
      end if
      if (is_pcc == PCC) then
         call calc_drho_pcore_sol(ier)
         if (ier /= 0) then
            write(IFLOG,*) '### ERROR ### in calc_drho_pcore' ; go to 99
         end if
      end if
   end select
   end if
   call calc_vloc_ion_sol(ier)
   if (ier /= 0) then
      write(IFLOG,*) '### ERROR ### in calc_vloc_ion_sol' ; go to 99
   end if
99 continue
   end subroutine calc_nonscf_sol

!============================ added by K. T. ===================== 4.0
subroutine calc_nonscf_sol_kt(ier)
  use parameters   
  implicit none

  integer,intent(out) :: ier
  ier = 0
  felec_sol = felec_val

  vloc_scr_sol(:,:) = vloc_scr_us(:,:)

  call set_focc_sol(ier)
  if (ier /= 0) then
     write(IFLOG,*) '### ERROR ### in set_focc_sol' ; go to 99
  end if

  call calc_bound_state_nonscf_sol_kt(ier)
  if (ier /= 0) then
     write(IFLOG,*) '### ERROR ### in calc_bound_state_nonscf_sol_kt' ; go to 99
  end if

  call sort_engy_sol(ier)
  if (ier /= 0) then
     write(IFLOG,*) '### ERROR ### in sort_engy_sol' ; go to 99
  end if

!  write(*,*) engy_sol
!  stop

  call calc_rho_sol_kt(ier)
  if (ier /= 0) then
     write(IFLOG,*) '### ERROR ### in calc_rho_sol_kt' ; go to 99
  end if


  if (is_pcc == PCC) then
     call calc_rho_pcore_sol(ier)
     if (ier /= 0) then
        write(IFLOG,*) '### ERROR ### in calc_rho_pcore_sol' ; go to 99
     end if

     call check_rho_pcore_sol(ier)
     call calc_pcc_fourier_sol(ier)
     if (ier /= 0) then
        write(IFLOG,*) '### ERROR ### in calc_pcc_fourier_sol' ; go to 99
     end if

  end if

  call check_negative_rho_sol_kt(ier)
  if (ier /= 0) then
     write(IFLOG,*) '### ERROR ### in check_negative_rho_sol_kt' ; go to 99
  end if
  
  if (is_xc_class == GGA) then
     select case (is_xc)

     case (GGAPBE96_MOMO)
        call calc_drho_ddrho_sol_kt(ier)
        if (ier /= 0) then
           write(IFLOG,*) '### ERROR ### in calc_drho_ddrho_sol' ; go to 99
        end if

        call calc_drho_ddrho_core_sol(ier)
        if (ier /= 0) then
           write(IFLOG,*) '### ERROR ### in calc_drho_ddrho_core' ; go to 99
        end if

        if (is_pcc == PCC) then
           call calc_drho_ddrho_pcore_sol(ier)
           if (ier /= 0) then
              write(IFLOG,*) '### ERROR ### in calc_drho_ddrho_pcore' ; go to 99
           end if
        end if

     case default
        call calc_drho_sol(ier)
        if (ier /= 0) then
           write(IFLOG,*) '### ERROR ### in calc_drho_sol' ; go to 99
        end if

        call calc_drho_core_sol(ier)
        if (ier /= 0) then
           write(IFLOG,*) '### ERROR ### in calc_drho_core' ; go to 99
        end if

        if (is_pcc == PCC) then
           call calc_drho_pcore_sol(ier)
           if (ier /= 0) then
              write(IFLOG,*) '### ERROR ### in calc_drho_pcore' ; go to 99
           end if
        end if

     end select
  end if
  
  call calc_vloc_ion_sol_kt(ier)
  if (ier /= 0) then
     write(IFLOG,*) '### ERROR ### in calc_vloc_ion_sol_kt' ; go to 99
  end if

99 continue
  
end subroutine calc_nonscf_sol_kt
! =============================================================================== 4.0

!=====================================================================
subroutine calc_scf_ss(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------  
  use parameters   
  implicit none

  integer,intent(out) :: ier
  integer :: loop_scf, is_conv

  ier = 0
  loop_scf = 0

  SCF: do
     loop_scf = loop_scf + 1
     engy_ss_old(:)       = engy_ss(:)
     rho_ss_old(:,:)      = rho_ss(:,:)
     vloc_scr_ss_old(:,:) = vloc_scr_ss(:,:)
     etot_ss_old          = etot_ss

     if (is_xc_class == GGA) then

        select case (is_xc)

        case (GGAPBE96_MOMO)
           call calc_drho_ddrho_ss(ier)
           if (ier /= 0) then
              write(IFLOG,*) '### ERROR ### in calc_drho_ddrho_ss' ; go to 99
           end if

        case default
           call calc_drho_ss(ier)
           if (ier /= 0) then
              write(IFLOG,*) '### ERROR ### in calc_drho_ss' ; go to 99
           end if

        end select
     end if

     call calc_vloc_scr_ss(ier)
     if (ier /= 0) then
        write(IFLOG,*) '### ERROR ### in calc_vloc_scr_ss(1)' ; go to 99
     end if

     call calc_bound_state_ss(ier)
     if (ier /= 0) then
        write(IFLOG,*) '### ERROR ### in calc_bound_state_ss' ; go to 99
     end if

     call sort_engy_ss(ier)
     if (ier /= 0) then
        write(IFLOG,*) '### ERROR ### in sort_engy_ss' ; go to 99
     end if

     call set_focc_ss(ier)
     if (ier /= 0) then
        write(IFLOG,*) '### ERROR ### in set_focc_ss' ; go to 99
     end if

     call calc_efermi_ss(ier)
     if (ier /= 0) then
        write(IFLOG,*) '### ERROR ### in calc_efermi_ss' ; go to 99
     end if

     call calc_rho_ss(ier)
     if (ier /= 0) then
        write(IFLOG,*) '### ERROR ### in calc_rho_ss' ; go to 99
     end if

     call calc_etot_ss(ier)
     if (ier /= 0) then
        write(IFLOG,*) '### ERROR ### in calc_etot_ss' ; go to 99
     end if

     call check_conv_ss(ier,is_conv,loop_scf)
     if (ier /= 0) then
        write(IFLOG,*) '### ERROR ### in check_conv_ss' ; go to 99
     end if

     if (is_conv == YES) then
        exit SCF
     end if

     call mix_rho_ss(ier)
     if (ier /= 0) then
        write(IFLOG,*) '### ERROR ### in mix_rho_ss' ; go to 99
     end if

  end do SCF

  if (is_xc_class == GGA) then

     select case (is_xc)

     case (GGAPBE96_MOMO)
        call calc_drho_ddrho_ss(ier)
        if (ier /= 0) then
           write(IFLOG,*) '### ERROR ### in calc_drho_ddrho_ss' ; go to 99
        end if

     case default
        call calc_drho_ss(ier)
        if (ier /= 0) then
           write(IFLOG,*) '### ERROR ### in calc_drho_ss' ; go to 99
        end if

     end select
  end if

  call calc_vloc_scr_ss(ier)
  
  if (ier /= 0) then
     write(IFLOG,*) '### ERROR ### in calc_vloc_scr_ss(2)' ; go to 99
  end if

99 continue

end subroutine calc_scf_ss

!================================================ added by K. T. ========== 4.0
subroutine calc_scf_ss_kt(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------  
  use parameters   
  implicit none

  integer,intent(out) :: ier
  integer :: loop_scf, is_conv

  ier = 0
  loop_scf = 0

  SCF: do
     loop_scf = loop_scf + 1
     engy_ss_old(:)       = engy_ss(:)
     rho_ss_old(:,:)      = rho_ss(:,:)
     vloc_scr_ss_old(:,:) = vloc_scr_ss(:,:)
     etot_ss_old          = etot_ss

     if (is_xc_class == GGA) then

        select case (is_xc)

        case (GGAPBE96_MOMO)
           call calc_drho_ddrho_ss(ier)
           if (ier /= 0) then
              write(IFLOG,*) '### ERROR ### in calc_drho_ddrho_ss' ; go to 99
           end if

        case default
           call calc_drho_ss(ier)
           if (ier /= 0) then
              write(IFLOG,*) '### ERROR ### in calc_drho_ss' ; go to 99
           end if

        end select
     end if

     call calc_vloc_scr_ss_kt(ier)
!!     call calc_vloc_scr_ss(ier)
     if (ier /= 0) then
        write(IFLOG,*) '### ERROR ### in calc_vloc_scr_ss_kt(1)' ; go to 99
     end if

     call calc_bound_state_ss_kt(ier)
!!     call calc_bound_state_ss(ier)
     if (ier /= 0) then
        write(IFLOG,*) '### ERROR ### in calc_bound_state_ss_kt' ; go to 99
     end if

     call sort_engy_ss(ier)
     if (ier /= 0) then
        write(IFLOG,*) '### ERROR ### in sort_engy_ss' ; go to 99
     end if

     call set_focc_ss(ier)
     if (ier /= 0) then
        write(IFLOG,*) '### ERROR ### in set_focc_ss' ; go to 99
     end if

     call calc_efermi_ss(ier)
     if (ier /= 0) then
        write(IFLOG,*) '### ERROR ### in calc_efermi_ss' ; go to 99
     end if

     call calc_rho_ss_kt(ier)
     if (ier /= 0) then
        write(IFLOG,*) '### ERROR ### in calc_rho_ss_kt' ; go to 99
     end if

     call calc_etot_ss_kt(ier)
     if (ier /= 0) then
        write(IFLOG,*) '### ERROR ### in calc_etot_ss_kt' ; go to 99
     end if

     call check_conv_ss(ier,is_conv,loop_scf)
     if (ier /= 0) then
        write(IFLOG,*) '### ERROR ### in check_conv_ss' ; go to 99
     end if

     if (is_conv == YES) then
        exit SCF
     end if

     call mix_rho_ss(ier)
     if (ier /= 0) then
        write(IFLOG,*) '### ERROR ### in mix_rho_ss' ; go to 99
     end if

  end do SCF

  if (is_xc_class == GGA) then

     select case (is_xc)

     case (GGAPBE96_MOMO)
        call calc_drho_ddrho_ss(ier)
        if (ier /= 0) then
           write(IFLOG,*) '### ERROR ### in calc_drho_ddrho_ss' ; go to 99
        end if

     case default
        call calc_drho_ss(ier)
        if (ier /= 0) then
           write(IFLOG,*) '### ERROR ### in calc_drho_ss' ; go to 99
        end if

     end select
  end if

  call calc_vloc_scr_ss_kt(ier)
  
  if (ier /= 0) then
     write(IFLOG,*) '### ERROR ### in calc_vloc_scr_ss_kt(2)' ; go to 99
  end if
99 continue

end subroutine calc_scf_ss_kt
! =============================================================================== 4.0


!=====================================================================
   subroutine check_conv_ss(ier,is_conv,loop_scf)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------  
   use parameters   
   implicit none
   integer,intent(out)   :: ier
   integer,intent(inout) :: is_conv
   integer,intent(in)    :: loop_scf
   integer :: i, iss
   real(8) :: dee_max, de, tmp
   integer,parameter :: nsave_dee_ss = 3
   real(8),parameter :: dee_conv_ss  = 1.d-7
   ier = 0
   is_conv = NO
   do i = nsave_dee_ss-1,1,-1
      dee_save(i+1) = dee_save(i)
   end do
   dee_save(1) = abs((etot_ss-etot_ss_old)/etot_ss_old)
   write(IFLOG,10) '### STOT ### etot,dee ...', &
      loop_scf, etot_ss, dee_save(1)
   dee_max = dee_save(1)
   if ((loop_scf > nsave_dee_ss).and.(nsave_dee_ss >= 2)) then
      do i = 2,nsave_dee_ss
         dee_max = max(dee_save(i),dee_max)
      end do
   end if
   de = abs(engy_ss(1)-engy_ss_old(1))
   do iss = 1,nss
      if (is_solve_ss(iss) /= 0) then
      tmp = abs(engy_ss(iss)-engy_ss_old(iss))
      de  = max(de,tmp)
      end if
   end do
   write(IFLOG,10) '#### DE #### de .........', &
      loop_scf, de
   if ((loop_scf > nsave_dee_ss).and.(dee_max < dee_conv_ss)) then
      is_conv = YES
      write(IFLOG,20) &
        'SCF calculation converged after',loop_scf,'iterations.'
      write(IFSUM,*)
      write(IFSUM,20) &
        'SCF calculation converged after',loop_scf,'iterations.'
   end if
   if (loop_scf > loop_conv) then
      write(IFLOG,30) &
       '### ERROR ### SCF loop count exceeded the limit',loop_conv,'.'
      write(IFSUM,*)
      write(IFSUM,30) &
       '### ERROR ### SCF loop count exceeded the limit',loop_conv,'.'
      ier = 1 ; go to 99
   end if
10 format(1x,a25,i7,2(1pe25.15))
20 format(1x,a31,(1x,i4,1x),a11)
30 format(1x,a47,(1x,i4),a1)
99 continue
   end subroutine check_conv_ss

!=====================================================================
   subroutine mix_rho_ss(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters   
   implicit none
   integer,intent(out) :: ier
   integer :: ispin
   ier = 0
   ispin = 1
   call adjust_rho(ier,IFLOG, &
        nmesh,rpos,wr,rho_ss(1,ispin),felec1_ss,eps_check)
   if (is_spin_ss == POLARIZED) then
      ispin = 2
      call adjust_rho(ier,IFLOG, &
           nmesh,rpos,wr,rho_ss(1,ispin),felec2_ss,eps_check)
   end if
   rho_ss(:,:) = (1.d0-mix_ss)*rho_ss_old(:,:) + mix_ss*rho_ss(:,:)
   ispin = 1
   call adjust_rho(ier,IFLOG, &
        nmesh,rpos,wr,rho_ss(1,ispin),felec1_ss,eps_check)
   if (is_spin_ss == POLARIZED) then
      ispin = 2
      call adjust_rho(ier,IFLOG, &
           nmesh,rpos,wr,rho_ss(1,ispin),felec2_ss,eps_check)
   end if
99 continue
   end subroutine mix_rho_ss
